# GPUArrays

*Reusable GPU array functionality for Julia's various GPU backends.*

| **Documentation**                                                         | **Build Status**                                                                                   | **Coverage**                    |
|:-------------------------------------------------------------------------:|:--------------------------------------------------------------------------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![][gh-img]][gh-url] [![][buildkite-img]][buildkite-url] [![PkgEval][pkgeval-img]][pkgeval-url] | [![][codecov-img]][codecov-url] |

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: http://JuliaGPU.github.io/GPUArrays.jl/stable/

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: http://JuliaGPU.github.io/GPUArrays.jl/dev/

[gitlab-img]: https://gitlab.com/JuliaGPU/GPUArrays.jl/badges/main/pipeline.svg
[gitlab-url]: https://gitlab.com/JuliaGPU/GPUArrays.jl/commits/main

[gh-img]: https://github.com/JuliaGPU/GPUArrays.jl/actions/workflows/Test.yml/badge.svg?branch=main
[gh-url]: https://github.com/JuliaGPU/GPUArrays.jl/actions/workflows/Test.yml

[buildkite-img]: https://badge.buildkite.com/05f9b27c5ce6c3906566fb66cfc42d44586e16d88a805a0b7b.svg?branch=main
[buildkite-url]: https://buildkite.com/julialang/gpuarrays-dot-jl

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/G/GPUArrays.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/G/GPUArrays.html

[codecov-img]: https://codecov.io/gh/JuliaGPU/GPUArrays.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaGPU/GPUArrays.jl

This package is the counterpart of Julia's `AbstractArray` interface, but for GPU array
types: It provides functionality and tooling to speed-up development of new GPU array types.
**This package is not intended for end users!** Instead, you should use one of the packages
that builds on GPUArrays.jl, such as [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl), [oneAPI.jl](https://github.com/JuliaGPU/oneAPI.jl), [AMDGPU.jl](https://github.com/JuliaGPU/AMDGPU.jl), or [Metal.jl](https://github.com/JuliaGPU/Metal.jl).

## Interface methods

To support a new GPU backend, you will need to implement various interface methods for your backend's array types.
Some (CPU based) examples can be see in the testing library `JLArrays` (located in the `lib` directory of this package).

### Dense array support

### Sparse array support (optional)

`GPUArrays.jl` provides **device-side** array types for `CSC`, `CSR`, `COO`, and `BSR` matrices, as well as sparse vectors.
It also provides abstract types for these layouts that you can create concrete child types of in order to benefit from the
backend-agnostic wrappers. In particular, `GPUArrays.jl` provides out-of-the-box support for broadcasting and `mapreduce` over
GPU sparse arrays.

For **host-side** types, your custom sparse types should implement:

- `dense_array_type` - the corresponding dense array type. For example, for a `CuSparseVector` or `CuSparseMatrixCXX`, the `dense_array_type` is `CuArray`
- `sparse_array_type` - the **untyped** sparse array type corresponding to a given parametrized type. A `CuSparseVector{Tv, Ti}` would have a `sparse_array_type` of `CuSparseVector` -- note the lack of type parameters!
- `csc_type(::Type{T})` - the compressed sparse column type for your backend. A `CuSparseMatrixCSR` would have a `csc_type` of `CuSparseMatrixCSC`. 
- `csr_type(::Type{T})` - the compressed sparse row type for your backend. A `CuSparseMatrixCSC` would have a `csr_type` of `CuSparseMatrixCSR`. 
- `coo_type(::Type{T})` - the coordinate sparse matrix type for your backend. A `CuSparseMatrixCSC` would have a `coo_type` of `CuSparseMatrixCOO`.

To use `SparseArrays.findnz`, your host-side type **must** implement `sortperm`. This can be done with scalar indexing, but will be very slow.

Additionally, you need to teach `GPUArrays.jl` how to translate your backend's specific types onto the device. `GPUArrays.jl` provides the device-side types:

- `GPUSparseDeviceVector`
- `GPUSparseDeviceMatrixCSC`
- `GPUSparseDeviceMatrixCSR`
- `GPUSparseDeviceMatrixBSR`
- `GPUSparseDeviceMatrixCOO`

You will need to create a method of `Adapt.adapt_structure` for each format your backend supports. **Note** that if your backend supports separate address spaces,
as CUDA and ROCm do, you need to provide a parameter to these device-side arrays to indicate in which address space the underlying pointers live. An example of adapting
an array to the device-side struct:

```julia
function GPUArrays.GPUSparseDeviceVector(iPtr::MyDeviceVector{Ti, A},
                                         nzVal::MyDeviceVector{Tv, A},
                                         len::Int,
                                         nnz::Ti) where {Ti, Tv, A}
    GPUArrays.GPUSparseDeviceVector{Tv, Ti, MyDeviceVector{Ti, A}, MyDeviceVector{Tv, A}, A}(iPtr, nzVal, len, nnz)
end

function Adapt.adapt_structure(to::MyAdaptor, x::MySparseVector)
    return GPUArrays.GPUSparseDeviceVector(
        adapt(to, x.iPtr),
        adapt(to, x.nzVal),
        length(x), x.nnz
    )
end
```

You'll also need to inform `GPUArrays.jl` and `GPUCompiler.jl` how to adapt your sparse arrays by extending `KernelAbstractions.jl`'s `get_backend()`:

```julia
KA.get_backend(::MySparseVector) = MyBackend()
```  

@testsuite "alloc cache" (AT, eltypes) -> begin
    if AT <: AbstractGPUArray
        cache = GPUArrays.AllocCache()

        # first allocation populates the cache
        T, dims = Float32, (1, 2, 3)
        GPUArrays.@cached cache begin
            cached1 = AT(zeros(T, dims))
        end
        @test sizeof(cache) == sizeof(cached1)
        key = first(keys(cache.free))
        @test length(cache.free[key]) == 1
        @test length(cache.busy[key]) == 0
        @test cache.free[key][1] === GPUArrays.storage(cached1)

        # second allocation hits the cache
        GPUArrays.@cached cache begin
            cached2 = AT(zeros(T, dims))

            # explicitly uncached ones don't
            GPUArrays.@uncached uncached = AT(zeros(T, dims))
        end
        @test sizeof(cache) == sizeof(cached2)
        key = first(keys(cache.free))
        @test length(cache.free[key]) == 1
        @test length(cache.busy[key]) == 0
        @test cache.free[key][1] === GPUArrays.storage(cached2)
        @test uncached !== cached2

        # compatible shapes should also hit the cache
        dims = (3, 2, 1)
        GPUArrays.@cached cache begin
            cached3 = AT(zeros(T, dims))
        end
        @test sizeof(cache) == sizeof(cached3)
        key = first(keys(cache.free))
        @test length(cache.free[key]) == 1
        @test length(cache.busy[key]) == 0
        @test cache.free[key][1] === GPUArrays.storage(cached3)

        # as should compatible eltypes
        T = Int32
        GPUArrays.@cached cache begin
            cached4 = AT(zeros(T, dims))
        end
        @test sizeof(cache) == sizeof(cached4)
        key = first(keys(cache.free))
        @test length(cache.free[key]) == 1
        @test length(cache.busy[key]) == 0
        @test cache.free[key][1] === GPUArrays.storage(cached4)

        # different shapes should trigger a new allocation
        dims = (2, 2)
        GPUArrays.@cached cache begin
            cached5 = AT(zeros(T, dims))

            # we're allowed to early free arrays, which should be a no-op for cached data
            GPUArrays.unsafe_free!(cached5)
        end
        @test sizeof(cache) == sizeof(cached4) + sizeof(cached5)
        _keys = collect(keys(cache.free))
        key2 = _keys[findfirst(i -> i != key, _keys)]
        @test length(cache.free[key]) == 1
        @test length(cache.free[key2]) == 1
        @test cache.free[key2][1] === GPUArrays.storage(cached5)

        # we should be able to re-use the early-freed
        GPUArrays.@cached cache begin
            cached5 = AT(zeros(T, dims))
        end

        # exceptions shouldn't cause issues
        @test_throws "Allowed exception" GPUArrays.@cached cache begin
            AT(zeros(T, dims))
            error("Allowed exception")
        end
        # NOTE: this should remaint the last test before calling `unsafe_free!` below,
        #       as it caught an erroneous assertion in the original code.

        # freeing all memory held by cache should free all allocations
        @test !GPUArrays.storage(cached1).freed
        @test GPUArrays.storage(cached1).cached
        @test !GPUArrays.storage(cached5).freed
        @test GPUArrays.storage(cached5).cached
        @test !GPUArrays.storage(uncached).freed
        @test !GPUArrays.storage(uncached).cached
        GPUArrays.unsafe_free!(cache)
        @test sizeof(cache) == 0
        @test GPUArrays.storage(cached1).freed
        @test !GPUArrays.storage(cached1).cached
        @test GPUArrays.storage(cached5).freed
        @test !GPUArrays.storage(cached5).cached
        @test !GPUArrays.storage(uncached).freed
        ## test that the underlying data was freed as well
        @test GPUArrays.storage(cached1).rc.count[] == 0
        @test GPUArrays.storage(cached5).rc.count[] == 0
        @test GPUArrays.storage(uncached).rc.count[] == 1
    end
end

# integration with LinearAlgebra stdlib

using LinearAlgebra: MulAddMul, wrap, diagm, BlasReal, AbstractTriangular

## transpose and adjoint

function LinearAlgebra.transpose!(B::AbstractGPUVector, A::AbstractGPUMatrix)
    axes(B,1) == axes(A,2) && axes(A,1) == 1:1 || throw(DimensionMismatch("transpose"))
    copyto!(B, A)
end
function LinearAlgebra.transpose!(B::AbstractGPUMatrix, A::AbstractGPUVector)
    axes(B,2) == axes(A,1) && axes(B,1) == 1:1 || throw(DimensionMismatch("transpose"))
    copyto!(B, A)
end
function LinearAlgebra.adjoint!(B::AbstractGPUVector, A::AbstractGPUMatrix)
    axes(B,1) == axes(A,2) && axes(A,1) == 1:1 || throw(DimensionMismatch("adjoint"))
    isempty(A) && return B
    @kernel function adjoint_kernel!(B, A)
        idx = @index(Global, Linear)
        @inbounds B[idx] = adjoint(A[1, idx])
    end
    adjoint_kernel!(get_backend(B))(B, A; ndrange = size(B))
    B
end
function LinearAlgebra.adjoint!(B::AbstractGPUMatrix, A::AbstractGPUVector)
    axes(B,2) == axes(A,1) && axes(B,1) == 1:1 || throw(DimensionMismatch("adjoint"))
    isempty(A) && return B
    @kernel function adjoint_kernel!(B, A)
        idx = @index(Global, Linear)
        @inbounds B[1, idx] = adjoint(A[idx])
    end
    adjoint_kernel!(get_backend(A))(B, A; ndrange = size(A))
    B
end

LinearAlgebra.transpose!(B::AnyGPUArray, A::AnyGPUArray) = transpose_f!(transpose, B, A)
LinearAlgebra.adjoint!(B::AnyGPUArray, A::AnyGPUArray) = transpose_f!(adjoint, B, A)
function transpose_f!(f, B::AnyGPUMatrix{T}, A::AnyGPUMatrix{T}) where T
    axes(B,1) == axes(A,2) && axes(B,2) == axes(A,1) || throw(DimensionMismatch(string(f)))
    # array with size zero dimension
    isempty(A) && return B
    @kernel function transpose_kernel!(B, A)
        idx = @index(Global, Cartesian)
        @inbounds B[idx[2], idx[1]] = f(A[idx[1], idx[2]])
    end
    transpose_kernel!(get_backend(B))(B, A; ndrange = size(A))
    B
end

function Base.copyto!(A::AbstractGPUArray{T,N}, B::Adjoint{T, <: AbstractGPUArray{T,N}}) where {T,N}
    adjoint!(A, B.parent)
end

function Base.copyto!(A::AbstractGPUArray{T,N}, B::Transpose{T, <: AbstractGPUArray{T,N}}) where {T,N}
    transpose!(A, B.parent)
end

function Base.copyto!(A::Array{T,N}, B::Adjoint{T, <:AbstractGPUArray{T,N}}) where {T,N}
    copyto!(A, Adjoint(Array(parent(B))))
end
function Base.copyto!(A::Array{T,N}, B::Transpose{T, <:AbstractGPUArray{T,N}}) where {T,N}
    copyto!(A, Transpose(Array(parent(B))))
end

## diagm

LinearAlgebra.diagm(kv::Pair{<:Integer,<:AbstractGPUVector}...) = _gpu_diagm(nothing, kv...)
LinearAlgebra.diagm(m::Integer, n::Integer, kv::Pair{<:Integer,<:AbstractGPUVector}...) = _gpu_diagm((Int(m),Int(n)), kv...)
LinearAlgebra.diagm(v::AbstractGPUVector) = LinearAlgebra.diagm(0 => v)
LinearAlgebra.diagm(m::Integer, n::Integer, v::AbstractGPUVector) = LinearAlgebra.diagm(m, n, 0 => v)

function _gpu_diagm(size, kv::Pair{<:Integer,<:AbstractGPUVector}...)
    A = LinearAlgebra.diagm_container(size, kv...)
    for p in kv
        inds = LinearAlgebra.diagind(A, p.first)
        copyto!(view(A, inds), p.second)
    end
    return A
end

function LinearAlgebra.diagm_container(size, kv::Pair{<:Integer,<:AbstractGPUVector}...)
    T = promote_type(map(x -> eltype(x.second), kv)...)
    U = promote_type(T, typeof(zero(T)))
    A = similar(kv[1].second, U, LinearAlgebra.diagm_size(size, kv...)...)
    fill!(A, zero(U))
    return A
end

function LinearAlgebra.diagm_size(size::Nothing, kv::Pair{<:Integer,<:AbstractGPUVector}...)
    mnmax = mapreduce(x -> length(x.second) + abs(Int(x.first)), max, kv; init=0)
    return mnmax, mnmax
end
function LinearAlgebra.diagm_size(size::Tuple{Int,Int}, kv::Pair{<:Integer,<:AbstractGPUVector}...)
    mmax = mapreduce(x -> length(x.second) - min(0,Int(x.first)), max, kv; init=0)
    nmax = mapreduce(x -> length(x.second) + max(0,Int(x.first)), max, kv; init=0)
    m, n = size
    (m ≥ mmax && n ≥ nmax) || throw(DimensionMismatch(lazy"invalid size=$size"))
    return m, n
end

## trace

function LinearAlgebra.tr(A::AnyGPUMatrix)
    LinearAlgebra.checksquare(A)
    sum(diag(A))
end

## copy upper triangle to lower and vice versa

function LinearAlgebra.copytri!(A::AbstractGPUMatrix, uplo::AbstractChar, conjugate::Bool = false, diag::Bool = false)
    n = LinearAlgebra.checksquare(A)
    if uplo == 'U' && conjugate
        @kernel function U_conj!(_A)
            I = @index(Global, Cartesian)
            i, j = Tuple(I)
            if j + diag > i
                @inbounds _A[j,i] = conj(_A[i,j])
          end
        end
        U_conj!(get_backend(A))(A; ndrange = size(A))
    elseif uplo == 'U' && !conjugate
        @kernel function U_noconj!(_A)
            I = @index(Global, Cartesian)
            i, j = Tuple(I)
            if j + diag > i
                @inbounds _A[j,i] = _A[i,j]
          end
        end
        U_noconj!(get_backend(A))(A; ndrange = size(A))
    elseif uplo == 'L' && conjugate
        @kernel function L_conj!(_A)
            I = @index(Global, Cartesian)
            i, j = Tuple(I)
            if j + diag > i
                @inbounds _A[i,j] = conj(_A[j,i])
            end
        end
        L_conj!(get_backend(A))(A; ndrange = size(A))
    elseif uplo == 'L' && !conjugate
        @kernel function L_noconj!(_A)
            I = @index(Global, Cartesian)
            i, j = Tuple(I)
            if j + diag > i
                @inbounds _A[i,j] = _A[j,i]
            end
        end
        L_noconj!(get_backend(A))(A; ndrange = size(A))
    else
        throw(ArgumentError("uplo argument must be 'U' (upper) or 'L' (lower), got $uplo"))
    end
    A
end

## copy a triangular part of a matrix to another matrix

if isdefined(LinearAlgebra, :copytrito!)
    function LinearAlgebra.copytrito!(B::AbstractGPUMatrix{T}, A::AbstractGPUMatrix{T}, uplo::AbstractChar) where {T}
        LinearAlgebra.BLAS.chkuplo(uplo)
        m,n = size(A)
        m1,n1 = size(B)
        if uplo == 'U'
            if n < m
                (m1 < n || n1 < n) && throw(DimensionMismatch("B of size ($m1,$n1) should have at least size ($n,$n)"))
            else
                (m1 < m || n1 < n) && throw(DimensionMismatch("B of size ($m1,$n1) should have at least size ($m,$n)"))
            end
            length(A) == 0 && return B
            @kernel function U_kernel!(_A, _B)
                I = @index(Global, Cartesian)
                i, j = Tuple(I)
                if j >= i
                    @inbounds _B[i,j] = _A[i,j]
                end
            end
            U_kernel!(get_backend(B))(A, B; ndrange = size(A))
        else  # uplo == 'L'
            if m < n
                (m1 < m || n1 < m) && throw(DimensionMismatch("B of size ($m1,$n1) should have at least size ($m,$m)"))
            else
                (m1 < m || n1 < n) && throw(DimensionMismatch("B of size ($m1,$n1) should have at least size ($m,$n)"))
            end
            length(A) == 0 && return B
            @kernel function L_kernel!(_A, _B)
                I = @index(Global, Cartesian)
                i, j = Tuple(I)
                if j <= i
                    @inbounds _B[i,j] = _A[i,j]
                end
            end
            L_kernel!(get_backend(A))(A, B; ndrange = size(A))
        end
        return B
    end
end

## triangular

# mixed CPU/GPU: B -> A
Base.copyto!(A::Array{T,N}, B::UpperTriangular{T, <:AbstractGPUArray{T,N}}) where {T,N} = copyto!(A, UpperTriangular(Array(parent(B))))
Base.copyto!(A::Array{T,N}, B::LowerTriangular{T, <:AbstractGPUArray{T,N}}) where {T,N} = copyto!(A, LowerTriangular(Array(parent(B))))

# GPU/GPU: B -> A
Base.copyto!(A::AbstractGPUArray{T,N}, B::UpperTriangular{T, <:AbstractGPUArray{T,N}}) where {T,N} = LinearAlgebra.triu!(copyto!(A, parent(B)))
Base.copyto!(A::AbstractGPUArray{T,N}, B::LowerTriangular{T, <:AbstractGPUArray{T,N}}) where {T,N} = LinearAlgebra.tril!(copyto!(A, parent(B)))
for T in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular)
    @eval Base.copyto!(A::$T{T, <:AbstractGPUArray{T,N}}, B::$T{T, <:AbstractGPUArray{T,N}}) where {T,N} = $T(copyto!(parent(A), parent(B)))
end

function LinearAlgebra.tril!(A::AbstractGPUMatrix{T}, d::Integer = 0) where T
    isempty(A) && return A
    @kernel function tril_kernel!(_A, _d)
        I = @index(Global, Cartesian)
        i, j = Tuple(I)
        if i < j - _d
            @inbounds _A[i, j] = zero(T)
        end
    end
    tril_kernel!(get_backend(A))(A, d; ndrange = size(A))
    return A
end

function LinearAlgebra.triu!(A::AbstractGPUMatrix{T}, d::Integer = 0) where T
    isempty(A) && return A
    @kernel function triu_kernel!(_A, _d)
        I = @index(Global, Cartesian)
        i, j = Tuple(I)
        if j < i + _d
            @inbounds _A[i, j] = zero(T)
        end
    end
    triu_kernel!(get_backend(A))(A, d; ndrange = size(A))
    return A
end

# check if upper triangular starting from the kth superdiagonal.
function LinearAlgebra.istriu(A::AbstractGPUMatrix, k::Integer = 0)
    function mapper(a, I)
        row, col = Tuple(I)
        if col < row + k
            return iszero(a)
        else
            true
        end
    end
    function reducer(a, b)
        a && b
    end
    mapreduce(mapper, reducer, A, eachindex(IndexCartesian(), A); init=true)
end

# check if lower triangular starting from the kth subdiagonal.
function LinearAlgebra.istril(A::AbstractGPUMatrix, k::Integer = 0)
    function mapper(a, I)
        row, col = Tuple(I)
        if col > row + k
            return iszero(a)
        else
            true
        end
    end
    function reducer(a, b)
        a && b
    end
    mapreduce(mapper, reducer, A, eachindex(IndexCartesian(), A); init=true)
end

# istriu/istril of triangular wrappers of the opposite triangularity: the generic
# fallbacks in LinearAlgebra scan the wrapper element-by-element, which requires scalar
# indexing. forwarding to the parent ends up in the mapreduce-based methods above, also
# for lazily wrapped parents (via LinearAlgebra's Adjoint/Transpose forwards). needed by
# e.g. 2-arg ldiv!/rdiv! on Julia 1.11.2+, which consult istriu/istril to select the
# solver; LinearAlgebra provides equivalent methods on Julia 1.13+
# (JuliaLang/LinearAlgebra.jl#1265), making these redundant there.
@static if VERSION < v"1.13.0-"
LinearAlgebra.istriu(A::LowerTriangular{<:Any, <:AnyGPUMatrix}, k::Integer = 0) =
    istriu(parent(A), min(k, 1))
LinearAlgebra.istriu(A::UnitLowerTriangular{<:Any, <:AnyGPUMatrix}, k::Integer = 0) =
    k <= 0 && istriu(parent(A), k)
LinearAlgebra.istril(A::UpperTriangular{<:Any, <:AnyGPUMatrix}, k::Integer = 0) =
    istril(parent(A), max(k, -1))
LinearAlgebra.istril(A::UnitUpperTriangular{<:Any, <:AnyGPUMatrix}, k::Integer = 0) =
    k >= 0 && istril(parent(A), k)
end

## uniformscaling

function LinearAlgebra.mul!(out::AnyGPUMatrix{T}, a::Number, B::LinearAlgebra.UniformScaling, α::Number, β::Number) where {T}
    LinearAlgebra.checksquare(out)
    if iszero(β)
        fill!(out, zero(T))
    elseif !isone(β)
        rmul!(out, β)
    end
    s = convert(T, a*B.λ*α)
    if !iszero(s)
        view(out, diagind(out)) .+= s
    end
    return out
end

@static if VERSION >= v"1.12.0-rc"
    import LinearAlgebra: _lscale_add!
    function LinearAlgebra._lscale_add!(C::AnyGPUMatrix, s::Number, X::AnyGPUMatrix, alpha::Number, beta::Number)
        if axes(C) == axes(X)
            if isone(alpha)
                if iszero(beta)
                    @. C = s * X
                else
                    @. C = s * X + C * beta
                end
            else
                if iszero(beta)
                    @. C = s * X * alpha
                else
                    @. C = s * X * alpha + C * beta
                end
            end
        else
            generic_mul!(C, s, X, alpha, beta)
        end
        return C
    end
end

## diagonal

Base.copy(D::Diagonal{T, <:AbstractGPUArray{T, N}}) where {T, N} = Diagonal(copy(D.diag))

_isrealandpositive(x) = isreal(x) && real(x) > 0

function LinearAlgebra.cholesky!(D::Diagonal{<:Any, <:AbstractGPUArray},
                                ::NoPivot = NoPivot(); check::Bool = true)
    info = findfirst(!_isrealandpositive, D.diag)
    if isnothing(info)
        D.diag .= sqrt.(D.diag)
        info = 0
    elseif check
        throw(PosDefException(info))
    else
        D.diag[begin:info-1] .= sqrt.(D.diag[begin:info-1])
    end
    return Cholesky(D, 'U', convert(LinearAlgebra.BlasInt, info))
end

function Base.:\(D::Diagonal{<:Any, <:AbstractGPUArray}, B::AbstractGPUVecOrMat)
    z = D.diag .== 0
    if any(z)
        i = findfirst(collect(z))
        throw(SingularException(i))
    else
        return D.diag .\ B
    end
end
function LinearAlgebra.mul!(C::AbstractGPUArray,
                            A::Diagonal{<:Any, <:AbstractGPUArray},
                            B::Diagonal{<:Any, <:AbstractGPUArray})
    C .= zero(eltype(C))
    dc = view(C, LinearAlgebra.diagind(C))
    da = A.diag
    db = B.diag
    d = length(dc)
    length(da) == d || throw(DimensionMismatch("right hand side has $(length(da)) rows but output is $d by $d"))
    length(db) == d || throw(DimensionMismatch("left hand side has $(length(db)) rows but output is $d by $d"))
    @. dc = da * db
    return C
end

function LinearAlgebra.mul!(C::AbstractGPUArray,
                            A::Diagonal{<:Any, <:AbstractGPUArray},
                            B::Diagonal{<:Any, <:AbstractGPUArray},
                            α::Number,
                            β::Number)
    dc = view(C, LinearAlgebra.diagind(C))
    da = A.diag
    db = B.diag
    d = length(dc)
    length(da) == d || throw(DimensionMismatch("right hand side has $(length(da)) rows but output is $d by $d"))
    length(db) == d || throw(DimensionMismatch("left hand side has $(length(db)) rows but output is $d by $d"))
    # C may be uninitialized, so a `β` that is zero has to fill rather than scale
    iszero(β) ? fill!(C, zero(eltype(C))) : rmul!(C, β)
    @. dc += α * da * db
    return C
end
function LinearAlgebra.mul!(C::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Diagonal{<:Any, <:AbstractGPUArray},
                            B::Diagonal{<:Any, <:AbstractGPUArray})
    dc = C.diag
    da = A.diag
    db = B.diag
    d = length(dc)
    length(da) == d || throw(DimensionMismatch("right hand side has $(length(da)) rows but output is $d by $d"))
    length(db) == d || throw(DimensionMismatch("left hand side has $(length(db)) rows but output is $d by $d"))
    @. dc = da * db

    return C
end

function LinearAlgebra.mul!(C::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Diagonal{<:Any, <:AbstractGPUArray},
                            B::Diagonal{<:Any, <:AbstractGPUArray},
                            α::Number,
                            β::Number)
    dc = C.diag
    da = A.diag
    db = B.diag
    d = length(dc)
    length(da) == d || throw(DimensionMismatch("right hand side has $(length(da)) rows but output is $d by $d"))
    length(db) == d || throw(DimensionMismatch("left hand side has $(length(db)) rows but output is $d by $d"))
    @. dc = α * da * db + β * dc

    return C
end
function LinearAlgebra.mul!(C::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            B::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}}) where {T}
    dc = C.diag
    d  = length(dc)
    m, n   = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    m == d  || throw(DimensionMismatch("left hand side has $m rows but output is $d by $d"))
    n′ == d || throw(DimensionMismatch("right hand side has $n′ cols but output is $d by $d"))
    C_ = A * B
    isdiag(C_) || throw(ErrorException("output matrix must be diagonal"))
    dc .= diag(C_)
    return C
end

function LinearAlgebra.mul!(C::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            B::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            α::Number,
                            β::Number) where {T}
    dc = C.diag
    d  = length(dc)
    m, n   = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    m == d  || throw(DimensionMismatch("left hand side has $m rows but output is $d by $d"))
    n′ == d || throw(DimensionMismatch("right hand side has $n′ cols but output is $d by $d"))
    C_ = @. α * A * B + β * C
    isdiag(C_) || throw(ErrorException("output matrix must be diagonal"))
    dc .= diag(C_)
    return C
end

function LinearAlgebra.mul!(B::AbstractGPUVecOrMat,
                            D::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}}) where {T}
    dd = D.diag
    d = length(dd)
    m, n = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    m == d || throw(DimensionMismatch("right hand side has $m rows but D is $d by $d"))
    (m, n) == (m′, n′) || throw(DimensionMismatch("expect output to be $m by $n, but got $m′ by $n′"))
    @. B = dd * A
    B
end

function LinearAlgebra.mul!(B::AbstractGPUVecOrMat,
                            D::Diagonal{<:Any, <:AbstractGPUArray},
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            α::Number,
                            β::Number) where {T}
    dd = D.diag
    d = length(dd)
    m, n = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    m == d || throw(DimensionMismatch("right hand side has $m rows but D is $d by $d"))
    (m, n) == (m′, n′) || throw(DimensionMismatch("expect output to be $m by $n, but got $m′ by $n′"))
    @. B = α * dd * A + β * B

    B
end

function LinearAlgebra.mul!(B::AbstractGPUVecOrMat,
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            D::Diagonal{<:Any, <:AbstractGPUArray}) where {T}
    dd = D.diag
    d = length(dd)
    m, n = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    n == d || throw(DimensionMismatch("left hand side has $n columns but D is $d by $d"))
    (m, n) == (m′, n′) || throw(DimensionMismatch("expect output to be $m by $n, but got $m′ by $n′"))
    ddT = transpose(dd)
    @. B = A * ddT

    B
end

function LinearAlgebra.mul!(B::AbstractGPUVecOrMat,
                            A::Union{AbstractGPUArray, Adjoint{T,<:AbstractGPUArray{T}}, Transpose{T,<:AbstractGPUArray{T}}},
                            D::Diagonal{<:Any, <:AbstractGPUArray},
                            α::Number,
                            β::Number) where {T}
    dd = D.diag
    d = length(dd)
    m, n = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    n == d || throw(DimensionMismatch("left hand side has $n columns but D is $d by $d"))
    (m, n) == (m′, n′) || throw(DimensionMismatch("expect output to be $m by $n, but got $m′ by $n′"))
    ddT = transpose(dd)
    @. B = α * A * ddT + β * B

    B
end

function LinearAlgebra.ldiv!(B::AbstractGPUVecOrMat,
                              D::Diagonal{<:Any, <:AbstractGPUArray},
                              A::AbstractGPUVecOrMat)
    dd = D.diag
    d = length(dd)
    m, n = size(A, 1), size(A, 2)
    m′, n′ = size(B, 1), size(B, 2)
    m == d || throw(DimensionMismatch("right hand side has $m rows but D is $d by $d"))
    (m, n) == (m′, n′) || throw(DimensionMismatch("expect output to be $m by $n, but got $m′ by $n′"))
    z = dd .== 0
    if any(z)
        i = findfirst(collect(z))
        throw(SingularException(i))
    else
        B .= dd .\ A
    end
    B
end


## matrix multiplication

# GPU-backed members of Base's StridedArray union match LinearAlgebra's BLAS methods,
# but cannot be converted to host pointers. Route them to the generic GPU kernels.
const StridedGPUSubArray{T,N} = Base.StridedSubArray{T,N,<:AbstractGPUArray}
const AnyStridedGPUArray{T,N} = Union{AbstractGPUArray{T,N},StridedGPUSubArray{T,N}}
const AnyStridedGPUVector{T} = AnyStridedGPUArray{T,1}
const AnyStridedGPUMatrix{T} = AnyStridedGPUArray{T,2}
const AnyStridedGPUVecOrMat{T} = Union{AnyStridedGPUVector{T},AnyStridedGPUMatrix{T}}
const AnyStridedGPUMatrixOperand{T} = Union{
    AnyStridedGPUMatrix{T},
    Adjoint{T,<:AnyStridedGPUMatrix{T}},
    Transpose{T,<:AnyStridedGPUMatrix{T}},
    Symmetric{T,<:AnyStridedGPUMatrix{T}},
    Hermitian{T,<:AnyStridedGPUMatrix{T}},
}
const AnyStridedGPUVecOrMatOperand{T} = Union{
    AnyStridedGPUVector{T},
    AnyStridedGPUMatrixOperand{T},
}

has_strided_gpu_view(As...) =
    any(A -> LinearAlgebra._unwrap(A) isa StridedGPUSubArray, As)

# Intercept before LinearAlgebra unwraps operands and dispatches to backend BLAS methods. The
# signatures also cover view-free products to avoid overlapping methods for each possible view
# position; those calls are sent back through LinearAlgebra's original implementation.
@static if VERSION < v"1.11"
function LinearAlgebra.mul!(C::AnyStridedGPUVector, A::AnyStridedGPUMatrixOperand,
                            B::AnyStridedGPUVector, a::Number, b::Number)
    if has_strided_gpu_view(C, A, B)
        return generic_matmatmul!(C, A, B, a, b)
    end
    invoke(LinearAlgebra.mul!,
           Tuple{AbstractVector,LinearAlgebra.AbstractVecOrMat,AbstractVector,Number,Number},
           C, A, B, a, b)
end

function LinearAlgebra.mul!(C::AnyStridedGPUMatrix, A::AnyStridedGPUVecOrMatOperand,
                            B::AnyStridedGPUVecOrMatOperand, a::Number, b::Number)
    if has_strided_gpu_view(C, A, B)
        return generic_matmatmul!(C, A, B, a, b)
    end
    invoke(LinearAlgebra.mul!,
           Tuple{AbstractMatrix,LinearAlgebra.AbstractVecOrMat,
                 LinearAlgebra.AbstractVecOrMat,Number,Number},
           C, A, B, a, b)
end
else
function LinearAlgebra._mul!(C::AnyStridedGPUVector, A::AnyStridedGPUMatrixOperand,
                             B::AnyStridedGPUVector, a::Number, b::Number)
    if has_strided_gpu_view(C, A, B)
        return generic_matmatmul!(C, A, B, a, b)
    end
    invoke(LinearAlgebra._mul!,
           Tuple{AbstractVector,LinearAlgebra.AbstractVecOrMat,AbstractVector,Number,Number},
           C, A, B, a, b)
end

function LinearAlgebra._mul!(C::AnyStridedGPUMatrix, A::AnyStridedGPUVecOrMatOperand,
                             B::AnyStridedGPUVecOrMatOperand, a::Number, b::Number)
    if has_strided_gpu_view(C, A, B)
        return generic_matmatmul!(C, A, B, a, b)
    end
    invoke(LinearAlgebra._mul!,
           Tuple{AbstractMatrix,LinearAlgebra.AbstractVecOrMat,
                 LinearAlgebra.AbstractVecOrMat,Number,Number},
           C, A, B, a, b)
end
end

# legacy method
generic_matmatmul!(C::AbstractArray, A::AbstractArray, B::AbstractArray, a::Number, b::Number) =
    generic_matmatmul!(C, A, B, MulAddMul(a, b))
function generic_matmatmul!(C::AbstractArray{R}, A::AbstractArray{T}, B::AbstractArray{S}, add::MulAddMul) where {T,S,R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch("matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))"))
    end
    if size(C,1) != size(A,1) || size(C,2) != size(B,2)
        throw(DimensionMismatch("result C has dimensions $(size(C)), needs $((size(A,1),size(B,2)))"))
    end
    if isempty(A) || isempty(B)
        return fill!(C, zero(R))
    end

    @kernel function matmatmul_kernel!(C, A, B)
        assume.(size(C) .> 0)
        idx = @index(Global, Linear)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1

        @inbounds if i <= size(A,1) && j <= size(B,2)
            z2 = zero(A[i, 1]*B[1, j] + A[i, 1]*B[1, j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            for k in 1:size(A,2)
                Cij = muladd(A[i, k], B[k, j], Cij)
            end
            C[i,j] = add(Cij, C[i,j])
        end
    end
    matmatmul_kernel!(get_backend(C))(C, A, B; ndrange = size(C))
    C
end

@static if !isdefined(LinearAlgebra, Symbol("@stable_muladdmul")) # @stable_muladdmul was added in 1.12
function LinearAlgebra.generic_matvecmul!(C::AnyStridedGPUVector, tA::AbstractChar, A::AnyStridedGPUMatrix, B::AnyStridedGPUVector, _add::MulAddMul = MulAddMul())
    generic_matmatmul!(C, wrap(A, tA), B, _add)
end

function LinearAlgebra.generic_matmatmul!(C::AnyStridedGPUVecOrMat, tA, tB, A::AnyStridedGPUVecOrMat, B::AnyStridedGPUVecOrMat, _add::MulAddMul=MulAddMul())
    generic_matmatmul!(C, wrap(A, tA), wrap(B, tB), _add)
end
else
function LinearAlgebra.generic_matvecmul!(C::AnyStridedGPUVector, tA::AbstractChar, A::AnyStridedGPUMatrix, B::AnyStridedGPUVector, a::Number, b::Number)
    LinearAlgebra.@stable_muladdmul generic_matmatmul!(C, wrap(A, tA), B, MulAddMul(a, b))
end

function LinearAlgebra.generic_matmatmul!(C::AnyStridedGPUVecOrMat, tA, tB, A::AnyStridedGPUVecOrMat, B::AnyStridedGPUVecOrMat, a::Number, b::Number)
    LinearAlgebra.@stable_muladdmul generic_matmatmul!(C, wrap(A, tA), wrap(B, tB), MulAddMul(a, b))
end
end

# triangular × triangular matmul: C = α·(A·B) + β·C, with both A and B triangular.
# Shared by the version-specific LinearAlgebra entry points below, which differ only in how
# α/β arrive (raw scalars on ≥1.12, a MulAddMul on older). The wrapper type — not the data —
# fixes which triangle holds the nonzeros, so we read it with a plain `isa` check.
function _triangular_matmatmul!(C::AbstractGPUVecOrMat{R}, A::AbstractTriangular, B::AbstractTriangular, alpha::Number, beta::Number) where {R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch(lazy"matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))"))
    end
    if size(C,1) != size(A,1) || size(C,2) != size(B,2)
        throw(DimensionMismatch(lazy"result C has dimensions $(size(C)), needs $((size(A,1),size(B,2)))"))
    end
    if isempty(A) || isempty(B)
        return fill!(C, zero(R))
    end
    upperA = A isa Union{UnitUpperTriangular, UpperTriangular}
    @kernel function trimatmul(C, A, B, alpha, beta)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i, 1]*B[1, j] + A[i, 1]*B[1, j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(A[i,i], B[i,j], Cij)
            for k in (upperA ? (i + 1) : 1):(upperA ? m : (i - 1))
                Cij = muladd(A[i,k], B[k,j], Cij)
            end
            # treat C as write-only when beta is zero (it may hold NaN/Inf)
            C[i,j] = iszero(beta) ? alpha * Cij : alpha * Cij + beta * C[i,j]
        end
    end
    trimatmul(get_backend(C))(C, A, B, alpha, beta; ndrange = length(C))
    return C
end

@static if VERSION ≥ v"1.12.0-rc"
    # we need to use the generic wrapper to avoid dispatch to the 2x2or3x3 method
    using LinearAlgebra: generic_matmatmul_wrapper!, BlasFlag
    function LinearAlgebra.generic_matmatmul_wrapper!(C::AnyStridedGPUMatrix{T}, tA::AbstractChar, tB::AbstractChar, A::AnyStridedGPUVecOrMat{T}, B::AnyStridedGPUVecOrMat{T}, alpha::Number, beta::Number, val::LinearAlgebra.BlasFlag.SyrkHerkGemm) where {T}
        LinearAlgebra.generic_matmatmul!(C, tA, tB, A, B, alpha, beta)
    end
    # Symmetric/Hermitian inputs with BLAS eltypes would otherwise dispatch to BLAS.symm!/
    # hemm!: GPU arrays are DenseArrays, so they match the StridedMatrix{<:BlasFloat} methods
    function LinearAlgebra.generic_matmatmul_wrapper!(C::AnyStridedGPUMatrix{T}, tA::AbstractChar, tB::AbstractChar, A::AnyStridedGPUVecOrMat{T}, B::AnyStridedGPUVecOrMat{T}, alpha::Number, beta::Number, val::LinearAlgebra.BlasFlag.SymmHemmGeneric) where {T}
        LinearAlgebra.generic_matmatmul!(C, tA, tB, A, B, alpha, beta)
    end
    # need to support mixed complex/real types too
    #function LinearAlgebra.generic_matmatmul_wrapper!(C::AbstractGPUMatrix{Complex{T}}, tA::AbstractChar, tB::AbstractChar, A::AbstractGPUVecOrMat{Complex{T}}, B::AbstractGPUVecOrMat{T}, alpha::Number, beta::Number, val::V) where {T<:BlasReal, V<:LinearAlgebra.BlasFlag.SyrkHerkGemm}
    #    LinearAlgebra.generic_matmatmul!(C, tA, tB, A, B, alpha, beta)
    #end
    function LinearAlgebra.generic_matmatmul_wrapper!(C::AnyStridedGPUMatrix{Complex{T}}, tA::AbstractChar, tB::AbstractChar, A::AnyStridedGPUVecOrMat{Complex{T}}, B::AnyStridedGPUVecOrMat{T}, alpha::Number, beta::Number, val::Val{LinearAlgebra.BlasFlag.GEMM}) where T<:Union{Float32, Float64}
        LinearAlgebra.generic_matmatmul!(C, tA, tB, A, B, alpha, beta)
    end
    function LinearAlgebra.generic_matmatmul_wrapper!(C::AnyStridedGPUMatrix{Complex{T}}, tA::AbstractChar, tB::AbstractChar, A::AnyStridedGPUVecOrMat{T}, B::AnyStridedGPUVecOrMat{Complex{T}}, alpha::Number, beta::Number, val::Val{LinearAlgebra.BlasFlag.GEMM}) where T<:Union{Float32, Float64}
        LinearAlgebra.generic_matmatmul!(C, tA, tB, A, B, alpha, beta)
    end
    # Julia 1.12 introduced generic_mul! for scalar * array operations
    function LinearAlgebra.generic_mul!(C::AbstractGPUVecOrMat, X::AbstractGPUVecOrMat, s::Number, alpha::Number, beta::Number)
        if length(C) != length(X)
            throw(DimensionMismatch(lazy"first array has length $(length(C)) which does not match the length of the second, $(length(X))."))
        end
        @. C = X * s * alpha + C * beta
        return C
    end
    function LinearAlgebra.generic_mul!(C::AbstractGPUVecOrMat, s::Number, X::AbstractGPUVecOrMat, alpha::Number, beta::Number)
        if length(C) != length(X)
            throw(DimensionMismatch(lazy"first array has length $(length(C)) which does not match the length of the second, $(length(X))."))
        end
        @. C = s * X * alpha + C * beta
        return C
    end
    LinearAlgebra._generic_matmatmul_nonadjtrans!(C::AbstractGPUVecOrMat, A::AbstractTriangular, B::AbstractTriangular, alpha::Number, beta::Number) =
        _triangular_matmatmul!(C, A, B, alpha, beta)
end

@static if VERSION < v"1.11.0-rc"
    LinearAlgebra._generic_matmatmul!(C::AbstractGPUVecOrMat, tA::Char, tB::Char, A::AbstractTriangular, B::AbstractTriangular, add::LinearAlgebra.MulAddMul) =
        _triangular_matmatmul!(C, A, B, add.alpha, add.beta)
end

@static if v"1.11.0-rc" < VERSION < v"1.12.0-rc"
    LinearAlgebra._generic_matmatmul!(C::AbstractGPUVecOrMat, A::AbstractTriangular, B::AbstractTriangular, add::LinearAlgebra.MulAddMul) =
        _triangular_matmatmul!(C, A, B, add.alpha, add.beta)
end

function generic_trimatmul!(C::AbstractGPUVecOrMat{R}, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix{T}, B::AbstractGPUVecOrMat{S}) where {T,S,R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch(lazy"matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))"))
    end
    if size(C,1) != size(A,1) || size(C,2) != size(B,2)
        throw(DimensionMismatch(lazy"result C has dimensions $(size(C)), needs $((size(A,1),size(B,2)))"))
    end
    if isempty(A) || isempty(B)
        return fill!(C, zero(R))
    end

    upper = tfun === identity ? uploc == 'U' :  uploc != 'U'
    unit  = isunitc == 'U'
    oA = oneunit(eltype(A))

    @kernel function trimatmul(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(unit ? oA : A[i,i], B[i,j], Cij)
            for k in (upper ? (i + 1) : 1):(upper ? m : (i - 1))
                Cij = muladd(A[i,k], B[k,j], Cij)
            end
            C[i,j] = Cij
        end
    end

    @kernel function trimatmul_t(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(unit ? oA : transpose(A[i,i]), B[i,j], Cij)
            for k in (upper ? (i + 1) : 1):(upper ? m : (i - 1))
                Cij = muladd(transpose(A[k,i]), B[k,j], Cij)
            end
            C[i,j] = Cij
        end
    end

    @kernel function trimatmul_a(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(unit ? oA : adjoint(A[i,i]), B[i,j], Cij)
            for k in (upper ? (i + 1) : 1):(upper ? m : (i - 1))
                Cij = muladd(adjoint(A[k,i]), B[k,j], Cij)
            end
            C[i,j] = Cij
        end
    end

    if tfun === identity
        trimatmul(get_backend(C))(C, A, B; ndrange = length(C))
    elseif tfun == transpose
        trimatmul_t(get_backend(C))(C, A, B; ndrange = length(C))
    elseif tfun === adjoint
        trimatmul_a(get_backend(C))(C, A, B; ndrange = length(C))
    else
        error("Not supported")
    end

    C
end

function generic_mattrimul!(C::AbstractGPUVecOrMat{R}, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix{T}, B::AbstractGPUVecOrMat{S}) where {T,S,R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch(lazy"matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))"))
    end
    if size(C,1) != size(A,1) || size(C,2) != size(B,2)
        throw(DimensionMismatch(lazy"result C has dimensions $(size(C)), needs $((size(A,1),size(B,2)))"))
    end
    if isempty(A) || isempty(B)
        return fill!(C, zero(R))
    end

    upper = tfun === identity ? uploc == 'U' :  uploc != 'U'
    unit  = isunitc == 'U'
    oB = oneunit(eltype(B))

    @kernel function mattrimul(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(A[i,j], unit ? oB : B[j,j], Cij)
            for k in (upper ? 1 : (j + 1)):(upper ? (j - 1) : m)
                Cij = muladd(A[i,k], B[k,j], Cij)
            end
            C[i,j] = Cij
        end
    end

    @kernel function mattrimul_t(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(A[i,j], unit ? oB : transpose(B[j,j]), Cij)
            for k in (upper ? 1 : (j + 1) ):(upper ? (j - 1) : m)
                Cij = muladd(A[i,k], transpose(B[j,k]), Cij)
            end
            C[i,j] = Cij
        end
    end

    @kernel function mattrimul_a(C, A, B)
        idx = @index(Global, Linear)
        assume.(size(C) .> 0)
        i, j = @inbounds Tuple(CartesianIndices(C)[idx])..., 1
        l, m, n = size(A, 1), size(B, 1), size(B, 2)

        @inbounds if i <= l && j <= n
            z2 = zero(A[i,1] * B[1,j] + A[i,1] * B[1,j])
            Cij = convert(promote_type(R, typeof(z2)), z2)
            Cij = muladd(A[i,j], unit ? oB : adjoint(B[j,j]), Cij)
            for k in (upper ? 1 : (j + 1)):(upper ? (j - 1) : m)
                Cij = muladd(A[i,k], adjoint(B[j,k]), Cij)
            end
            C[i,j] = Cij
        end
    end

    if tfun === identity
        mattrimul(get_backend(C))(C, A, B; ndrange = length(C))
    elseif tfun == transpose
        mattrimul_t(get_backend(C))(C, A, B; ndrange = length(C))
    elseif tfun === adjoint
        mattrimul_a(get_backend(C))(C, A, B; ndrange = length(C))
    else
        error("Not supported")
    end

    C
end

# triangular solves parallelize only across right-hand sides; each one is a sequential
# forward/backward substitution. backends with a vendor BLAS override these with native
# trsm calls, so these fallbacks mainly serve backends without one. unlike LinearAlgebra's
# generic implementation, a zero diagonal element does not throw a SingularException but
# yields Infs/NaNs, like vendor BLAS libraries.
function generic_trimatdiv!(C::AbstractGPUVecOrMat{R}, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix{T}, B::AbstractGPUVecOrMat{S}) where {T,S,R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch(lazy"matrix A has dimensions $(size(A)), right hand side B has dimensions $(size(B))"))
    end
    if size(C) != size(B)
        throw(DimensionMismatch(lazy"result C has dimensions $(size(C)), needs $(size(B))"))
    end
    isempty(B) && return C

    upper = tfun === identity ? uploc == 'U' : uploc != 'U'
    unit  = isunitc == 'U'

    # C = tfun(A) \ B; safe for C === B, as B[i,j] is read before C[i,j] is written
    @kernel function trimatdiv(C, A, B, tf)
        j = @index(Global, Linear)
        m, n = size(C, 1), size(C, 2)

        @inbounds if j <= n
            for ii in 1:m
                i = upper ? m - ii + 1 : ii
                Cij = convert(promote_type(R, S), B[i,j])
                for k in (upper ? (i + 1) : 1):(upper ? m : (i - 1))
                    Aik = tf === identity ? A[i,k] : tf(A[k,i])
                    Cij -= Aik * C[k,j]
                end
                C[i,j] = unit ? Cij : tf(A[i,i]) \ Cij
            end
        end
    end

    trimatdiv(get_backend(C))(C, A, B, tfun; ndrange = size(C, 2))

    C
end

function generic_mattridiv!(C::AbstractGPUMatrix{R}, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix{T}, B::AbstractGPUMatrix{S}) where {T,S,R}
    if size(A,2) != size(B,1)
        throw(DimensionMismatch(lazy"left hand side A has dimensions $(size(A)), matrix B has dimensions $(size(B))"))
    end
    if size(C) != size(A)
        throw(DimensionMismatch(lazy"result C has dimensions $(size(C)), needs $(size(A))"))
    end
    isempty(A) && return C

    upper = tfun === identity ? uploc == 'U' : uploc != 'U'
    unit  = isunitc == 'U'

    # C = A / tfun(B); safe for C === A, as A[i,j] is read before C[i,j] is written
    @kernel function mattridiv(C, A, B, tf)
        i = @index(Global, Linear)
        m, n = size(C, 1), size(C, 2)

        @inbounds if i <= m
            for jj in 1:n
                j = upper ? jj : n - jj + 1
                Cij = convert(promote_type(R, T), A[i,j])
                for k in (upper ? 1 : (j + 1)):(upper ? (j - 1) : n)
                    Bkj = tf === identity ? B[k,j] : tf(B[j,k])
                    Cij -= C[i,k] * Bkj
                end
                C[i,j] = unit ? Cij : Cij / tf(B[j,j])
            end
        end
    end

    mattridiv(get_backend(C))(C, A, B, tfun; ndrange = size(C, 1))

    C
end

function LinearAlgebra.generic_trimatmul!(C::AbstractGPUVecOrMat, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix, B::AbstractGPUVecOrMat)
    generic_trimatmul!(C, uploc, isunitc, tfun, A, B)
end
function LinearAlgebra.generic_mattrimul!(C::AbstractGPUMatrix, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix, B::AbstractGPUMatrix)
    generic_mattrimul!(C, uploc, isunitc, tfun, A, B)
end
function LinearAlgebra.generic_trimatdiv!(C::AbstractGPUVecOrMat, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix, B::AbstractGPUVecOrMat)
    generic_trimatdiv!(C, uploc, isunitc, tfun, A, B)
end
function LinearAlgebra.generic_mattridiv!(C::AbstractGPUMatrix, uploc, isunitc, tfun::Function, A::AbstractGPUMatrix, B::AbstractGPUMatrix)
    generic_mattridiv!(C, uploc, isunitc, tfun, A, B)
end

function generic_rmul!(X::AbstractArray, s::Number)
    @kernel function rmul_kernel!(X, s)
        i = @index(Global, Linear)
        @inbounds X[i] *= s
    end
    rmul_kernel!(get_backend(X))(X, s; ndrange = size(X))
    return X
end

LinearAlgebra.rmul!(A::AbstractGPUArray, b::Number) = generic_rmul!(A, b)
LinearAlgebra.rmul!(A::Diagonal{T, <:AbstractGPUArray}, b::Number) where {T} = generic_rmul!(A.diag, b)

function generic_lmul!(s::Number, X::AbstractArray)
    @kernel function lmul_kernel!(X, s)
        i = @index(Global, Linear)
        @inbounds X[i] = s*X[i]
    end
    lmul_kernel!(get_backend(X))(X, s; ndrange = size(X))
    return X
end

LinearAlgebra.lmul!(a::Number, B::AbstractGPUArray) = generic_lmul!(a, B)
LinearAlgebra.lmul!(a::Number, B::Diagonal{T, <:AbstractGPUArray}) where {T} = generic_lmul!(a, B.diag)


## permutedims
LinearAlgebra.permutedims!(dest::AbstractGPUArray, src::AbstractGPUArray, perm) =
    permutedims!(dest, src, Tuple(perm))

@inline @generated function permute_linearindex(size::NTuple{N,T}, l::T,
                                                strides::NTuple{N,T}) where {N,T}
    quote
        l -= one(T)
        res = one(T)
        Base.Cartesian.@nexprs $(N-1) i->begin
            assume(size[i] > 0)
            @inbounds l, s = divrem(l, size[i])
            @inbounds res += s * strides[i]
        end
        return @inbounds res + strides[N] * l
    end
end

function LinearAlgebra.permutedims!(dest::AbstractGPUArray,
                                    src::AbstractGPUArray,
                                    perm::NTuple{N}) where N
    if length(dest) <= typemax(UInt32)
        _permutedims!(UInt32, dest, src, perm)
    else
        _permutedims!(UInt64, dest, src, perm)
    end
end

function _permutedims!(::Type{IT}, dest::AbstractGPUArray,
                       src::AbstractGPUArray, perm::NTuple{N}) where {IT,N}
    @assert length(src) <= typemax(IT)
    Base.checkdims_perm(dest, src, perm)
    dest_strides = ntuple(k->k==1 ? 1 : prod(i->size(dest, i), 1:k-1), N)
    dest_strides_perm = ntuple(i->IT(dest_strides[findfirst(==(i), perm)]), N)
    size_src = IT.(size(src))
    @kernel function permutedims_kernel!(dest, src, size_src, dest_strides_perm)
        SLI = @index(Global, Linear)
        assume(0 < SLI <= typemax(IT))
        LI = IT(SLI)
        dest_index = permute_linearindex(size_src, LI, dest_strides_perm)
        @inbounds dest[dest_index] = src[LI]
    end
    kernel = permutedims_kernel!(get_backend(dest))
    kernel(vec(dest), vec(src), size_src, dest_strides_perm; ndrange = size(dest))
    return dest
end

## norm

function LinearAlgebra.norm(v::AnyGPUArray{T}, p::Real=2) where {T}
    result_type, sum_type, promote_ = _normtypes(T)
    isempty(v) && return zero(result_type)
    p == 0 && return convert(result_type, count(!iszero, v))
    spp = convert(sum_type, p)
    init = zero(sum_type)  # To set the accumulation type in `sum`
    # Rescaling heuristic similar to Base, see LinearAlgebra/src/generic.jl
    result = if p > 1 || p < -1  # May need rescaling
        infnorm = p > 1 ? maximum(norm, v) : minimum(norm, v)
        if isinf(p) || iszero(infnorm) || isinf(infnorm)
            return convert(result_type, infnorm)  # Return early to skip conversions
        end
        factor = convert(sum_type, infnorm)
        if p == 2
            if isfinite(length(v) * factor^2) && !iszero(factor^2)  # No rescaling
                sqrt(sum(x -> LinearAlgebra.norm_sqr(promote_(x)), v; init=init))
            else  # Rescaling
                factor * sqrt(sum(x -> (norm(promote_(x)) / factor)^2, v; init=init))
            end
        else
            if isfinite(length(v) * factor^spp) && !iszero(factor^spp)  # No rescaling
                sum(x -> norm(promote_(x))^spp, v; init=init)^inv(spp)
            else  # Rescaling
                factor * (sum(x -> (norm(promote_(x)) / factor)^spp, v; init=init)^inv(spp))
            end
        end
    elseif p == 1
        sum(x -> norm(promote_(x)), v; init=init)
    else
        sum(x -> norm(promote_(x))^spp, v; init=init)^inv(spp)
    end
    return convert(result_type, result)
end

function _normtypes(::Type{T}) where {T}
    result_type = typeof(float(norm(zero(T))))
    # Accumulate in at least Float32, like nrm2 in CUBLAS
    sum_type = promote_type(Float32, result_type)
    # If sum_type is wider than T, promote before applying other functions. To work in GPU
    # kernels this operation must close around a value, not a type, hence the prototype
    prototype = zero(promote_type(T, sum_type))
    promote_(x) = convert(typeof(prototype), x)
    return result_type, sum_type, promote_
end

## normalize
@static if VERSION < v"1.14.0-DEV.2264" # no longer needed as of JuliaLang/LinearAlgebra#1634
# Avoid `first(a)` scalar indexing in LinearAlgebra.normalize (JuliaGPU/CUDA.jl#3097)
function LinearAlgebra.normalize(a::AnyGPUArray, p::Real=2)
    nrm = norm(a, p)
    if !isempty(a)
        T = typeof(zero(eltype(a))/nrm)
        aa = LinearAlgebra.copymutable_oftype(a, T)
        return LinearAlgebra.__normalize!(aa, nrm)
    else
        T = typeof(zero(eltype(a))/nrm)
        return T[]
    end
end
end
## opnorm

function LinearAlgebra.opnorm1(A::AnyGPUArray{T,2}) where {T}
    result_type, sum_type, promote_ = _normtypes(T)
    result = maximum(sum(x -> norm(promote_(x)), A; dims=1); init=zero(sum_type))
    return convert(result_type, result)
end

function LinearAlgebra.opnormInf(A::AnyGPUArray{T,2}) where {T}
    result_type, sum_type, promote_ = _normtypes(T)
    result = maximum(sum(x -> norm(promote_(x)), A; dims=2); init=zero(sum_type))
    return convert(result_type, result)
end

## symmetric

# prevent scalar indexing (upstream? this version is slower than a simple loop)
function Base.similar(A::Hermitian{<:Any,<:AbstractGPUArray}, ::Type{T}) where T
    B = similar(parent(A), T)
    fill!(view(B, diagind(B)), 0)
    return Hermitian(B, ifelse(A.uplo == 'U', :U, :L))
end

## rotate

function LinearAlgebra.rotate!(x::AbstractGPUArray, y::AbstractGPUArray, c::Number, s::Number)
    @kernel function rotate_kernel!(x, y, c, s)
        i = @index(Global, Linear)
        @inbounds xi = x[i]
        @inbounds yi = y[i]
        @inbounds x[i] = s*yi +      c *xi
        @inbounds y[i] = c*yi - conj(s)*xi
    end
    rotate_kernel!(get_backend(x))(x, y, c, s; ndrange = size(x))
    return x, y
end

## reflect

function LinearAlgebra.reflect!(x::AbstractGPUArray, y::AbstractGPUArray, c::Number, s::Number)
    @kernel function  reflect_kernel!(x, y, c, s)
        i = @index(Global, Linear)
        @inbounds xi = x[i]
        @inbounds yi = y[i]
        @inbounds x[i] =      c  * xi + s * yi
        @inbounds y[i] = conj(s) * xi - c * yi
    end
    reflect_kernel!(get_backend(x))(x, y, c, s; ndrange = size(x))
    return x, y
end

## dot

LinearAlgebra.dot(x::AbstractGPUArray, y::AbstractGPUArray) = mapreduce(dot, +, x, y)

## axp{b}y

LinearAlgebra.axpby!(alpha::Number, x::AbstractGPUArray,
                     beta::Number,  y::AbstractGPUArray) = y .= x.*alpha .+ y.*beta

LinearAlgebra.axpy!(alpha::Number, x::AbstractGPUArray, y::AbstractGPUArray) = y .+= x.*alpha

## identity and zero equality check

Base.iszero(x::AbstractGPUMatrix{T}) where {T} = all(iszero, x)
function Base.isone(x::AbstractGPUMatrix{T}) where {T}
    n,m = size(x)
    m != n && return false

    # lazily perform `x-I`
    bc = Broadcast.broadcasted(x, CartesianIndices(x)) do _x, inds
        _x - (inds[1] == inds[2] ? one(_x) : zero(_x))
    end
    # call `GPUArrays.mapreducedim!` directly, which supports Broadcasted inputs
    y = similar(x, Bool, 1)
    GPUArrays.mapreducedim!(iszero, &, y, Broadcast.instantiate(bc); init=true)

    Array(y)[]
end

## Kronecker product

@kernel function kron_kernel_vec!(z, @Const(x), @Const(y))
    i, j = @index(Global, NTuple)

    @inbounds z[(i - 1) * length(y) + j] = x[i] * y[j]
end

function LinearAlgebra.kron!(z::AbstractGPUVector{T1}, x::AbstractGPUVector{T2}, y::AbstractGPUVector{T3}) where {T1,T2,T3}
    @assert length(z) == length(x) * length(y)

    backend = KernelAbstractions.get_backend(z)
    kernel = kron_kernel_vec!(backend)

    kernel(z, x, y, ndrange=(length(x), length(y)))

    return z
end

function LinearAlgebra.kron(x::AbstractGPUVector{T1}, y::AbstractGPUVector{T2}) where {T1,T2}
    T = promote_type(T1, T2)
    z = similar(x, T, length(x) * length(y))
    return kron!(z, x, y)
end

@kernel function kron_kernel!(C, @Const(A), @Const(B))
    ai, aj = @index(Global, NTuple)  # Indices in the result matrix

    # lb1, lb2 = size(B)  # Dimensions of B
    lb1 = size(B, 1)
    lb2 = size(B, 2)

    # Map global indices (ai, aj) to submatrices of the Kronecker product
    i_a = fld1(ai, lb1)  # Corresponding row index in A
    i_b = mod1(ai, lb1)  # Corresponding row index in B
    j_a = fld1(aj, lb2)  # Corresponding col index in A
    j_b = mod1(aj, lb2)  # Corresponding col index in B

    @inbounds C[ai, aj] = A[i_a, j_a] * B[i_b, j_b]
end

trans_adj_wrappers = (
    T -> :(AbstractGPUVecOrMat{$T}),
    T -> :(Transpose{$T, <:AbstractGPUVecOrMat{$T}}),
    T -> :(Adjoint{$T, <:AbstractGPUVecOrMat{$T}}),
)

for wrapa in trans_adj_wrappers, wrapb in trans_adj_wrappers
    TypeA = wrapa(:T1)
    TypeB = wrapb(:T2)
    TypeC = :(AbstractGPUVecOrMat{T3})

    @eval function LinearAlgebra.kron!(C::$TypeC, A::$TypeA, B::$TypeB) where {T1, T2, T3}
        @assert size(C, 1) == size(A, 1) * size(B, 1)
        @assert size(C, 2) == size(A, 2) * size(B, 2)

        backend = KernelAbstractions.get_backend(C)
        kernel = kron_kernel!(backend)

        kernel(C, A, B, ndrange=(size(C, 1), size(C, 2)))

        return C
    end

    @eval function LinearAlgebra.kron(A::$TypeA, B::$TypeB) where {T1, T2}
        T = promote_type(T1, T2)
        C = similar(A, T, size(A, 1) * size(B, 1), size(A, 2) * size(B, 2))
        return kron!(C, A, B)
    end
end

@kernel function kron_diag_dense_kernel!(C, @Const(a), @Const(B))
    ci, cj = @index(Global, NTuple)
    mb = size(B, 1)
    nb = size(B, 2)
    i = fld1(ci, mb)
    bi = mod1(ci, mb)
    j = fld1(cj, nb)
    bj = mod1(cj, nb)
    @inbounds C[ci, cj] = (i == j) ? a[i] * B[bi, bj] : zero(eltype(C))
end

@kernel function kron_dense_diag_kernel!(C, @Const(A), @Const(b))
    ci, cj = @index(Global, NTuple)
    nb = length(b)
    i = fld1(ci, nb)
    bi = mod1(ci, nb)
    j = fld1(cj, nb)
    bj = mod1(cj, nb)
    @inbounds C[ci, cj] = (bi == bj) ? A[i, j] * b[bi] : zero(eltype(C))
end

function LinearAlgebra.kron!(C::AbstractGPUMatrix, A::Diagonal{T1, <:AbstractGPUVector}, B::AbstractGPUMatrix{T2}) where {T1, T2}
    size(C) == (length(A.diag) * size(B, 1), length(A.diag) * size(B, 2)) || throw(DimensionMismatch())
    backend = KernelAbstractions.get_backend(C)
    kron_diag_dense_kernel!(backend)(C, A.diag, B, ndrange = size(C))
    return C
end

function LinearAlgebra.kron(A::Diagonal{T1, <:AbstractGPUVector}, B::AbstractGPUMatrix{T2}) where {T1, T2}
    T = promote_type(T1, T2)
    return kron!(similar(B, T, length(A.diag) * size(B, 1), length(A.diag) * size(B, 2)), A, B)
end

function LinearAlgebra.kron!(C::AbstractGPUMatrix, A::AbstractGPUMatrix{T1}, B::Diagonal{T2, <:AbstractGPUVector}) where {T1, T2}
    size(C) == (size(A, 1) * length(B.diag), size(A, 2) * length(B.diag)) || throw(DimensionMismatch())
    backend = KernelAbstractions.get_backend(C)
    kron_dense_diag_kernel!(backend)(C, A, B.diag, ndrange = size(C))
    return C
end

function LinearAlgebra.kron(A::AbstractGPUMatrix{T1}, B::Diagonal{T2, <:AbstractGPUVector}) where {T1, T2}
    T = promote_type(T1, T2)
    return kron!(similar(A, T, size(A, 1) * length(B.diag), size(A, 2) * length(B.diag)), A, B)
end

function LinearAlgebra.kron!(C::Diagonal{<:Any, <:AbstractGPUVector}, A::Diagonal{T1, <:AbstractGPUVector}, B::Diagonal{T2, <:AbstractGPUVector}) where {T1, T2}
    kron!(C.diag, A.diag, B.diag)
    return C
end

function LinearAlgebra.kron(A::Diagonal{T1, <:AbstractGPUVector}, B::Diagonal{T2, <:AbstractGPUVector}) where {T1, T2}
    Diagonal(kron(A.diag, B.diag))
end

using ..GPUArrays

@static if VERSION < v"1.11"
    using ScopedValues
else
    using Base.ScopedValues
end

mutable struct AllocCache
    lock::ReentrantLock
    busy::Dict{UInt64, Vector{DataRef}}
    free::Dict{UInt64, Vector{DataRef}}

    function AllocCache()
        cache = new(
            ReentrantLock(),
            Dict{UInt64, Vector{Any}}(),
            Dict{UInt64, Vector{Any}}()
        )
        return finalizer(unsafe_free!, cache)
    end
end

function get_pool!(cache::AllocCache, pool::Symbol, uid::UInt64)
    pool = getproperty(cache, pool)
    uid_pool = get(pool, uid, nothing)
    if uid_pool === nothing
        uid_pool = pool[uid] = DataRef[]
    end
    return uid_pool
end

function cached_alloc(f, key)
    cache = ALLOC_CACHE[]
    if cache === nothing
        return f()::DataRef
    end

    ref = nothing
    uid = hash(key)

    Base.@lock cache.lock begin
        free_pool = get_pool!(cache, :free, uid)

        if !isempty(free_pool)
            ref = Base.@lock cache.lock pop!(free_pool)
        end
    end

    if ref === nothing
        ref = f()::DataRef
        ref.cached = true
    end

    Base.@lock cache.lock begin
        busy_pool = get_pool!(cache, :busy, uid)
        push!(busy_pool, ref)
    end

    return ref
end

function free_busy!(cache::AllocCache)
    Base.@lock cache.lock begin
        for uid in keys(cache.busy)
            busy_pool = get_pool!(cache, :busy, uid)
            isempty(busy_pool) && continue

            free_pool = get_pool!(cache, :free, uid)
            append!(free_pool, busy_pool)
            empty!(busy_pool)
        end
    end
    return
end

function unsafe_free!(cache::AllocCache)
    Base.@lock cache.lock begin
        for pool in values(cache.busy)
            isempty(pool) || error("Cannot invalidate a cache that's in active use")
        end
        for pool in values(cache.free), ref in pool
            # release the reference
            ref.cached = false
            unsafe_free!(ref)
        end
        empty!(cache.free)
    end
    return
end

function Base.sizeof(cache::AllocCache)
    sz = UInt64(0)
    Base.@lock cache.lock begin
        for kind in (cache.free, cache.busy), (_, pool) in kind
            sz += sum(sizeof, pool; init = UInt64(0))
        end
    end
    return sz
end

function Base.show(io::IO, cache::AllocCache)
    sz, n_free, n_busy = Base.@lock cache.lock begin
        sz = sizeof(cache)
        n_free = sum(p -> length(p[2]), cache.free; init = 0)
        n_busy = sum(p -> length(p[2]), cache.busy; init = 0)
        sz, n_free, n_busy
    end
    return print(io, "AllocCache(n_free=$n_free, n_busy=$n_busy, sizeof=$(Base.format_bytes(sz)))")
end

const ALLOC_CACHE = ScopedValue{Union{Nothing, AllocCache}}(nothing)

"""
    @cached cache expr

Evaluate `expr` using allocations cache `cache`.

When GPU memory is allocated during the execution of `expr`, `cache` will first be checked.
If no memory is available in the cache, a new allocation will be requested.

After the execution of `expr`, all allocations made under the scope of `@cached` will be
cached within `cache` for future use. This is useful to avoid relying on GC to free GPU
memory in time.

Once `cache` goes out scope, or when the user calls `unsafe_free!` on it, all cached
allocations will be freed.

# Example

In the following example, each iteration of the for-loop requires 8 GiB of GPU memory.
Without caching those allocations, significant pressure would be put on the GC, resulting
in high memory usage and latency. By using the allocator cache, the memory usage is stable:

```julia
cache = GPUArrays.AllocCache()
for i in 1:1000
    GPUArrays.@cached cache begin
        sin.(CUDA.rand(Float32, 1024^3))
    end
end

# optionally: free the memory now, instead of waiting for the GC to collect `cache`
GPUArrays.unsafe_free!(cache)
```

See [`@uncached`](@ref).
"""
macro cached(cache, expr)
    try_expr = :(@with $(esc(ALLOC_CACHE)) => cache $(esc(expr)))
    fin_expr = :(free_busy!($(esc(cache))))
    return quote
        local cache = $(esc(cache))
        GC.@preserve cache $(Expr(:tryfinally, try_expr, fin_expr))
    end
end

"""
    @uncached expr

Evaluate expression `expr` without using the allocation. This is useful to call from within
`@cached` to avoid caching some allocations, e.g., because they can be returned out of the
`@cached` scope.
"""
macro uncached(expr)
    return quote
        @with $(esc(ALLOC_CACHE)) => nothing $(esc(expr))
    end
end

@testsuite "sparse" (AT, eltypes)->begin
    sparse_ATs = sparse_types(AT)
    @testset "sparse_AT = $sparse_AT" for sparse_AT in sparse_ATs
        if sparse_AT <: AbstractSparseVector
            vector(sparse_AT, eltypes)
            vector_construction(sparse_AT, eltypes)
            broadcasting_vector(sparse_AT, eltypes)
            iszero_vector(sparse_AT, eltypes)
        elseif sparse_AT <: AbstractSparseMatrix
            matrix(sparse_AT, eltypes)
            matrix_construction(sparse_AT, eltypes)
            broadcasting_matrix(sparse_AT, eltypes)
            mapreduce_matrix(sparse_AT, eltypes)
            linalg(sparse_AT, eltypes)
            iszero_matrix(sparse_AT, eltypes)
       end
    end
end

using SparseArrays
using SparseArrays: nonzeroinds, nonzeros, rowvals

function vector(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "Sparse vector properties" begin
        @testset "$ET" for ET in eltypes
            m = 25
            n = 35
            k = 10
            p = 5
            blockdim = 5
            x   = sprand(ET,m,0.2)
            d_x = AT(x)
            @test length(d_x) == m
            @test size(d_x)   == (m,)
            @test size(d_x,1) == m
            @test size(d_x,2) == 1
            @test ndims(d_x)  == 1
            dense_d_x  = dense_AT(x)
            dense_d_x2 = dense_AT(d_x)
            @allowscalar begin
                @test Array(d_x[:])        == x[:]
                @test d_x[firstindex(d_x)] == x[firstindex(x)]
                @test d_x[div(end, 2)]     == x[div(end, 2)]
                @test d_x[end]             == x[end]
                @test Array(d_x[firstindex(d_x):end]) == x[firstindex(x):end]
                @test Array(dense_d_x[firstindex(d_x):end]) == x[firstindex(x):end]
                @test Array(dense_d_x2[firstindex(d_x):end]) == x[firstindex(x):end]
            end
            @test_throws BoundsError d_x[firstindex(d_x) - 1]
            @test_throws BoundsError d_x[end + 1]
            @test nnz(d_x)    == nnz(x)
            @test Array(nonzeros(d_x)) == nonzeros(x)
            @test Array(nonzeroinds(d_x)) == nonzeroinds(x)
            @test Array(rowvals(d_x)) == nonzeroinds(x)
            @test nnz(d_x)    == length(nonzeros(d_x))
        end
    end
end

function vector_construction(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    for ET in eltypes
        m = 25
        n = 35
        k = 10
        p = 5
        blockdim = 5
        x = sprand(ET, m, 0.2)
        d_x = AT(x)
        @test collect(d_x) == collect(x)
        @test similar(d_x) isa AT{ET}
        @test similar(d_x, Float32) isa AT{Float32}
    end
end

function matrix(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "Sparse matrix properties" begin
        @testset "$ET" for ET in eltypes
            m = 25
            n = 35
            k = 10
            p = 5
            blockdim = 5
            x    = sprand(ET, m, 0.2)
            d_x  = AT(x)
            @test size(d_x) == (m, 1)
            x    = sprand(ET, m, n, 0.2)
            d_x  = AT(x)
            d_tx = AT(transpose(x))
            d_ax = AT(adjoint(x))
            @test size(d_tx)   == (n, m)
            @test size(d_ax)   == (n, m)
            @test length(d_x)  == m*n
            @test size(d_x)    == (m, n)
            @test size(d_x, 1) == m
            @test size(d_x, 2) == n
            @test size(d_x, 3) == 1
            @test ndims(d_x)   == 2
            @allowscalar begin
                @test d_x[:, :]            == x[:, :]
                @test d_tx[:, :]           == transpose(x)[:, :]
                @test d_ax[:, :]           == adjoint(x)[:, :]
                @test d_x[(1, 1)]          == x[1, 1]
                @test d_x[firstindex(d_x)] == x[firstindex(x)]
                @test d_x[div(end, 2)]     == x[div(end, 2)]
                @test d_x[end]             == x[end]
                @test d_x[firstindex(d_x), firstindex(d_x)] == x[firstindex(x), firstindex(x)]
                @test d_x[div(end, 2), div(end, 2)]         == x[div(end, 2), div(end, 2)]
                @test d_x[end, end]        == x[end, end]
                for i in 1:size(x, 2)
                    @test Array(d_x[:, i]) == x[:, i]
                end
            end
            @test_throws BoundsError d_x[firstindex(d_x) - 1]
            @test_throws BoundsError d_x[end + 1]
            @test_throws BoundsError d_x[firstindex(d_x) - 1, firstindex(d_x) - 1]
            @test_throws BoundsError d_x[end + 1, end + 1]
            @test_throws BoundsError d_x[firstindex(d_x) - 1:end + 1, :]
            @test_throws BoundsError d_x[firstindex(d_x) - 1, :]
            @test_throws BoundsError d_x[end + 1, :]
            @test_throws BoundsError d_x[:, firstindex(d_x) - 1:end + 1]
            @test_throws BoundsError d_x[:, firstindex(d_x) - 1]
            @test_throws BoundsError d_x[:, end + 1]
            @test nnz(d_x)    == nnz(x)
            @test nnz(d_x)    == length(nonzeros(d_x))
            @test !issymmetric(d_x)
            @test !ishermitian(d_x)
        end
    end
end

function matrix_construction(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    for ET in eltypes
        m = 25
        n = 35
        k = 10
        p = 5
        blockdim = 5
        x = sprand(ET, m, n, 0.2)
        d_x = AT(x)
        @test collect(d_x) == collect(x)
        @test similar(d_x) isa AT{ET}
        @test similar(d_x, Float32) isa AT{Float32}
        @test similar(d_x, Float32, n, m) isa AT{Float32}
        @test similar(d_x, Float32, (n, m)) isa AT{Float32}
        @test similar(d_x, (3, 4)) isa AT{ET}
        @test size(similar(d_x, (3, 4))) == (3, 4)
    end
end

function broadcasting_vector(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "SparseVector broadcasting" begin
        @testset "$ET" for ET in eltypes
            m  = 64
            p  = 0.5
            x  = sprand(ET, m, p)
            dx = AT(x)

            # zero-preserving
            y  = x  .* ET(1)
            dy = dx .* ET(1)
            @test dy isa AT{ET}
            @test collect(SparseArrays.nonzeroinds(dy)) == collect(SparseArrays.nonzeroinds(dx))
            @test collect(SparseArrays.nonzeroinds(dy)) == SparseArrays.nonzeroinds(y)
            @test collect(SparseArrays.nonzeros(dy))    == SparseArrays.nonzeros(y)
            @test y == SparseVector(dy)

            # not zero-preserving
            y  = x  .+ ET(1)
            dy = dx .+ ET(1)
            @test dy isa dense_AT{ET}
            hy = Array(dy)
            @test Array(y) == hy

            # involving something dense
            y  = x  .+ ones(ET, m)
            dy = dx .+ dense_AT(ones(ET, m))
            @test dy isa dense_AT{ET}
            @test Array(y) == Array(dy)

            # sparse to sparse
            dx = AT(x)
            y  = sprand(ET, m, p)
            dy = AT(y)
            z  = x  .* y
            dz = dx .* dy
            @test dz isa AT{ET}
            @test z ≈ SparseVector(dz)

            # multiple inputs
            y  = sprand(ET, m, p)
            w  = sprand(ET, m, p)
            dy = AT(y)
            dx = AT(x)
            dw = AT(w)
            z  = @. x  * y  * w
            dz = @. dx * dy * dw
            @test dz isa AT{ET}
            @test z ≈ SparseVector(dz)

            y = sprand(ET, m, p)
            w = sprand(ET, m, p)
            dense_arr   = rand(ET, m)
            d_dense_arr = dense_AT(dense_arr)
            dy = AT(y)
            dw = AT(w)
            z  = @. x  * y  * w  * dense_arr
            dz = @. dx * dy * dw * d_dense_arr
            @test dz isa dense_AT{ET}
            @test Array(z) ≈ Array(dz)

            y  = sprand(ET, m, p)
            dy = AT(y)
            dx = AT(x)
            z  = x  .* y  .* ET(2)
            dz = dx .* dy .* ET(2)
            @test dz isa AT{ET}
            @test z ≈ SparseVector(dz)

            # type-mismatching
            ## non-zero-preserving
            dx = AT(x)
            dy = dx .+ 1
            y  = x .+ 1
            @test dy isa dense_AT{promote_type(ET, Int)}
            @test Array(y) == Array(dy)
            ## zero-preserving
            dy = dx .* 1
            y  = x  .* 1
            @test dy isa AT{promote_type(ET, Int)}
            @test collect(SparseArrays.nonzeroinds(dy))  == collect(SparseArrays.nonzeroinds(dx))
            @test collect(SparseArrays.nonzeroinds(dy))  == SparseArrays.nonzeroinds(y)
            @test collect(SparseArrays.nonzeros(dy)) == SparseArrays.nonzeros(y)
            @test y == SparseVector(dy)
        end
    end
end

function broadcasting_matrix(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "SparseMatrix broadcasting" begin
        @testset "$ET" for ET in eltypes
            m, n = 5, 6
            p   = 0.5
            x   = sprand(ET, m, n, p)
            dx  = AT(x)
            # zero-preserving
            y  = x  .* ET(1)
            dy = dx .* ET(1)
            @test dy isa AT{ET}
            @test y == SparseMatrixCSC(dy)

            # not zero-preserving
            y  = x  .+ ET(1)
            dy = dx .+ ET(1)
            @test dy isa dense_AT{ET}
            hy = Array(dy)
            dense_y = Array(y)
            @test Array(y) == Array(dy)

            # involving something dense
            y  = x  .* ones(ET, m, n)
            dy = dx .* dense_AT(ones(ET, m, n))
            @test dy isa dense_AT{ET}
            @test Array(y) == Array(dy)

            # multiple inputs
            y  = sprand(ET, m, n, p)
            dy = AT(y)
            z  = x  .* y  .* ET(2)
            dz = dx .* dy .* ET(2)
            @test dz isa AT{ET}
            @test z ≈ SparseMatrixCSC(dz)

            # multiple inputs
            w  = sprand(ET, m, n, p)
            dw = AT(w)
            z  = x  .* y  .* w
            dz = dx .* dy .* dw
            @test dz isa AT{ET}
            @test z ≈ SparseMatrixCSC(dz)

            # create a matrix with nnz < leading_dim
            x = spdiagm(m, m, 2=>rand(ET, m - 2))
            dx = AT(x)
            y = ET(3) * x
            dy = ET(3) * dx
            @test y == SparseMatrixCSC(dy)

            x = spdiagm(m, m, -2=>rand(ET, m - 2))
            dx = AT(x)
            y = ET(3) * x
            dy = ET(3) * dx
            @test y == SparseMatrixCSC(dy)
        end
    end
end

function mapreduce_matrix(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "SparseMatrix mapreduce" begin
        @testset "$ET" for ET in eltypes
            m,n = 5,6
            p = 0.5
            x = sprand(ET, m, n, p)
            dx = AT(x)

            # dim=:
            y  = sum(x)
            dy = sum(dx)
            @test y ≈ dy

            y  = mapreduce(abs, +, x)
            dy = mapreduce(abs, +, dx)
            @test y ≈ dy

            # dim=1
            y  = sum(x, dims=1)
            dy = sum(dx, dims=1)
            @test y ≈ Array(dy)

            y  = mapreduce(abs, +, x, dims=1)
            dy = mapreduce(abs, +, dx, dims=1)
            @test y ≈ Array(dy)

            # dim=2
            y = sum(x, dims=2)
            dy = sum(dx, dims=2)
            @test y ≈ Array(dy)

            y  = mapreduce(abs, +, x, dims=2)
            dy = mapreduce(abs, +, dx, dims=2)
            @test y ≈ Array(dy)
            if ET in (Float32, Float64)
                dy = mapreduce(abs, +, dx; init=zero(ET))
                y  = mapreduce(abs, +, x; init=zero(ET))
                @test y ≈ dy
            end

            # test with a matrix with fully empty rows
            x = zeros(ET, m, n)
            x[2, :] .= -one(ET)
            x[2, end] = -ET(16)
            dx = AT(sparse(x))
            y  = mapreduce(abs, max, x)
            dy = mapreduce(abs, max, dx)
            @test y ≈ dy
        end
    end
end

function linalg(AT, eltypes)
    dense_AT = GPUArrays.dense_array_type(AT)
    @testset "Sparse matrix linear algebra" begin
        # sprandn doesn't work nicely with these...
        @testset "$ET" for ET in filter(T -> !(T <: Union{Int16, Int32, Int64, Complex{Int16}, Complex{Int32}, Complex{Int64}}), eltypes)
            m = 10
            A  = sprandn(ET, m, m, 0.2)
            B  = sprandn(ET, m, m, 0.3)
            ZA = spzeros(ET, m, m)
            C  = I(div(m, 2))
            dA = AT(A)
            dB = AT(B)
            dZA = AT(ZA)
            @testset "opnorm and norm" begin
                @test opnorm(A, Inf) ≈ opnorm(dA, Inf)
                @test opnorm(A, 1)   ≈ opnorm(dA, 1)
                @test_throws ArgumentError opnorm(dA, 2)
            end
        end
    end
end

function iszero_vector(AT, eltypes)
    @testset "iszero SparseVector" begin
        @testset "$ET" for ET in eltypes
            m = 25

            # Test non-zero sparse vector
            x = sprand(ET, m, 0.5)
            while iszero(x)
                x = sprand(ET, m, 0.5)
            end
            d_x = AT(x)
            @test iszero(d_x) == iszero(x)
            @test iszero(d_x) == false

            # Test zero sparse vector (no stored elements)
            z = spzeros(ET, m)
            d_z = AT(z)
            @test iszero(d_z) == iszero(z)
            @test iszero(d_z) == true

            # Test sparse vector with stored zeros (e.g., after operations)
            # Create a sparse vector then multiply by zero
            x_zeros = x .* zero(ET)
            d_x_zeros = d_x .* zero(ET)
            @test iszero(d_x_zeros) == iszero(x_zeros)
            @test iszero(d_x_zeros) == true
        end
    end
end

function iszero_matrix(AT, eltypes)
    @testset "iszero SparseMatrix" begin
        @testset "$ET" for ET in eltypes
            m, n = 10, 10

            # Test non-zero sparse matrix
            A = sprand(ET, m, n, 0.5)
            while iszero(A)
                A = sprand(ET, m, n, 0.5)
            end
            dA = AT(A)
            @test iszero(dA) == iszero(A)
            @test iszero(dA) == false

            # Test zero sparse matrix (no stored elements)
            ZA = spzeros(ET, m, n)
            dZA = AT(ZA)
            @test iszero(dZA) == iszero(ZA)
            @test iszero(dZA) == true

            # Test sparse matrix with stored zeros
            A_zeros = A .* zero(ET)
            dA_zeros = dA .* zero(ET)
            @test iszero(dA_zeros) == iszero(A_zeros)
            @test iszero(dA_zeros) == true
        end
    end
end

@testsuite "linalg/core" (AT, eltypes) -> begin
    @testset "adjoint and transpose" begin
        @test compare(adjoint, AT, rand(Float32, 32, 32))
        @test compare(adjoint!, AT, rand(Float32, 32, 32), rand(Float32, 32, 32))
        @test compare(adjoint!, AT, rand(Float32, 1, 32), rand(Float32, 32))
        @test compare(adjoint!, AT, rand(Float32, 32), rand(Float32, 1, 32))
        @test compare(adjoint!, AT, rand(Float32, 32, 0), rand(Float32, 0, 32))
        @test compare(adjoint!, AT, rand(Float32, 0, 32), rand(Float32, 32, 0))
        @test compare(transpose, AT, rand(Float32, 32, 32))
        @test compare(transpose!, AT, rand(Float32, 32, 32), rand(Float32, 32, 32))
        @test compare(transpose!, AT, rand(Float32, 1, 32), rand(Float32, 32))
        @test compare(transpose!, AT, rand(Float32, 32), rand(Float32, 1, 32))
        @test compare(transpose!, AT, rand(Float32, 32, 0), rand(Float32, 0, 32))
        @test compare(transpose!, AT, rand(Float32, 0, 32), rand(Float32, 32, 0))
        @test compare((x,y)->copyto!(x, adjoint(y)), AT, rand(Float32, 32, 32), rand(Float32, 32, 32))
        @test compare((x,y)->copyto!(x, transpose(y)), AT, rand(Float32, 32, 32), rand(Float32, 32, 32))
        @test compare(transpose!, AT, Array{Float32}(undef, 32, 32), rand(Float32, 32, 32))
        @test compare(transpose!, AT, Array{Float32}(undef, 128, 32), rand(Float32, 32, 128))
    end

    @testset "tr" begin
        @test compare(tr, AT, rand(Float32, 32, 32))
    end

    @testset "permutedims" begin
        @test compare(x -> permutedims(x, (2, 1)), AT, rand(Float32, 2, 3))
        @test compare(x -> permutedims(x, (2, 1, 3)), AT, rand(Float32, 4, 5, 6))
        @test compare(x -> permutedims(x, (3, 1, 2)), AT, rand(Float32, 4, 5, 6))
        if ComplexF32 in eltypes
            @test compare(x -> permutedims(x, [2,1,4,3]), AT, randn(ComplexF32,3,4,5,1))
            # test UInt64 version to make sure it works properly when array length is larger than typemax of UInt32.
            AT <: GPUArrays.AbstractGPUArray && @test let
                x = randn(ComplexF32,3,4,5,1)
                y = permutedims(x, (2,1,4,3))
                Array(GPUArrays._permutedims!(UInt64, AT(zero(y)), AT(x), (2,1,4,3))) ≈ y
            end
        end
        # high dimensional tensor
        @test compare(x -> permutedims(x, 18:-1:1), AT, rand(Float32, 4, [2 for _ = 2:18]...))
        # test the Uint64 type version for large array permutedims
        AT <: GPUArrays.AbstractGPUArray && @test let
            x = rand(Float32, 4, [2 for _ = 2:18]...)
            pm = (18:-1:1...,)
            y = permutedims(x, pm)
            Array(GPUArrays._permutedims!(UInt64, AT(zero(y)), AT(x), pm)) ≈ y
        end
    end


    @testset "symmetric" begin
        @testset "Hermitian" begin
            A    = rand(Float32,2,2)
            A    = A*A'+I #posdef
            d_A  = AT(A)
            similar(Hermitian(d_A, :L), Float32)
        end

        @testset "issymmetric/ishermitian" begin
            n = 128
            areal = randn(n,n)/2
            aimg  = randn(n,n)/2

            @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64)
                if !(eltya in eltypes)
                    continue
                end
                a = convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
                asym = transpose(a) + a        # symmetric indefinite
                aherm = a' + a                 # Hermitian indefinite
                @test issymmetric(asym)
                @test ishermitian(aherm)
            end
        end
    end

    @testset "triangular" begin
        @testset "copytri!" begin
            @testset for eltya in (Float32, Float64, ComplexF32, ComplexF64), uplo in ('U', 'L'), conjugate in (true, false), diag in (true, false)
                if !(eltya in eltypes)
                    continue
                end
                n = 128
                areal = randn(n,n)/2
                aimg  = randn(n,n)/2
                a = convert(Matrix{eltya}, eltya <: Complex ? complex.(areal, aimg) : areal)
                @test compare(x -> LinearAlgebra.copytri!(x, uplo, conjugate, diag), AT, a)
            end
        end

        if isdefined(LinearAlgebra, :copytrito!)
            @testset "copytrito!" begin
                @testset for T in eltypes, uplo in ('L', 'U')
                    n = 16
                    A = rand(T,n,n)
                    B = zeros(T,n,n)
                    @test compare(copytrito!, AT, B, A, uplo)
                end
                @testset for T in eltypes, uplo in ('L', 'U')
                    n = 16
                    m = 32
                    A = uplo == 'U' ? rand(T,m,n) : rand(T,n,m)
                    B = zeros(T,n,n)
                    @test compare(copytrito!, AT, B, A, uplo)
                end
            end
        end

        @testset "copyto! for triangular" begin
            for TR in (UpperTriangular, LowerTriangular)
                @test compare(transpose!, AT, Array{Float32}(undef, 128, 32), rand(Float32, 32, 128))

                cpu_a = Array{Float32}(undef, 128, 128)
                gpu_a = AT{Float32}(undef, 128, 128)
                gpu_b = AT{Float32}(undef, 128, 128)

                copyto!(gpu_a, rand(Float32, (128,128)))
                copyto!(cpu_a, TR(gpu_a))
                @test cpu_a == Array(collect(TR(gpu_a)))

                copyto!(gpu_a, rand(Float32, (128,128)))
                gpu_c = copyto!(gpu_b, TR(gpu_a))
                @test all(Array(gpu_b) .== TR(Array(gpu_a)))
                @test gpu_c isa AT
            end

            for TR in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular)
                gpu_a = AT(rand(Float32, (128,128))) |> TR
                gpu_b = AT{Float32}(undef, 128, 128) |> TR

                gpu_c = copyto!(gpu_b, gpu_a)
                @test all(TR(Array(parent(gpu_b))) .== TR(Array(parent(gpu_a))))
                @test all(TR(Array(parent(gpu_c))) .== TR(Array(parent(gpu_a))))
                @test gpu_c isa TR
            end
        end

        @testset "istril" begin
            for rows in 3:4, cols in 3:4, diag in -4:4
                A = tril(rand(Float32, rows,cols), diag)
                B = AT(A)
                @test istril(A) == istril(B)
            end
        end

        @testset "istriu" begin
            for rows in 3:4, cols in 3:4, diag in -4:4
                A = triu(rand(Float32, rows,cols), diag)
                B = AT(A)
                @test istriu(A) == istriu(B)
            end
        end

        @testset "mul! + Triangular" begin
            @testset "trimatmul! ($TR x $T, $f)" for T in (Float32, ComplexF32), TR in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular), f in (identity, transpose, adjoint)
                if !(T in eltypes)
                    continue
                end
                n = 128
                A = AT(rand(T, n,n))
                b = AT(rand(T, n))
                Ct = AT(fill(T(NaN), n))
                C = fill(T(NaN), n)
                mul!(Ct, f(TR(A)), b)
                mul!(C, f(TR(collect(A))), collect(b))
                @test collect(Ct) ≈ C

                B = AT(rand(T, n, n))
                Ct = AT(fill(T(NaN), n, n))
                C = fill(T(NaN), n, n)
                mul!(Ct, f(TR(A)), B)
                mul!(C, f(TR(collect(A))), collect(B))
                @test collect(Ct) ≈ C
            end

            @testset "mattrimul ($TR x $T, $f)" for T in (Float32, ComplexF32), TR in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular), f in (identity, transpose, adjoint)
                if !(T in eltypes)
                    continue
                end
                n = 128
                A = AT(rand(T, n,n))
                B = AT(rand(T, n, n))
                Ct = AT(fill(T(NaN), n, n))
                C = fill(T(NaN), n, n)
                mul!(Ct, A, f(TR(B)))
                mul!(C, collect(A), f(TR(collect(B))))
                @test collect(Ct) ≈ C
            end
            @testset "matmul! with nonzero β ($TR1 x $TR2)" for T in (Float32, ComplexF32), TR1 in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular), TR2 in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular)
                if !(T in eltypes)
                    continue
                end
                n = 128
                A = AT(rand(T, n, n))
                B = AT(rand(T, n, n))
                Ct = AT(rand(T, n, n))
                C = collect(Ct)
                mul!(Ct, TR1(A), TR2(B), 1, -1)
                mul!(C, TR1(collect(A)), TR2(collect(B)), 1, -1)
                @test collect(Ct) ≈ C
                # general case: α≠1 and β≠0 together
                Et = AT(rand(T, n, n))
                E = collect(Et)
                mul!(Et, TR1(A), TR2(B), 3, 2)
                mul!(E, TR1(collect(A)), TR2(collect(B)), 3, 2)
                @test collect(Et) ≈ E
            end
            @testset "matmul! is write-only for β=0 ($TR1 x $TR2)" for T in (Float32, ComplexF32), TR1 in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular), TR2 in (UpperTriangular, LowerTriangular, UnitUpperTriangular, UnitLowerTriangular)
                if !(T in eltypes)
                    continue
                end
                n = 128
                A = AT(rand(T, n, n))
                B = AT(rand(T, n, n))
                # C starts as NaN: with β=0 it must be ignored (not multiplied), α≠1 to reach this path
                Ct = AT(fill(T(NaN), n, n))
                C = collect(Ct)
                mul!(Ct, TR1(A), TR2(B), 2, 0)
                mul!(C, TR1(collect(A)), TR2(collect(B)), 2, 0)
                @test collect(Ct) ≈ C
            end
        end

        @testset "mul! + Symmetric/Hermitian" begin
            # with BLAS eltypes these dispatch through generic_matmatmul_wrapper!'s
            # SymmHemmGeneric path, which must not end up in BLAS.symm!/hemm!
            @testset "$W{$T}, uplo=$uplo" for T in (Float32, ComplexF32), W in (Symmetric, Hermitian), uplo in (:U, :L)
                if !(T in eltypes)
                    continue
                end
                n = 128
                A = AT(rand(T, n, n))
                B = AT(rand(T, n, n))
                b = AT(rand(T, n))

                # matrix-matrix, wrapped on either side
                Ct = AT(zeros(T, n, n))
                C = zeros(T, n, n)
                mul!(Ct, W(A, uplo), B)
                mul!(C, W(collect(A), uplo), collect(B))
                @test collect(Ct) ≈ C

                mul!(Ct, B, W(A, uplo))
                mul!(C, collect(B), W(collect(A), uplo))
                @test collect(Ct) ≈ C

                # general case: α≠1 and β≠0 together
                Et = AT(rand(T, n, n))
                E = collect(Et)
                mul!(Et, W(A, uplo), B, 3, 2)
                mul!(E, W(collect(A), uplo), collect(B), 3, 2)
                @test collect(Et) ≈ E

                # matrix-vector
                ct = AT(zeros(T, n))
                c = zeros(T, n)
                mul!(ct, W(A, uplo), b)
                mul!(c, W(collect(A), uplo), collect(b))
                @test collect(ct) ≈ c
            end
        end
    end

    @testset "diagm" begin
        @testset "$elty" for elty in (Float32, ComplexF32)
            m = 128
            A = AT(rand(elty, m))
            B = AT(rand(elty, m - 1))
            diagA = diagm(A)
            diagB = diagm(1 => B)
            @test eltype(diagA) == elty
            @test eltype(diagB) == elty
            @test size(diagA) == (m, m)
            @test size(diagB) == (m, m)
            diagind_A = diagind(diagA, 0)
            diagind_B = diagind(diagB, 1)
            @test collect(diagA[diagind_A]) == collect(A)
            @test collect(diagB[diagind_B]) == collect(B)
        end
    end

    @testset "mul! + UniformScaling" begin
        @testset "$elty" for elty in (Float32, ComplexF32)
            if !(elty in eltypes)
                continue
            end
            n = 128
            s = rand(elty)
            I_s = UniformScaling(s)

            # Test vector operations
            a = AT(rand(elty, n))
            b = AT(rand(elty, n))
            b_copy = copy(b)

            # Test mul!(a, I*s, b) - should compute a = s * b
            mul!(a, I_s, b)
            @test collect(a) ≈ s .* collect(b_copy)

            # Test mul!(a, b, s) - should compute a = b * s
            a = AT(rand(elty, n))
            mul!(a, b, s)
            @test collect(a) ≈ collect(b_copy) .* s

            # Test matrix operations
            A = AT(rand(elty, n, n))
            B = AT(rand(elty, n, n))
            B_copy = copy(B)

            # Test mul!(A, I*s, B)
            mul!(A, I_s, B)
            @test collect(A) ≈ s .* collect(B_copy)

            # Test mul!(A, B, s)
            A = AT(rand(elty, n, n))
            mul!(A, B, s)
            @test collect(A) ≈ collect(B_copy) .* s
        end
    end

    @testset "lmul! and rmul!" begin
        @testset "$T ($a,$b)" for (a,b) in [((3,4),(4,3)), ((3,), (1,3)), ((1,3), (3))], T in eltypes
            @test compare(rmul!, AT, rand(T, a), Ref(rand(T)))
            @test compare(lmul!, AT, Ref(rand(T)), rand(T, b))
        end
    end

    @testset "axp{b}y" begin
        @testset "$T" for T in eltypes
            @test compare(axpby!, AT, Ref(rand(T)), rand(T,5), Ref(rand(T)), rand(T,5))
            @test compare(axpy!, AT, Ref(rand(T)), rand(T,5), rand(T,5))
        end
    end

    @testset "dot" begin
        @testset "$T" for T in eltypes
            @test compare(dot, AT, rand(T,5), rand(T, 5))
        end
    end

    @testset "rotate!" begin
        @testset "$T" for T in eltypes
            @test compare(rotate!, AT, rand(T,5), rand(T,5), Ref(rand(real(T))), Ref(rand(T)))
        end
    end

    @testset "reflect!" begin
        @testset "$T" for T in eltypes
            @test compare(reflect!, AT, rand(T,5), rand(T,5), Ref(rand(real(T))), Ref(rand(T)))
        end
    end

    @testset "iszero and isone" begin
        @testset "$T" for T in eltypes
            A = one(AT(rand(T, 2, 2)))
            @test isone(A)
            @test iszero(A) == false

            A = zero(AT(rand(T, 2, 2)))
            @test iszero(A)
            @test isone(A) == false
        end
    end
end

@testsuite "linalg/kron" (AT, eltypes) -> begin
    @testset "$T, $opa, $opb" for T in eltypes, opa in (vec, identity, transpose, adjoint), opb in (vec, identity, transpose, adjoint)
        @test compare(kron, AT, opa(rand(T, 16, 32)), opb(rand(T, 64, 8)))
    end
end

@testsuite "linalg/diagonal" (AT, eltypes) -> begin
    @testset "Array + Diagonal" begin
        n = 128
        A = AT(rand(Float32, (n,n)))
        d = AT(rand(Float32, n))
        D = Diagonal(d)
        B = A + D
        @test collect(B) ≈ collect(A) + collect(D)
    end

    @testset "copy diagonal" begin
        a = AT(rand(Float32, 10))
        D = Diagonal(a)
        C = copy(D)
        @test C isa Diagonal
        @test C.diag isa AT
        @test collect(D) == collect(C)
    end

    @testset "cholesky + Diagonal" begin
        n = 128
        # Add one in order prevent failures due to random numbers being zero
        d = AT(zeros(Float32, n) .+ one(Float32))
        D = Diagonal(d)
        F = collect(D)
        @test collect(cholesky(D).U) ≈ collect(cholesky(F).U)
        @test collect(cholesky(D).L) ≈ collect(cholesky(F).L)

        d = AT([1f0, 2f0, -1f0, 0f0])
        D = Diagonal(d)
        @test cholesky(D, check = false).info == 3
    end

    @testset "\\ + Diagonal" begin
        n = 128
        d = AT(rand(Float32, n))
        D = Diagonal(d)
        b = AT(rand(Float32, n))
        B = AT(rand(Float32, n, n))
        @test collect(D \ b) ≈ Diagonal(collect(d)) \ collect(b)
        @test collect(D \ B) ≈ Diagonal(collect(d)) \ collect(B)

        d = ones(Float32, n)
        d[rand(1:n)] = 0
        d = AT(d)
        D = Diagonal(d)
        @test_throws SingularException D \ B
    end

    #TODO: Refactor
    @testset "mul! + Diagonal" begin
        @testset "$elty" for elty in (Float32, ComplexF32)
            if !(elty in eltypes)
                continue
            end
            n = 128
            d = AT(rand(elty, n))
            D = Diagonal(d)
            B = AT(rand(elty, n, n))
            X = AT(zeros(elty, n, n))
            Y = zeros(elty, n, n)
            α = rand(elty)
            β = rand(elty)
            mul!(X, D, B)
            mul!(Y, Diagonal(collect(d)), collect(B))
            @test collect(X) ≈ Y
            mul!(X, D, adjoint(B))
            mul!(Y, Diagonal(collect(d)), collect(adjoint(B)))
            @test collect(X) ≈ Y
            mul!(X, D, B, α, β)
            mul!(Y, Diagonal(collect(d)), collect(B), α, β)
            @test collect(X) ≈ Y
            mul!(X, B, D)
            mul!(Y, collect(B), Diagonal(collect(d)))
            @test collect(X) ≈ Y
            mul!(X, B, D, α, β)
            mul!(Y, collect(B), Diagonal(collect(d)), α, β)
            @test collect(X) ≈ Y
            a = AT(rand(elty, n))
            b = AT(rand(elty, n))
            C = Diagonal(d)
            B = Diagonal(b)
            A = Diagonal(a)
            mul!(C, A, B)
            @test collect(C.diag) ≈ collect(A.diag) .* collect(B.diag)
            C_diag = collect(C.diag)
            mul!(C, A, B, α, β)
            @test collect(C.diag) ≈ α * collect(A.diag) .* collect(B.diag) .+ β * C_diag
            a = AT(diagm(rand(elty, n)))
            b = AT(diagm(rand(elty, n)))
            C = Diagonal(d)
            mul!(C, a, b)
            @test collect(C) ≈ Diagonal(collect(a) * collect(b))
            C_coll = collect(C)
            mul!(C, a, b, α, β)
            @test collect(C) ≈ Diagonal(α * collect(a) * collect(b) + β * C_coll)
            a = transpose(AT(diagm(rand(elty, n))))
            b = adjoint(AT(diagm(rand(elty, n))))
            C = Diagonal(d)
            mul!(C, a, b)
            @test collect(C) ≈ Diagonal(collect(a) * collect(b))
            C_coll = collect(C)
            mul!(C, a, b, α, β)
            @test collect(C) ≈ Diagonal(α * collect(a) * collect(b)) + β * C_coll
        end
    end

    @testset "ldiv! + Diagonal" begin
        n = 128
        d = AT(rand(Float32, n))
        D = Diagonal(d)
        b = AT(rand(Float32, n))
        B = AT(rand(Float32, n, n))
        X = AT(zeros(Float32, n, n))
        Y = zeros(Float32, n, n)
        ldiv!(X, D, B)
        ldiv!(Y, Diagonal(collect(d)), collect(B))
        @test collect(X) ≈ Y
        ldiv!(D, B)
        @test collect(B) ≈ collect(X)

        d = ones(Float32, n)
        d[rand(1:n)] = 0
        d = AT(d)
        D = Diagonal(d)
        B = AT(rand(Float32, n, n))

        @test_throws SingularException ldiv!(X, D, B)

        # two-argument version throws SingularException
        @test_throws SingularException ldiv!(D, B)
    end

    @testset "$f with diagonal $d" for f in (triu, triu!, tril, tril!),
                                        d in -2:2
        A = randn(Float32, 10, 10)
        @test compare(f, AT, A, d)

        A_empty = randn(Float32, 0, 0)
        @test compare(f, AT, A_empty, d)
    end

    @testset "rmul!/lmul! with diagonal and number" begin
        n = 32
        h_d = rand(Float32, n)
        h_D = Diagonal(h_d)
        d = AT(h_d)
        D = Diagonal(d)
        a = rand(Float32)
        rmul!(D, a)
        rmul!(h_D, a)
        @test collect(D) ≈ h_D
        lmul!(a, D)
        lmul!(a, h_D)
        @test collect(D) ≈ h_D
    end
end

@testsuite "linalg/mul!/vector-matrix" (AT, eltypes)->begin
    @testset "$T gemv y := $f(A) * x * a + y * b" for f in (identity, transpose, adjoint), T in eltypes
        y, A, x = rand(T, 4), rand(T, 4, 4), rand(T, 4)

        # workaround for https://github.com/JuliaLang/julia/issues/35163#issue-584248084
        T <: Integer && (y .%= T(10); A .%= T(10); x .%= T(10))

        @test compare(*, AT, f(A), x)
        @test compare(mul!, AT, y, f(A), x)
        @test compare(mul!, AT, y, f(A), x, Ref(T(4)), Ref(T(5)))
        @test typeof(AT(rand(T, 3, 3)) * AT(rand(T, 3))) <: AbstractVector

        if f !== identity
            @test compare(mul!, AT, rand(T, 2,2), rand(T, 2,1), f(rand(T, 2)))
        end
    end
end

@testsuite "linalg/mul!/matrix-matrix" (AT, eltypes)->begin
    @testset "$T gemm C := $f(A) * $g(B) * a + C * b" for f in (identity, transpose, adjoint), g in (identity, transpose, adjoint), T in eltypes
        A, B, C = rand(T, 4, 4), rand(T, 4, 4), rand(T, 4, 4)

        # workaround for https://github.com/JuliaLang/julia/issues/35163#issue-584248084
        T <: Integer && (A .%= T(10); B .%= T(10); C .%= T(10))

        @test compare(*, AT, f(A), g(B))
        @test compare(mul!, AT, C, f(A), g(B))
        @test compare(mul!, AT, C, f(A), g(B), Ref(T(4)), Ref(T(5)))
        @test typeof(AT(rand(T, 3, 3)) * AT(rand(T, 3, 3))) <: AbstractMatrix
    end
    @testset "$(complex(T)), $(complex(T)), $T gemm C := A * B * a + C * b" for T in filter(T-><:(T, Real) && <:(T, AbstractFloat), eltypes)
        Tc = complex(T)
        A, B, C = rand(Tc, 4, 4), rand(T, 4, 4), rand(Tc, 4, 4)

        @test compare(*, AT, A, B)
        @test compare(mul!, AT, C, A, B)
        @test compare(mul!, AT, C, A, B, Ref(T(4)), Ref(T(5)))
        @test typeof(AT(rand(Tc, 3, 3)) * AT(rand(T, 3, 3))) <: AbstractMatrix
    end
    @testset "$T with views" for T in eltypes
        A = rand(T, 10, 10)
        v1 = @view(A[:, 1:5])
        v2 = @view(A[1:5, :])
        dA = AT(A)
        dv1 = @view(dA[:, 1:5])
        dv2 = @view(dA[1:5, :])
        @test Array(v1) * Array(v2) ≈ Array(v1 * v2)
    end
end

@testsuite "linalg/mul!/integer-accumulate" (AT, eltypes)->begin
    # products must be formed in the wide accumulator type, not the narrow input type, else
    # narrow-integer products overflow.
    gpu = AT <: AbstractGPUArray
    @testset "$Tin -> $Tout" for (Tin, Tout) in ((Int16, Int32), (Int16, Int64), (Int32, Int64))
        Tin in eltypes || continue
        n = 16
        hi = Tin(4) * isqrt(typemax(Tin))       # |a*b| reliably exceeds typemax(Tin)
        rng = (-hi):hi
        A, B, x = rand(rng, n, n), rand(rng, n, n), rand(rng, n)
        dA, dB, dx = AT(A), AT(B), AT(x)

        if gpu || VERSION >= v"1.11"
            C = AT(zeros(Tout, n, n))
            mul!(C, dA, dB)
            @test Array(C) == Tout.(Int64.(A) * Int64.(B))
        end
        if gpu # JuliaLang/LinearAlgebra.jl#1659
            c = AT(zeros(Tout, n))
            mul!(c, dA, dx)
            @test Array(c) == Tout.(Int64.(A) * Int64.(x))
        end
    end
end

# a container-like element type that doesn't promote with its own scalars
struct Duo{T}
    a::T
    b::T
end
Base.zero(::Type{Duo{T}}) where {T} = Duo(zero(T), zero(T))
Base.zero(x::Duo) = zero(typeof(x))
Base.:(+)(x::Duo, y::Duo) = Duo(x.a + y.a, x.b + y.b)
Base.:(*)(x::Duo, y::Number) = Duo(x.a * y, x.b * y)
Base.:(*)(x::Number, y::Duo) = Duo(x * y.a, x * y.b)

@testsuite "linalg/mul!/mixed-eltype" (AT, eltypes)->begin
    # mixed element types that have no common promotion type
    @testset "Duo{$T} * $T" for T in filter(isfloattype, eltypes)
        n = 4
        A = [Duo(T(i), T(2i)) for i in 1:n, _ in 1:n]
        B = T.(reshape(1:n^2, n, n))

        @test Array(AT(A) * AT(B)) == A * B
        @test Array(AT(B) * AT(A)) == B * A

        @testset "$W" for W in (UpperTriangular, LowerTriangular,
                                UnitUpperTriangular, UnitLowerTriangular)
            @test Array(W(AT(B)) * AT(A)) == W(B) * A
            @test Array(AT(A) * W(AT(B))) == A * W(B)
        end
    end
end

@testsuite "linalg/norm" (AT, eltypes)->begin
    @testset "$p-norm($sz x $T)" for sz in [(2,), (2,0), (2,2,2)],
                                     p in Any[0, 0.5, 1, 1.5, 2, Inf, -Inf],
                                     T in eltypes
        if T == Int8
            continue
        end
        if !in(float(real(T)), eltypes)
            # norm promotes to float, so make sure that type is supported
            continue
        end
        range = real(T) <: Integer ? (T.(1:10)) : T # prevent integer overflow
        arr = rand(range, sz)
        @test compare(norm, AT, arr, Ref(p))
        @test isrealfloattype(typeof(norm(AT(arr), p)))
        if !isempty(arr) && real(T) <: AbstractFloat && !iszero(p) && !isinf(p)
            # Hit anti-under/overflow rescaling
            @allowscalar arr[1] = floatmax(real(T)) / 2
            @test compare(norm, AT, arr, Ref(p))
            arr .= floatmin(real(T)) * 2
            @test compare(norm, AT, arr, Ref(p))
        end
    end
    @testset "$p-opnorm($sz x $T)" for sz in [(2, 0), (2, 3)],
                                     p in Any[1, Inf],
                                     T in eltypes
        if T == Int8
            continue
        end
        if !in(float(real(T)), eltypes)
            # norm promotes to float, so make sure that type is supported
            continue
        end
        range = real(T) <: Integer ? (T.(1:10)) : T # prevent integer overflow
        mat = rand(range, sz)
        @test compare(opnorm, AT, mat, Ref(p))
        @test isrealfloattype(typeof(opnorm(AT(mat), p)))
    end
    @testset "normalize($T)" for T in eltypes
        if !in(float(real(T)), eltypes)
            continue
        end
        range = real(T) <: Integer ? (T.(1:10)) : T
        arr = rand(range, 10)
        @test compare(normalize, AT, arr)
        @test compare(normalize, AT, arr, Ref(1))
    end
    # Wrapped GPU arrays (e.g. SubArray) must also avoid scalar iteration.
    @testset "$p-norm(view, $sz x $T)" for sz in [(5,), (5, 5), (4, 4, 4)],
                                           p in Any[0, 1, 2, Inf],
                                           T in eltypes
        if T == Int8
            continue
        end
        if !in(float(real(T)), eltypes)
            continue
        end
        range = real(T) <: Integer ? (T.(1:10)) : T
        arr = rand(range, sz)
        indices = map(d -> 2:d-1, sz)
        @test compare(x -> norm(view(x, indices...), p), AT, arr)
    end
    @testset "normalize(view, $T)" for T in eltypes
        if !in(float(real(T)), eltypes)
            continue
        end
        range = real(T) <: Integer ? (T.(1:10)) : T
        arr = rand(range, 10)
        @test compare(x -> normalize(view(x, 2:9)), AT, arr)
    end
end

@testsuite "linalg/NaN_false" (AT, eltypes)->begin
    eltypes = filter(T -> isfloattype(T), eltypes) # only floats have NaN
    if AT <: AbstractGPUArray
        @testset "rmul! / lmul!" for T in eltypes
            y = invoke(rmul!, Tuple{AbstractGPUArray, Number}, adapt(AT, fill(NaN_T(T), 3)), false)
            @test !any(isnan, collect(y))
            y = invoke(lmul!, Tuple{Number, AbstractGPUArray}, false, adapt(AT, fill(NaN_T(T), 3)))
            @test !any(isnan, collect(y))
        end

        @testset "axp{b}y!" for T in eltypes
            y = invoke(axpby!, Tuple{Number, AbstractGPUArray, Number, AbstractGPUArray}, false, adapt(AT, fill(NaN_T(T), 3)), false, adapt(AT, fill(NaN_T(T), 3)))
            @test !any(isnan, collect(y))
            y = invoke(axpy!, Tuple{Number, AbstractGPUArray, AbstractGPUArray}, false, adapt(AT, fill(NaN_T(T), 3)), adapt(AT, rand(T, 3)))
            @test !any(isnan, collect(y))
        end

        @testset "rotate! / reflect!" for T in eltypes
            x, y = invoke(rotate!, Tuple{AbstractGPUArray, AbstractGPUArray, Number, Number}, adapt(AT, fill(NaN_T(T), 3)), adapt(AT, fill(NaN_T(T), 3)), false, false)
            @test !any(isnan, collect(x))
            @test !any(isnan, collect(y))
            x, y = invoke(reflect!, Tuple{AbstractGPUArray, AbstractGPUArray, Number, Number}, adapt(AT, fill(NaN_T(T), 3)), adapt(AT, fill(NaN_T(T), 3)), false, false)
            @test !any(isnan, collect(x))
            @test !any(isnan, collect(y))
        end

        @testset "generic_matmatmul!" for T in eltypes
            y = invoke(GPUArrays.generic_matmatmul!, Tuple{AbstractArray, AbstractArray, AbstractArray, Number, Number}, adapt(AT, fill(NaN_T(T), 3, 3)), adapt(AT, fill(NaN_T(T), 3, 3)), adapt(AT, fill(NaN_T(T), 3, 3)), false, false)
            @test !any(isnan, collect(y))
        end
    end
end

@testsuite "linalg/kron_diagonal" (AT, eltypes) -> begin
    for T in filter(T -> T == Float32 || T == Float64, eltypes)
        n, m = 16, 8
        a, b = rand(T, n), rand(T, m)

        # Diagonal*Diagonal
        R = kron(Diagonal(adapt(AT, a)), Diagonal(adapt(AT, b)))
        @test R isa Diagonal
        @test Array(R.diag) ≈ kron(a, b)

        # Diagonal*Dense
        B = rand(T, m, m)
        R2 = kron(Diagonal(adapt(AT, a)), adapt(AT, B))
        @test Array(R2) ≈ kron(Matrix(Diagonal(a)), B)

        # Dense*Diagonal
        A = rand(T, n, n)
        R3 = kron(adapt(AT, A), Diagonal(adapt(AT, b)))
        @test Array(R3) ≈ kron(A, Matrix(Diagonal(b)))

        # kron! Diagonal*Diagonal
        C1 = Diagonal(adapt(AT, zeros(T, n * m)))
        kron!(C1, Diagonal(adapt(AT, a)), Diagonal(adapt(AT, b)))
        @test C1 isa Diagonal
        @test Array(C1.diag) ≈ kron(a, b)

        # kron! Diagonal*Dense
        C2 = adapt(AT, zeros(T, n * m, n * m))
        kron!(C2, Diagonal(adapt(AT, a)), adapt(AT, B))
        @test Array(C2) ≈ kron(Matrix(Diagonal(a)), B)

        # kron! Dense*Diagonal
        C3 = adapt(AT, zeros(T, n * m, n * m))
        kron!(C3, adapt(AT, A), Diagonal(adapt(AT, b)))
        @test Array(C3) ≈ kron(A, Matrix(Diagonal(b)))
    end
end

module GPUArrays

using KernelAbstractions
using Serialization
using Random
using LinearAlgebra
using Printf

using LinearAlgebra.BLAS
using Base.Cartesian

using Adapt
using LLVM.Interop

using Reexport
@reexport using GPUArraysCore

using KernelAbstractions

# device functionality
include("device/abstractarray.jl")
include("device/sparse.jl")

# host abstractions
include("host/abstractarray.jl")
include("host/construction.jl")
## integrations and specialized methods
include("host/base.jl")
include("host/indexing.jl")
include("host/broadcast.jl")
include("host/mapreduce.jl")
include("host/linalg.jl")
include("host/math.jl")
include("host/random.jl")
include("host/quirks.jl")
include("host/uniformscaling.jl")
include("host/statistics.jl")
include("host/sparse.jl")
include("host/alloc_cache.jl")

include("deprecated.jl")

end # module

# test suite that can be used for all packages inheriting from GPUArrays
#
# use this by either calling `test`, or inspecting the dictionary `tests`

module TestSuite

export supported_eltypes

using GPUArrays

using KernelAbstractions
using LinearAlgebra
using JLD2
using Random
using Test

using Adapt

test_result(@nospecialize(a), @nospecialize(b); kwargs...) = a == b
test_result(::Nothing, ::Nothing; kwargs...) = true
test_result(::Nothing, @nospecialize(b); kwargs...) = false
test_result(@nospecialize(a), ::Nothing; kwargs...) = false
test_result(a::Number, b::Number; kwargs...) = ≈(a, b; kwargs...)
test_result(a::Missing, b::Missing; kwargs...) = true
test_result(a::Number, b::Missing; kwargs...) = false
test_result(a::Missing, b::Number; kwargs...) = false
# Branch on eltype at runtime so one compiled method body handles every
# (T, ndims) combination — the `where T` version would still instantiate
# per element type even under @nospecialize.
function test_result(@nospecialize(a::AbstractArray), @nospecialize(b::AbstractArray); kwargs...)
    T = eltype(a)
    # The original `where T<:…` methods required matching eltypes; preserve
    # that by falling through to `a == b` when they diverge.
    if eltype(b) === T
        if T <: Number
            return ≈(collect(a), collect(b); kwargs...)
        elseif T <: NTuple{N,<:Number} where {N}
            ET = eltype(T)
            return ≈(reinterpret(ET, collect(a)), reinterpret(ET, collect(b)); kwargs...)
        end
    end
    a == b
end
function test_result(@nospecialize(as::Tuple), @nospecialize(bs::Tuple); kwargs...)
    length(as) == length(bs) || return false
    all(zip(as, bs)) do (a, b)
        test_result(a, b; kwargs...)
    end
end

function compare(@nospecialize(f), AT::Type{<:AbstractGPUArray}, @nospecialize(xs...); kwargs...)
    # copy on the CPU, adapt on the GPU, but keep Ref's
    cpu_in = map(x -> isa(x, Base.RefValue) ? x[] : deepcopy(x), xs)
    gpu_in = map(x -> isa(x, Base.RefValue) ? x[] : adapt(AT, x), xs)

    cpu_out = f(cpu_in...)
    gpu_out = f(gpu_in...)

    test_result(cpu_out, gpu_out; kwargs...)
end

function compare(@nospecialize(f), AT::Type{<:Array}, @nospecialize(xs...); kwargs...)
    # no need to actually run this tests: we have nothing to compare against,
    # and we'll run it on a CPU array anyhow when comparing to a GPU array.
    #
    # this method exists so that we can at least run the test suite with Array,
    # and make sure we cover other tests (that don't call `compare`) too.
    return true
end

# element types that are supported by the array type
supported_eltypes(AT, test) = supported_eltypes(AT)
supported_eltypes(AT) = supported_eltypes()
supported_eltypes() = (Int16, Int32, Int64,
                       Float16, Float32, Float64,
                       ComplexF16, ComplexF32, ComplexF64,
                       Complex{Int16}, Complex{Int32}, Complex{Int64})

# derived sparse container types that are supported by the array type
sparse_types(::Type{AT}) where {AT} = ()

# some convenience predicates for filtering test eltypes
isrealtype(T) = T <: Real
iscomplextype(T) = T <: Complex
isrealfloattype(T) = T <: AbstractFloat
isfloattype(T) = T <: AbstractFloat || T <: Complex{<:AbstractFloat}
NaN_T(T::Type{<:AbstractFloat}) = T(NaN)
NaN_T(T::Type{<:Complex{<:AbstractFloat}}) = T(NaN, NaN)

# list of tests
const tests = Dict()
macro testsuite(name, ex)
    safe_name = lowercase(replace(replace(name, " "=>"_"), "/"=>"_"))
    fn = Symbol("test_$(safe_name)")
    quote
        # the supported element types can be overrided by passing in a different set,
        # or by specializing the `supported_eltypes` function on the array type and test.
        $(esc(fn))(AT; eltypes=supported_eltypes(AT, $(esc(fn)))) = $(esc(ex))(AT, eltypes)

        @assert !haskey(tests, $name)
        tests[$name] = $fn
    end
end

include("testsuite/construction.jl")
include("testsuite/indexing.jl")
include("testsuite/base.jl")
include("testsuite/vector.jl")
include("testsuite/reductions.jl")
include("testsuite/broadcasting.jl")
include("testsuite/linalg.jl")
include("testsuite/math.jl")
include("testsuite/random.jl")
include("testsuite/uniformscaling.jl")
include("testsuite/statistics.jl")
include("testsuite/sparse.jl")
include("testsuite/alloc_cache.jl")
include("testsuite/jld2ext.jl")

"""
Runs the entire GPUArrays test suite on array type `AT`
"""
function test(AT::Type)
    for (name, fun) in tests
        code = quote
            $fun($AT)
        end
        @eval @testset $name $code
    end
end

end

# on-device sparse array types
# should be excluded from coverage counts
# COV_EXCL_START
using SparseArrays

# NOTE: this functionality is currently very bare-bones, only defining the array types
#       without any device-compatible sparse array functionality


# core types

export GPUSparseDeviceVector, GPUSparseDeviceMatrixCSC, GPUSparseDeviceMatrixCSR,
       GPUSparseDeviceMatrixBSR, GPUSparseDeviceMatrixCOO

abstract type AbstractGPUSparseDeviceMatrix{Tv, Ti} <: AbstractSparseMatrix{Tv, Ti} end


struct GPUSparseDeviceVector{Tv,Ti,Vi,Vv, A} <: AbstractSparseVector{Tv,Ti}
    iPtr::Vi
    nzVal::Vv
    len::Int
    nnz::Ti
end

Base.length(g::GPUSparseDeviceVector) = g.len
Base.size(g::GPUSparseDeviceVector) = (g.len,)
SparseArrays.nnz(g::GPUSparseDeviceVector) = g.nnz
SparseArrays.nonzeroinds(g::GPUSparseDeviceVector) = g.iPtr
SparseArrays.nonzeros(g::GPUSparseDeviceVector) = g.nzVal

struct GPUSparseDeviceMatrixCSC{Tv,Ti,Vi,Vv,A} <: AbstractGPUSparseDeviceMatrix{Tv, Ti}
    colPtr::Vi
    rowVal::Vi
    nzVal::Vv
    dims::NTuple{2,Int}
    nnz::Ti
end

Base.length(g::GPUSparseDeviceMatrixCSC) = prod(g.dims)
Base.size(g::GPUSparseDeviceMatrixCSC) = g.dims
SparseArrays.nnz(g::GPUSparseDeviceMatrixCSC) = g.nnz
SparseArrays.rowvals(g::GPUSparseDeviceMatrixCSC) = g.rowVal
SparseArrays.getcolptr(g::GPUSparseDeviceMatrixCSC) = g.colPtr
SparseArrays.nzrange(g::GPUSparseDeviceMatrixCSC, col::Integer) = @inbounds SparseArrays.getcolptr(g)[col]:(SparseArrays.getcolptr(g)[col+1]-1)
SparseArrays.nonzeros(g::GPUSparseDeviceMatrixCSC) = g.nzVal

const GPUSparseDeviceColumnView{Tv, Ti, Vi, Vv, A} = SubArray{Tv, 1, GPUSparseDeviceMatrixCSC{Tv, Ti, Vi, Vv, A}, Tuple{Base.Slice{Base.OneTo{Int}}, Int}}
function SparseArrays.nonzeros(x::GPUSparseDeviceColumnView)
    rowidx, colidx = parentindices(x)
    A = parent(x)
    @inbounds y = view(SparseArrays.nonzeros(A), SparseArrays.nzrange(A, colidx))
    return y
end

function SparseArrays.nonzeroinds(x::GPUSparseDeviceColumnView)
    rowidx, colidx = parentindices(x)
    A = parent(x)
    @inbounds y = view(SparseArrays.rowvals(A), SparseArrays.nzrange(A, colidx))
    return y
end
SparseArrays.rowvals(x::GPUSparseDeviceColumnView) = SparseArrays.nonzeroinds(x)

function SparseArrays.nnz(x::GPUSparseDeviceColumnView)
    rowidx, colidx = parentindices(x)
    A = parent(x)
    return length(SparseArrays.nzrange(A, colidx))
end

struct GPUSparseDeviceMatrixCSR{Tv,Ti,Vi,Vv,A} <: AbstractGPUSparseDeviceMatrix{Tv,Ti}
    rowPtr::Vi
    colVal::Vi
    nzVal::Vv
    dims::NTuple{2, Int}
    nnz::Ti
end

@inline function _getindex(arg::Union{GPUSparseDeviceMatrixCSR{Tv},
                                      GPUSparseDeviceMatrixCSC{Tv},
                                      GPUSparseDeviceVector{Tv}}, I, ptr)::Tv where {Tv}
    if ptr == 0
        return zero(Tv)
    else
        return @inbounds arg.nzVal[ptr]::Tv
    end
end

struct GPUSparseDeviceMatrixBSR{Tv,Ti,Vi,Vv,A} <: AbstractGPUSparseDeviceMatrix{Tv,Ti}
    rowPtr::Vi
    colVal::Vi
    nzVal::Vv
    dims::NTuple{2,Int}
    blockDim::Ti
    dir::Char
    nnz::Ti
end

struct GPUSparseDeviceMatrixCOO{Tv,Ti,Vi,Vv, A} <: AbstractGPUSparseDeviceMatrix{Tv,Ti}
    rowInd::Vi
    colInd::Vi
    nzVal::Vv
    dims::NTuple{2,Int}
    nnz::Ti
end

Base.length(g::AbstractGPUSparseDeviceMatrix) = prod(g.dims)
Base.size(g::AbstractGPUSparseDeviceMatrix) = g.dims
SparseArrays.nnz(g::AbstractGPUSparseDeviceMatrix) = g.nnz
SparseArrays.getnzval(g::AbstractGPUSparseDeviceMatrix) = g.nzVal

struct GPUSparseDeviceArrayCSR{Tv, Ti, Vi, Vv, N, M, A} <: AbstractSparseArray{Tv, Ti, N}
    rowPtr::Vi
    colVal::Vi
    nzVal::Vv
    dims::NTuple{N, Int}
    nnz::Ti
end

function GPUSparseDeviceArrayCSR{Tv, Ti, Vi, Vv, N}(rowPtr::Vi, colVal::Vi, nzVal::Vv, dims::NTuple{N,<:Integer}) where {Tv, Ti<:Integer, M, Vi<:AbstractDeviceArray{<:Integer,M}, Vv<:AbstractDeviceArray{Tv, M}, N}
    @assert M == N - 1 "GPUSparseDeviceArrayCSR requires ndims(rowPtr) == ndims(colVal) == ndims(nzVal) == length(dims) - 1"
    GPUSparseDeviceArrayCSR{Tv, Ti, Vi, Vv, N, M}(rowPtr, colVal, nzVal, dims, length(nzVal))
end

Base.length(g::GPUSparseDeviceArrayCSR) = prod(g.dims)
Base.size(g::GPUSparseDeviceArrayCSR) = g.dims
SparseArrays.nnz(g::GPUSparseDeviceArrayCSR) = g.nnz
SparseArrays.getnzval(g::GPUSparseDeviceArrayCSR) = g.nzVal

# input/output

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceVector)
    println(io, "$(length(A))-element device sparse vector at:")
    println(io, "  iPtr: $(A.iPtr)")
    print(io,   "  nzVal: $(A.nzVal)")
end

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceMatrixCSR)
    println(io, "$(length(A))-element device sparse matrix CSR at:")
    println(io, "  rowPtr: $(A.rowPtr)")
    println(io, "  colVal: $(A.colVal)")
    print(io,   "  nzVal:  $(A.nzVal)")
end

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceMatrixCSC)
    println(io, "$(length(A))-element device sparse matrix CSC at:")
    println(io, "  colPtr: $(A.colPtr)")
    println(io, "  rowVal: $(A.rowVal)")
    print(io,   "  nzVal:  $(A.nzVal)")
end

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceMatrixBSR)
    println(io, "$(length(A))-element device sparse matrix BSR at:")
    println(io, "  rowPtr: $(A.rowPtr)")
    println(io, "  colVal: $(A.colVal)")
    print(io,   "  nzVal:  $(A.nzVal)")
end

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceMatrixCOO)
    println(io, "$(length(A))-element device sparse matrix COO at:")
    println(io, "  rowPtr: $(A.rowPtr)")
    println(io, "  colInd: $(A.colInd)")
    print(io,   "  nzVal:  $(A.nzVal)")
end

function Base.show(io::IO, ::MIME"text/plain", A::GPUSparseDeviceArrayCSR)
    println(io, "$(length(A))-element device sparse array CSR at:")
    println(io, "  rowPtr: $(A.rowPtr)")
    println(io, "  colVal: $(A.colVal)")
    print(io,   "  nzVal:  $(A.nzVal)")
end

# COV_EXCL_STOP

using Statistics

function Statistics.varm(A::AbstractGPUArray{<:Real}, M::AbstractArray{<:Real};
                         dims, corrected::Bool=true)
    T = float(eltype(A))
    λ = convert(T, inv(_mean_denom(A, dims) - corrected))
    #B = (A .- M).^2
    # NOTE: the above broadcast promotes to Float64 and uses power_by_squaring...
    B = Broadcast.broadcasted(A, M) do a, m
        x = (a - m)
        λ * x * x
    end
    sum(Broadcast.instantiate(B); dims)
end

Statistics.stdm(A::AbstractGPUArray{<:Real},m::AbstractArray{<:Real}, dim::Int; corrected::Bool=true) =
    sqrt.(varm(A,m;dims=dim,corrected=corrected))

Statistics._std(A::AbstractGPUArray, corrected::Bool, mean, dims) =
    sqrt.(Statistics.var(A; corrected=corrected, mean=mean, dims=dims))

Statistics._std(A::AbstractGPUArray, corrected::Bool, mean, ::Colon) =
    sqrt.(Statistics.var(A; corrected=corrected, mean=mean, dims=:))

# Revert https://github.com/JuliaLang/Statistics.jl/pull/25
Statistics._mean(A::AbstractGPUArray, ::Colon)    = sum(A) / length(A)
Statistics._mean(f, A::AbstractGPUArray, ::Colon) = sum(f, A) / length(A)

function Statistics._mean(A::AbstractGPUArray, dims)
    T = float(eltype(A))
    λ = convert(T, inv(_mean_denom(A, dims)))
    sum(Base.Fix1(*,λ), A; dims)
end
function Statistics._mean(f, A::AbstractGPUArray, dims)
    T = float(eltype(A))
    λ = convert(T, inv(_mean_denom(A, dims)))
    sum(Base.Fix1(*,λ) ∘ f, A; dims)
end

function Statistics.covzm(x::AbstractGPUMatrix, vardim::Int=1; corrected::Bool=true)
    C = Statistics.unscaled_covzm(x, vardim)
    T = promote_type(typeof(one(eltype(C)) / 1), eltype(C))
    A = convert(AbstractArray{T}, C)
    b = 1//(size(x, vardim) - corrected)
    A .*= b
    return A
end

function Statistics.cov2cor!(C::AbstractGPUMatrix{T}, xsd::AbstractGPUArray) where T
    nx = length(xsd)
    size(C) == (nx, nx) || throw(DimensionMismatch("inconsistent dimensions"))
    tril!(C, -1)
    C += adjoint(C)
    C = Statistics.clampcor.(C ./ (xsd * xsd'))
    C[diagind(C)] .= oneunit(T)
    return C
end

function Statistics.corzm(x::AbstractGPUMatrix, vardim::Int=1)
    c = Statistics.unscaled_covzm(x, vardim)
    return Statistics.cov2cor!(c, sqrt.(diag(c)))
end

_mean_denom(x::AbstractArray, dims::Integer) = size(x, dims)
_mean_denom(x::AbstractArray, dims::Colon) = length(x)
_mean_denom(x::AbstractArray, dims) = prod(size(x,d) for d in unique(dims); init=1)

@kernel function cartesian_iter(res, A)
    i = @index(Global, Cartesian)
    res[i] = A[i]
end

@kernel function clmap!(f, out, b)
    i = @index(Global, Linear) # get the kernel index it gets scheduled on
    out[i] = f(b[i])
end

@kernel function ntuple_test(result, ::Val{N}) where N
    result[1] = ntuple(Val(N)) do i
        Float32(i) * 77f0
    end
end

@kernel function ntuple_closure(result, ::Val{N}, testval) where N
    result[1] = ntuple(Val(N)) do i
        Float32(i) * testval
    end
end

@testsuite "base" (AT, eltypes)->begin
    if AT <: AbstractGPUArray
        @testset "storage" begin
          x = AT(rand(Float32, 10))
          @test GPUArrays.storage(x) isa GPUArrays.DataRef
          GPUArrays.unsafe_free!(x)
        end
    end

    @testset "issorted" begin
        # basic sorted / unsorted
        @test compare(issorted, AT, [1, 2, 3, 4])
        @test compare(x -> !issorted(x), AT, [1, 3, 2, 4])

        # reverse ordering
        @test compare(x -> issorted(x; rev = true), AT, [4, 3, 2, 1])
        @test compare(x -> !issorted(x; rev = true), AT, [1, 2, 3])

        # custom lt
        @test compare(x -> issorted(x; lt = >), AT, [3, 2, 1])
        @test compare(x -> !issorted(x; lt = >), AT, [1, 2, 3])

        # by = abs
        @test compare(x -> issorted(x; by = abs), AT, [-1, -2, -3])
        @test compare(x -> !issorted(x; by = abs), AT, [-1, -3, -2])

        # order keyword normalization
        @test compare(
            x -> issorted(x; order = Base.Order.Reverse),
            AT,
            [3, 2, 1],
        )

        @test compare(
            x -> !issorted(x; order = Base.Order.Reverse),
            AT,
            [1, 2, 3],
        )

        # edge cases
        @test compare(issorted, AT, Int[])
        @test compare(issorted, AT, [42])

        # unsupported custom orderings
        AT <: AbstractGPUArray && @testset "unsupported orderings" begin
            x = AT([1, 2, 3])
            @test_throws ArgumentError issorted(
                x;
                order = Base.Order.By(identity),
            )
        end
    end

    @testset "copy!" begin
        for (dst, src,) in (
                            (rand(Float32, (10,)),   rand(Float32, (10,))),   # vectors
                            (rand(Float32, (10,20)), rand(Float32, (10,20))), # multidim
                            )
            dst = AT(dst)
            src = AT(src)

            copy!(dst, src)
            @test dst == src
        end
    end

    @testset "copyto!" begin
        x = fill(0f0, 1)
        y = rand(Float32, 1)
        a = AT(x)
        copyto!(x, 1:1, y, 1:1)
        copyto!(a, 1:1, y, 1:1)
        @test x == Array(a)

        x = fill(0f0, 10)
        y = rand(Float32, 20)
        a = AT(x)
        b = AT(y)
        r1 = 1:7
        r2 = 11:17
        copyto!(x, r1, y, r2)
        copyto!(a, r1, b, r2)
        @test x == Array(a)

        x = fill(0f0, (10, 10))
        y = rand(Float32, (20, 10))
        a = AT(x)
        b = AT(y)
        r1 = CartesianIndices((1:7, 3:8))
        r2 = CartesianIndices((4:10, 3:8))
        copyto!(x, r1, y, r2)
        copyto!(a, r1, b, r2)
        @test x == Array(a)
        r2 = CartesianIndices((4:11, 3:8))
        @test_throws ArgumentError copyto!(a, r1, b, r2)

        r2 = CartesianIndices((4:10, 3:8))
        x2 = fill(0f0, (10, 10))
        copyto!(x2, r1, b, r2)
        @test x2 == x

        fill!(a, 0f0)
        copyto!(a, r1, y, r2)
        @test Array(a) == x

        x = fill(0f0, (10,))
        y = rand(Float32, (20,))
        a = AT(x)
        b = AT(y)
        r1 = CartesianIndices((1:7,))
        r2 = CartesianIndices((4:10,))
        copyto!(x, r1, y, r2)
        copyto!(a, r1, b, r2)
        @test x == Array(a)
        r2 = CartesianIndices((4:11,))
        @test_throws ArgumentError copyto!(a, r1, b, r2)

        x = fill(0f0, (10,))
        y = rand(Float32, (20,))
        a = AT(x)
        b = AT(y)
        r1 = 1:7
        r2 = 4:10
        copyto!(x, r1, y, r2)
        copyto!(a, r1, b, r2)
        @test x == Array(a)

        x = fill(0f0, (10,))
        y = fill(1f0, (10,))
        a = AT(x)
        b = AT(y)
        copyto!(a, b)
        @test Float32.(y) == Array(a)

        # wrapped gpu array to wrapped gpu array
        x = rand(Float32, 4, 4)
        a = AT(x)
        b = view(a, 2:3, 2:3)
        c = AT{eltype(b)}(undef, size(b))
        copyto!(c, b)
        Array(c) == Array(b)

        # wrapped gpu array to cpu array
        z = Array{eltype(b)}(undef, size(b))
        copyto!(z, b)
        @test z == Array(b)

        # cpu array to wrapped gpu array
        copyto!(b, z)

        # bug in copyto!
        ## needless N type parameter
        @test compare((x,y)->copyto!(y, selectdim(x, 2, 1)), AT, ones(Float32, 2, 2, 2), zeros(Float32, 2, 2))
        ## inability to copyto! smaller destination
        ## (this was broken on Julia <1.5)
        @test compare((x,y)->copyto!(y, selectdim(x, 2, 1)), AT, ones(Float32, 2, 2, 2), zeros(Float32, 3, 3))

        if (Float32 in eltypes && Float64 in eltypes)
            # mismatched types
            let src = rand(Float32, 4)
                dst = AT{Float64}(undef, size(src))
                copyto!(dst, src)
                @test Array(dst) == src
            end
            let dst = Array{Float64}(undef, 4)
                src = AT(rand(Float32, size(dst)))
                copyto!(dst, src)
                @test Array(src) == dst
            end
        end
    end

    @testset "cat" begin
        @test compare(hcat, AT, rand(Float32, 3), rand(Float32, 3))
        @test compare(hcat, AT, rand(Float32, ), rand(Float32, 1, 3))
        @test compare(hcat, AT, rand(Float32, 1, 3), rand(Float32))
        @test compare(hcat, AT, rand(Float32, 3), rand(Float32, 3, 3))
        @test compare(hcat, AT, rand(Float32, 3, 3), rand(Float32, 3))
        @test compare(hcat, AT, rand(Float32, 3, 3), rand(Float32, 3, 3))
        #@test compare(hcat, AT, rand(Float32, ), rand(Float32, 3, 3))
        #@test compare(hcat, AT, rand(Float32, 3, 3), rand(Float32))

        @test compare(vcat, AT, rand(Float32, 3), rand(Float32, 3))
        @test compare(vcat, AT, rand(Float32, 3, 3), rand(Float32, 3, 3))
        @test compare(vcat, AT, rand(Float32, ), rand(Float32, 3))
        @test compare(vcat, AT, rand(Float32, 3), rand(Float32))
        @test compare(vcat, AT, rand(Float32, ), rand(Float32, 3, 3))
        #@test compare(vcat, AT, rand(Float32, 3, 3), rand(Float32))

        @test compare((a,b) -> cat(a, b; dims=4), AT, rand(Float32, 3, 4), rand(Float32, 3, 4))
    end

    @testset "reshape" begin
        @test compare(reshape, AT, rand(Float32, 10), Ref((10,)))
        @test compare(reshape, AT, rand(Float32, 10), Ref((10,1)))
        @test compare(reshape, AT, rand(Float32, 10), Ref((1,10)))

        @test_throws Exception reshape(AT(rand(Float32, 10)), (10,2))
    end

    @testset "reinterpret" begin
        a = rand(ComplexF32, 22)
        A = AT(a)
        af0 = reinterpret(Float32, a)
        Af0 = reinterpret(Float32, A)
        @test Array(Af0) == af0
        a = rand(ComplexF32, 4, 4)
        A = AT(a)

        a = rand(ComplexF32, 10 * 10)
        A = AT(a)
        af0 = reshape(reinterpret(Float32, vec(a)), (20, 10))
        Af0 = reshape(reinterpret(Float32, vec(A)), (20, 10))
        @test Array(Af0) == af0
    end

    AT <: AbstractGPUArray && @testset "ntuple test" begin
        result = AT(Vector{NTuple{3, Float32}}(undef, 1))
        ntuple_test(get_backend(result))(result, Val(3); ndrange = 1)
        @test Array(result)[1] == (77, 2*77, 3*77)
        x = 88f0
        ntuple_closure(get_backend(result))(result, Val(3), x; ndrange = 1)
        @test Array(result)[1] == (x, 2*x, 3*x)
    end

    AT <: AbstractGPUArray && @testset "cartesian iteration" begin
        Ac = rand(Float32, 32, 32)
        A = AT(Ac)
        result = fill!(copy(A), 0.0f0)
        cartesian_iter(get_backend(A))(result, A; ndrange = size(A))
        Array(result) == Ac
    end

    AT <: AbstractGPUArray && @testset "Custom kernel from Julia function" begin
        x = AT(rand(Float32, 100))
        y = AT(rand(Float32, 100))
        clmap!(get_backend(x))(-, x, y; ndrange = size(x))
        jy = Array(y)
        @test map!(-, jy, jy) ≈ Array(x)
    end

    @testset "map" begin
        @test compare((a, b)-> map(+, a, b),    AT, rand(Float32, 10), rand(Float32, 10))
        @test compare((a, b)-> map!(-, a, b),   AT, rand(Float32, 10), rand(Float32, 10))
        @test compare((a, b, c, d)-> map!(*, a, b, c, d), AT, rand(Float32, 10), rand(Float32, 10), rand(Float32, 10), rand(Float32, 10))
    end

    @testset "repeat" begin
        @test compare(a-> repeat(a, 5, 6),  AT, rand(Float32, 10))
        @test compare(a-> repeat(a, 5),     AT, rand(Float32, 10))
        @test compare(a-> repeat(a, 5),     AT, rand(Float32, 5, 4))
        @test compare(a-> repeat(a, 4, 3),  AT, rand(Float32, 10, 15))
        @test compare(a-> repeat(a, 0),     AT, rand(Float32, 10))
        @test compare(a-> repeat(a, 0),     AT, rand(Float32, 5, 4))
        @test compare(a-> repeat(a, 4, 0),  AT, rand(Float32, 10, 15))

        # Test inputs.
        x = rand(Float32, 10)
        xmat = rand(Float32, 2, 10)
        xarr = rand(Float32, 3, 2, 10)

        # Note: When testing repeat(x; inner) need to hit both `repeat_inner_src_kernel!`
        # and `repeat_inner_dst_kernel!` to get full coverage.

        # Inner.
        @test compare(a -> repeat(a, inner=(2, )), AT, x)
        @test compare(a -> repeat(a, inner=(2, 3)), AT, xmat)
        @test compare(a -> repeat(a, inner=(3, 2)), AT, xmat)
        @test compare(a -> repeat(a, inner=(2, 3, 4)), AT, xarr)
        @test compare(a -> repeat(a, inner=(4, 3, 2)), AT, xarr)
        # Outer.
        @test compare(a -> repeat(a, outer=(2, )), AT, x)
        @test compare(a -> repeat(a, outer=(2, 3)), AT, xmat)
        @test compare(a -> repeat(a, outer=(2, 3, 4)), AT, xarr)
        # Both.
        @test compare(a -> repeat(a, inner=(2, ), outer=(2, )), AT, x)
        @test compare(a -> repeat(a, inner=(2, 3), outer=(2, 3)), AT, xmat)
        @test compare(a -> repeat(a, inner=(2, 3, 4), outer=(2, 1, 4)), AT, xarr)
        # Repeat which expands dimensionality.
        @test compare(a -> repeat(a, inner=(2, 1, 3)), AT, x)
        @test compare(a -> repeat(a, inner=(3, 1, 2)), AT, x)
        @test compare(a -> repeat(a, outer=(2, 1, 3)), AT, x)
        @test compare(a -> repeat(a, inner=(2, 1, 3), outer=(2, 2, 3)), AT, x)

        @test compare(a -> repeat(a, inner=(2, 1, 3)), AT, xmat)
        @test compare(a -> repeat(a, inner=(3, 1, 2)), AT, xmat)
        @test compare(a -> repeat(a, outer=(2, 1, 3)), AT, xmat)
        @test compare(a -> repeat(a, inner=(2, 1, 3), outer=(2, 2, 3)), AT, xmat)
    end

    @testset "permutedims" begin
        @test compare(x->permutedims(x, [1, 2]), AT, rand(Float32, 4, 4))

        inds = rand(1:100, 150, 150)
        @test compare(x->permutedims(view(x, inds, :), (3, 2, 1)), AT, rand(Float32, 100, 100))
    end

    @testset "circshift" begin
        @test compare(x->circshift(x, (0,1)), AT, reshape(Vector(1:16), (4,4)))
    end

    @testset "copy" begin
        a = AT([1])
        b = copy(a)
        fill!(b, 0)
        @test Array(b) == [0]
        @test Array(a) == [1]
    end

    @testset "input output" begin
        # compact=false to avoid type aliases
        replstr(x, kv::Pair...) = sprint((io,x) -> show(IOContext(io, :compact => false, :limit => true, :displaysize => (24, 80), kv...), MIME("text/plain"), x), x)
        showstr(x, kv::Pair...) = sprint((io,x) -> show(IOContext(io, :limit => true, :displaysize => (24, 80), kv...), x), x)

        @testset "showing" begin
            # vectors and non-vector arrays showing
            # are handled differently in base/arrayshow.jl
            A = AT(Int64[1])
            B = AT(Int64[1 2;3 4])

            msg = replstr(A)
            @test occursin(Regex("^1-element $AT{Int64,\\s?1.*}:\n 1\$"), msg)

            # # result of e.g. `print` differs on 32bit and 64bit machines
            # due to different definition of `Int` type
            # print([1]) shows as [1] on 64bit but Int64[1] on 32bit
            msg = showstr(A)
            @test msg == "[1]" || msg == "Int64[1]"

            msg = replstr(B)
            @test occursin(Regex("^2×2 $AT{Int64,\\s?2.*}:\n 1  2\n 3  4\$"), msg)

            msg = showstr(B)
            @test msg == "[1 2; 3 4]" || msg == "Int64[1 2; 3 4]"

            # the printing of Adjoint depends on global state
            msg = replstr(A')
            @test occursin(Regex("^1×1 Adjoint{Int64,\\s?$AT{Int64,\\s?1.*}}:\n 1\$"), msg) ||
                occursin(Regex("^1×1 LinearAlgebra.Adjoint{Int64,\\s?$AT{Int64,\\s?1.*}}:\n 1\$"), msg) ||
                occursin(Regex("^1×1 adjoint\\(::$AT{Int64,\\s?1.*}\\) with eltype Int64:\n 1\$"), msg)
        end
    end

    @testset "view" begin
      @test compare(AT, rand(Float32, 5)) do x
        y = x[2:4]
        y .= 1
        x
      end

      @test compare(AT, rand(Float32, 5)) do x
        y = view(x, 2:4)
        y .= 1
        x
      end

      @test compare(x->view(x, :, 1:4, 3), AT, rand(Float32, 5, 4, 3))
      @test compare(x->view(x, Base.Slice(Base.OneTo(5)), 1:4, 3), AT, rand(Float32, 5, 4, 3))

      let x = AT(rand(Float32, 5, 4, 3))
        @test_throws BoundsError view(x, :, :, 1:10)
      end

      @testset "selectdim" begin
        @test compare(x -> selectdim(x, 3, 1), AT, rand(Float32, 2, 2, 2))
        let x = AT(rand(Float32, 5, 4, 3))
          @test typeof(selectdim(x, 3, 1)) == typeof(view(x, :, :, 1))         
          @test typeof(selectdim(x, 2, 1)) == typeof(view(x, :, 1, :))
        end
      end

      # bug in parentindices conversion
      let x = AT{Int}(undef, 1, 1)
        x[1,:] .= 42
        @test Array(x)[1,1] == 42
      end

      # bug in conversion of indices (#506)
      show(devnull, AT(view(ones(Float32, 1), [1])))

      # performance loss due to Array indices
      let x = AT{Int}(undef, 1)
        i = [1]
        y = view(x, i)
        @test parent(y) isa AT
        @test parentindices(y) isa Tuple{<:AT}
      end

      @testset "GPU array source" begin
          a = rand(Float32, 3)
          i = rand(1:3, 2)
          @test compare(view, AT, a, i)
          @test compare(view, AT, a, view(i, 2:2))
      end

      @testset "CPU array source" begin
          a = rand(Float32, 3)
          i = rand(1:3, 2)
          @test compare(view, AT, a, i)
          @test compare(view, AT, a, view(i, 2:2))
      end
    end

    @testset "reshape" begin
      A = [1 2 3 4
           5 6 7 8]
      gA = reshape(AT(A),1,8)
      _A = reshape(A,1,8)
      _gA = Array(gA)
      @test all(_A .== _gA)
      A = [1,2,3,4]
      gA = reshape(AT(A),4)
    end

    @testset "reinterpret" begin
      A = Int32[-1,-2,-3]
      dA = AT(A)
      dB = reinterpret(UInt32, dA)
      @test reinterpret(UInt32, A) == Array(dB)

      @test collect(reinterpret(Int32, AT(fill(1f0))))[] == reinterpret(Int32, 1f0)

      @testset "reinterpret(reshape)" begin
        a = AT(ComplexF32[1.0f0+2.0f0*im, 2.0f0im, 3.0f0im])
        b = reinterpret(reshape, Float32, a)
        @test a isa AT{ComplexF32, 1}
        if AT <: AbstractGPUArray
          # only GPUArrays materialize the reinterpret(reshape) wrapper
          @test b isa AT{Float32, 2}
        end
        @test(Array(b) == [1.0 0.0 0.0; 2.0 2.0 3.0],
              broken=(AT <: Array &&
                        (v"1.11.0-DEV.727" <= VERSION < v"1.11.0-beta2" || # broken in JuliaLang/julia#51760 & reverted in beta2
                          v"1.12.0-" <= VERSION < v"1.12.0-DEV.528"
                        )
                      )
              )

        a = AT(Float32[1.0 0.0 0.0; 2.0 2.0 3.0])
        b = reinterpret(reshape, ComplexF32, a)
        @test Array(b) == ComplexF32[1.0f0+2.0f0*im, 2.0f0im, 3.0f0im]
      end

      if AT <: AbstractGPUArray
        # XXX: use a predicate function?
        supports_bitsunion = try
          AT([1,nothing])
          true
        catch
          false
        end

        if supports_bitsunion
          @test_throws "cannot reinterpret an `Union{Nothing, Int64}` array to `Float64`, because not all types are bitstypes" reinterpret(Float64, AT([1,nothing]))
        end

        @test_throws "cannot reinterpret a zero-dimensional `Float32` array to `Int128` which is of a different size" reinterpret(Int128, AT(fill(1f0)))

        @test_throws "cannot reinterpret an `Float32` array to `Int128` whose first dimension has size `3`." reinterpret(Int128, AT(ones(Float32, 3)))
      end
    end
end

# Base mathematical operations

function Base.clamp!(A::AnyGPUArray, low, high)
    @kernel function clamp_kernel!(A, low, high)
        I = @index(Global, Cartesian)
        A[I] = clamp(A[I], low, high)
    end
    clamp_kernel!(get_backend(A))(A, low, high; ndrange = size(A))
    return A
end

using Documenter, GPUArrays

function main()
    makedocs(
        modules = [GPUArrays],
        format = Documenter.HTML(
            # Use clean URLs on CI
            prettyurls = get(ENV, "CI", nothing) == "true",
            assets = ["assets/favicon.ico"],
            analytics = "UA-154489943-6",
        ),
        sitename = "GPUArrays.jl",
        pages = [
            "Home"          => "index.md",
            "Interface"     => "interface.md",
            "Functionality" => [
                "functionality/host.md",
                "functionality/device.md",
            ],
            "Test suite"    => "testsuite.md",
        ],
        doctest = true,
        warnonly = [:missing_docs],
    )

    deploydocs(
        repo = "github.com/JuliaGPU/GPUArrays.jl.git"
    )
end

isinteractive() || main()

# integration with Random stdlib

## Philox4x32-10 counter-based RNG

# Stateless: (counter, key) → 4 UInt32 outputs. Each unique counter gives independent
# random values with no shared memory or global state needed.
#
# Reference: Salmon et al., "Parallel Random Numbers: As Easy as 1, 2, 3" (2011)
# Based on: PhiloxRNG.jl by Nathan Zimmerberg

const PHILOX_M4x32_0 = 0xD2511F53
const PHILOX_M4x32_1 = 0xCD9E8D57
const PHILOX_W32_0   = 0x9E3779B9
const PHILOX_W32_1   = 0xBB67AE85

@inline function philox4x32round(ctr::NTuple{4,UInt32}, key::NTuple{2,UInt32})
    mul0 = widemul(PHILOX_M4x32_0, ctr[1])
    mul1 = widemul(PHILOX_M4x32_1, ctr[3])
    hi0 = (mul0 >> 32) % UInt32
    hi1 = (mul1 >> 32) % UInt32
    lo0 = mul0 % UInt32
    lo1 = mul1 % UInt32
    (hi1 ⊻ ctr[2] ⊻ key[1], lo1, hi0 ⊻ ctr[4] ⊻ key[2], lo0)
end

@inline function philox4x32bumpkey(key::NTuple{2,UInt32})
    (key[1] + PHILOX_W32_0, key[2] + PHILOX_W32_1)
end

@inline function philox4x32_10(ctr::NTuple{4,UInt32}, key::NTuple{2,UInt32})
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key); key = philox4x32bumpkey(key)
    ctr = philox4x32round(ctr, key)
    ctr
end

@inline function philox4x32_10(ctr0::UInt64, ctr1::UInt64, key::UInt64)::NTuple{4, UInt32}
    philox4x32_10((ctr0%UInt32, (ctr0>>32)%UInt32, ctr1%UInt32, (ctr1>>32)%UInt32), (key%UInt32, (key>>32)%UInt32))
end

## Float conversions: unsigned integer → uniform float, strictly positive
## (can round up to exactly 1.0)

"""
    u01(F, u::Union{UInt32, UInt64})::F

Convert an unsigned integer to a float of type `F` uniformly distributed in (0, 1].

Ported from [Random123 uniform.hpp](https://github.com/DEShawResearch/random123/blob/v1.14.0/include/Random123/uniform.hpp#L175).
"""
@inline function u01(::Type{F}, u::UInt32)::F where F
    fma(F(u), F(2)^Int32(-32), F(2)^Int32(-33))
end

@inline function u01(::Type{F}, u::UInt64)::F where F
    fma(F(u), F(2)^Int32(-64), F(2)^Int32(-65))
end

## Fast sincospi for Box-Muller
#
# Base.sincospi(::Float32) widens to Float64 internally (via `sinpi_kernel_wide`,
# see base/special/trig.jl:744), which breaks Metal — it has no Float64 support
# at all — and wastes cycles on other backends that must emulate FP64.
#
# Vendored from PhiloxRNG.jl (MIT): a minimax polynomial that stays entirely
# in Float32 and consumes the Philox UInt32 output directly. Bottom 3 bits
# select one of 8 octants (swap/negate), upper 29 bits give the reduced
# argument (+0.5-biased so y ≠ 0).
#
# Vendored contents of:
# https://github.com/medyan-dev/PhiloxRNG.jl/blob/v1.1.1/src/fastsincospi.jl
# With minor style changes.

# ============================================================
# Fast sincospi for Box-Muller
#
# Computes (sin(θ), cos(θ)) from a uniform UInt32 (or UInt64),
# placing 2^N points uniformly around the unit circle with
# no point landing exactly on an axis.
#
# The bottom 3 bits of u select one of 8 octants (π/4 each).
# The upper bits give the reduced argument y ∈ (0, 0.25),
# with a +0.5 bias to avoid y = 0. The polynomials evaluate
# sin(πy) and cos(πy) — with π baked into the coefficients —
# then each octant bit directly controls one operation:
#   bit 0 → swap sin/cos
#   bit 1 → negate sin
#   bit 2 → negate cos
#
# The octants are not in geometric order, but the 2^N points
# are uniformly distributed around the unit circle regardless.
# ============================================================

# --- Float32 minimax coefficients for sin(πy)/y and cos(πy) in y² ---
#
# 4-term (degree 3 in y²) minimax via Remez algorithm on [0, 0.0625].
const SP_F32 = (3.1415927f0, -5.167708f0, 2.5497673f0, -0.58907866f0)
const CP_F32 = (1.0f0, -4.934788f0, 4.057578f0, -1.3061346f0)

@inline function fast_sincospi(::Type{Float32}, u::Union{UInt32, UInt64})
    oct = (u % Int32) & Int32(7)
    y = fma(Float32(u & ~oftype(u, 7)), Float32(2)^Int32(-(sizeof(u)*8+2)), Float32(2)^Int32(-(sizeof(u)*8)))

    sp = y * evalpoly(y * y, SP_F32)
    cp = evalpoly(y * y, CP_F32)

    swap    = !iszero(oct & Int32(1))
    sin_neg = !iszero(oct & Int32(2))
    cos_neg = !iszero(oct & Int32(4))

    s_raw = ifelse(swap, cp, sp)
    c_raw = ifelse(swap, sp, cp)
    sin_val = ifelse(sin_neg, -s_raw, s_raw)
    cos_val = ifelse(cos_neg, -c_raw, c_raw)
    (sin_val, cos_val)
end

# ============================================================
# Float64 / UInt64 version
#
# Same structure as Float32: bottom 3 bits → octant, upper
# 61 bits → reduced argument, +0.5 bias, direct bit mapping.
# ============================================================

const SP_F64 = (3.141592653589793, -5.167712780049954, 2.5501640398733785,
               -0.5992645289398095, 0.08214586918507949, -0.007370021659123395,
               0.0004615322405282014)
const CP_F64 = (1.0, -4.934802200544605, 4.0587121263978485,
               -1.3352627670374702, 0.23533054723811608, -0.025804938901032953,
               0.0019068114005246046)

@inline function fast_sincospi(::Type{Float64}, u::Union{UInt32, UInt64})
    oct = (u % Int32) & Int32(7)
    y = fma(Float64(u & ~oftype(u, 7)), Float64(2)^Int32(-(sizeof(u)*8+2)), Float64(2)^Int32(-(sizeof(u)*8)))

    sp = y * evalpoly(y * y, SP_F64)
    cp = evalpoly(y * y, CP_F64)

    swap    = !iszero(oct & Int32(1))
    sin_neg = !iszero(oct & Int32(2))
    cos_neg = !iszero(oct & Int32(4))

    s_raw = ifelse(swap, cp, sp)
    c_raw = ifelse(swap, sp, cp)
    sin_val = ifelse(sin_neg, -s_raw, s_raw)
    cos_val = ifelse(cos_neg, -c_raw, c_raw)
    (sin_val, cos_val)
end

# End of vendored https://github.com/medyan-dev/PhiloxRNG.jl/blob/v1.1.1/src/fastsincospi.jl

## Fast log for Box-Muller
#
# Base.log(::Float32) widens to Float64 internally (see base/special/log.jl:242
# `Float64(2f0*f)/(2.0+f)`), same Metal / FP64-emulation problem as sincospi.
#
# Vendored contents of:
# https://github.com/medyan-dev/PhiloxRNG.jl/blob/v1.1.1/src/fastlog.jl
# With minor style changes.

# Core log algorithm (polynomial coefficients, ln2 splitting, and reconstruction)
# adapted from fdlibm's e_log.c / e_logf.c (Sun Microsystems, 1993).
# See: https://github.com/JuliaMath/openlibm/blob/v0.8.7/src/e_log.c
#      https://github.com/JuliaMath/openlibm/blob/v0.8.7/src/e_logf.c

const SQRT_HALF_I32 = reinterpret(Int32, Float32(sqrt(0.5)))
const LOG_POLY_F32 = (0.6666666f0, 0.40000972f0, 0.28498787f0, 0.24279079f0)
const LN2_HI_F32 = 0.6931381f0
const LN2_LO_F32 = 9.058001f-6

@inline function fast_log(::Type{Float32}, u::Union{UInt32, UInt64})
    x = u01(Float32, u)

    # Goal: find k and f such that
    # x = 2^k * (1+f)
    # where sqrt(2)/2 ≤ (1+f) < sqrt(2)
    # if k is zero
    # we calculate f by -u01(Float32, ~u) which is more accurate for x near 1

    # Float32 has 23 fractional bits.
    # x is ordered by value in Int32 space.
    # Starting from x=1, k starts at 0, then ix becomes negative at x = prevfloat(sqrt(0.5f0))
    # making k = -1. For each power of 2 scale in x,
    # k changes by one, because we shift out the 23 fraction bits.
    ix = reinterpret(Int32, x) - SQRT_HALF_I32
    k = ix >> Int32(23)

    # `f_plus_one_std` will have the same fraction bits as `x`
    # because `- SQRT_HALF_I32` and `+ SQRT_HALF_I32` cancel out in the low 23 bits.
    # `& Int32(0x007fffff)` clears the exponent and sign fields.
    # `f_plus_one_std` must either have an exponent of -1 or 0.
    # If x's fractional bits are less than the fractional bits of SQRT_HALF_I32
    # the `- SQRT_HALF_I32` borrows a 2^23 from the exponent field of x,
    # which then shows up as an extra 2^23 in the low 23 bits after masking.
    # When adding SQRT_HALF_I32 this extra 2^23 propagates up and
    # bumps the exponent from -1 to 0.
    f_plus_one_std = reinterpret(Float32, (ix & Int32(0x007fffff)) + SQRT_HALF_I32)
    f_std = f_plus_one_std - 1.0f0

    f_comp = -u01(Float32, ~u)
    f = ifelse(k == Int32(0), f_comp, f_std)

    # Goal: get log(1+f) via a polynomial approx.
    # Let s = f/(2+f), z = s², and log_poly(z) ≈ evalpoly(z, LOG_POLY_F32)
    # log(1+f) = 2s + s³*log_poly(s²)
    # R = s²*log_poly(s²)
    # log(1+f) = f - f²/2 + s*(f²/2 + R)
    s = f / (2.0f0 + f)
    z = s * s
    R = z * evalpoly(z, LOG_POLY_F32)
    hfsq = 0.5f0 * f * f

    # log(x) = k*log(2) + log(1+f)
    k_f32 = Float32(k)
    # Simpler version, but fails the mean test by 2E-9
    # fma(k_f32, 0.6931472f0 #= log(2) =#, fma(s, R-f, f))
    # log(2) = LN2_HI_F32 + LN2_LO_F32
    fma(k_f32, LN2_HI_F32,
        f - (hfsq - fma(s, (hfsq + R), k_f32 * LN2_LO_F32))
    )
end

const SQRT_HALF_I64 = reinterpret(Int64, sqrt(0.5))
const LOG_POLY_F64 = (
    6.666666666666735130e-01,
    3.999999999940941908e-01,
    2.857142874366239149e-01,
    2.222219843214978396e-01,
    1.818357216161805012e-01,
    1.531383769920937332e-01,
    1.479819860511658591e-01,
)
const LN2_HI_F64 = 6.93147180369123816490e-01
const LN2_LO_F64 = 1.90821492927058770002e-10

@inline function fast_log(::Type{Float64}, u::Union{UInt32, UInt64})
    # See Float32 version for commentary
    x = u01(Float64, u)

    ix = reinterpret(Int64, x) - SQRT_HALF_I64
    k = ix >> Int64(52)
    f_std = reinterpret(Float64, (ix & Int64(0x000fffffffffffff)) + SQRT_HALF_I64) - 1.0

    f_comp = -u01(Float64, ~u)
    f = ifelse(k == Int64(0), f_comp, f_std)

    s = f / (2.0 + f)
    z = s * s
    R = z * evalpoly(z, LOG_POLY_F64)
    hfsq = 0.5 * f * f

    # log(x) = k*ln2 + log(1+f)
    k_f64 = Float64(k)
    fma(k_f64, LN2_HI_F64,
        f - (hfsq - fma(s, (hfsq + R), k_f64 * LN2_LO_F64))
    )
end

# End of vendored https://github.com/medyan-dev/PhiloxRNG.jl/blob/v1.1.1/src/fastlog.jl


## Box-Muller transform

# ≤32-bit float output: both log and sincospi go through the Float32
# polynomials above.
# Using Base.sqrt_llvm to avoid the DomainError check.
@inline function boxmuller(::Type{F}, u1::UInt32, u2::UInt32) where F <: Union{Float16,Float32}
    r = Base.sqrt_llvm(-2f0 * fast_log(Float32, u2))
    s, c = fast_sincospi(Float32, u1)
    (F(r * s), F(r * c))
end

@inline function boxmuller(::Type{Float64}, u1::UInt64, u2::UInt64)
    r = Base.sqrt_llvm(-2.0 * fast_log(Float64, u2))
    s, c = fast_sincospi(Float64, u1)
    (r * s, r * c)
end

# For complex normals each component has variance 1/2, so the radius is
# sqrt(-log(U)) rather than sqrt(-2·log(U)).
@inline function boxmuller(::Type{Complex{F}}, u1::UInt32, u2::UInt32) where F <: Union{Float16,Float32}
    r = Base.sqrt_llvm(-fast_log(Float32, u2))
    s, c = fast_sincospi(Float32, u1)
    complex(F(r * s), F(r * c))
end
@inline function boxmuller(::Type{Complex{Float64}}, u1::UInt64, u2::UInt64)
    r = Base.sqrt_llvm(-fast_log(Float64, u2))
    s, c = fast_sincospi(Float64, u1)
    complex(r * s, r * c)
end


## RNG type
#
# Parameterized on the GPU array type `AT` (e.g. `CuArray`, `ROCArray`, `JLArray`).
# `AT` is only consulted by the *out-of-place* `rand`/`randn` constructors and by
# the CPU-array fill fallback — the in-place `rand!`/`randn!` GPU paths dispatch
# on the destination's KernelAbstractions backend and ignore `AT`.

mutable struct RNG{AT} <: AbstractRNG
    seed::UInt64
    counter::UInt64
end

RNG{AT}() where {AT} = RNG{AT}(rand(Random.RandomDevice(), UInt64), rand(Random.RandomDevice(), UInt64))
RNG{AT}(seed::Integer) where {AT} = RNG{AT}(seed % UInt64, UInt64(0))

Random.seed!(rng::RNG) = (rng.seed = rand(Random.RandomDevice(), UInt64); rng.counter = rand(Random.RandomDevice(), UInt64); rng)
Random.seed!(rng::RNG, seed::Integer) = (rng.seed = seed % UInt64; rng.counter = UInt64(0); rng)

function advance_counter!(rng::RNG)
    rng.counter += one(UInt64)
    rng
end


## Specialized rand! kernels for common types

# Each Philox4x32 call produces 4 UInt32 outputs. Specialized kernels batch
# multiple values per work item to use all 4 outputs efficiently:
# - ≤4-byte types (including Float16): 4 values per call
# - 8-byte types (Int64/UInt64/Float64/Complex{Float32}): 2 values per call
# - 16-byte types (Int128/UInt128/Complex{Float64}):     1 value per call

# Convert Philox UInt32 outputs to N values of type T
@inline philox_to_vals(::Type{Float16}, a1, a2, a3, a4) =
    (Float16(u01(Float32, a1)), Float16(u01(Float32, a2)),
     Float16(u01(Float32, a3)), Float16(u01(Float32, a4)))
@inline philox_to_vals(::Type{Float32}, a1, a2, a3, a4) =
    (u01(Float32, a1), u01(Float32, a2), u01(Float32, a3), u01(Float32, a4))
for T in (UInt8, UInt16, UInt32, Int8, Int16, Int32, Bool)
    @eval @inline philox_to_vals(::Type{$T}, a1, a2, a3, a4) =
        (a1 % $T, a2 % $T, a3 % $T, a4 % $T)
end
@inline philox_to_vals(::Type{Float64}, a1, a2, a3, a4) =
    (u01(Float64, UInt64(a1) | UInt64(a2) << 32),
     u01(Float64, UInt64(a3) | UInt64(a4) << 32))
for T in (UInt64, Int64)
    @eval @inline philox_to_vals(::Type{$T}, a1, a2, a3, a4) =
        ((UInt64(a1) | UInt64(a2) << 32) % $T,
         (UInt64(a3) | UInt64(a4) << 32) % $T)
end
for T in (UInt128, Int128)
    @eval @inline philox_to_vals(::Type{$T}, a1, a2, a3, a4) =
        ((UInt128(a1) | UInt128(a2) << 32 | UInt128(a3) << 64 | UInt128(a4) << 96) % $T,)
end
@inline philox_to_vals(::Type{Complex{Float32}}, a1, a2, a3, a4) =
    (complex(u01(Float32, a1), u01(Float32, a2)),
     complex(u01(Float32, a3), u01(Float32, a4)))
@inline philox_to_vals(::Type{Complex{Float64}}, a1, a2, a3, a4) =
    (complex(u01(Float64, UInt64(a1) | UInt64(a2) << 32),
             u01(Float64, UInt64(a3) | UInt64(a4) << 32)),)

# Number of output values per Philox4x32 call
vals_per_call(::Type{T}) where T = sizeof(T) <= 4 ? 4 : sizeof(T) <= 8 ? 2 : 1
vals_per_call(::Type{Complex{T}}) where T = sizeof(T) <= 4 ? 2 : 1

# Batched kernel: N values per work item from one Philox call
@kernel function rand_batched_kernel!(seed::UInt64, counter::UInt64, A::AbstractArray{T}) where T
    gid = @index(Global, Linear)
    N = vals_per_call(T)
    idx = N * gid
    len = length(A)
    if idx <= len
        vals = philox_to_vals(T, philox4x32_10(gid % UInt64, counter, seed)...)
        for j in 1:N
            @inbounds A[idx - N + j] = vals[j]
        end
    elseif idx - N < len
        vals = philox_to_vals(T, philox4x32_10(gid % UInt64, counter, seed)...)
        for j in 1:min(N, len - idx + N)
            @inbounds A[idx - N + j] = vals[j]
        end
    end
end

# Types with specialized batched kernels
const BatchedRandTypes = Union{
    Float16, Float32, Float64, Complex{Float32}, Complex{Float64},
    Bool, Int8, Int16, Int32, Int64, Int128,
    UInt8, UInt16, UInt32, UInt64, UInt128}

function Random.rand!(rng::RNG, A::AnyGPUArray{T}) where T <: BatchedRandTypes
    isempty(A) && return A
    N = vals_per_call(T)
    rand_batched_kernel!(get_backend(A))(rng.seed, rng.counter, A;
                                         ndrange=cld(length(A), N))
    advance_counter!(rng)
    A
end


## ElementRNG: a device-side AbstractRNG for generic rand/randn fallbacks

# For element types without a specialized batched kernel (BigFloat,
# FixedPointNumbers, user-defined types, ...), we create a per-work-item
# AbstractRNG and delegate to Random stdlib's `rand(rng, T)` / `randn(rng, T)`.
#
# The struct is immutable (mutable structs get heap-allocated on GPU); the
# per-work-item subcounter state lives in a stack-allocated Ref that the
# struct holds a pointer to.

struct ElementRNG <: AbstractRNG
    seed::UInt64
    counter::UInt64
    nthreads::UInt64
    ctr0_ptr::Ptr{UInt64}
end

@inline Random.rng_native_52(::ElementRNG) = UInt64

@inline function Random.rand(rng::ElementRNG, ::Random.SamplerType{UInt64})
    sc = unsafe_load(rng.ctr0_ptr) + rng.nthreads
    unsafe_store!(rng.ctr0_ptr, sc)
    a1, a2, _, _ = philox4x32_10(sc, rng.counter, rng.seed)
    UInt64(a1) | UInt64(a2) << 32
end

@inline function Random.rand(rng::ElementRNG, ::Random.SamplerType{UInt128})
    UInt128(rand(rng, Random.SamplerType{UInt64}())) |
    UInt128(rand(rng, Random.SamplerType{UInt64}())) << 64
end

@inline Random.rand(rng::ElementRNG, ::Random.SamplerType{T}) where T <: Union{Bool,Base.BitInteger} =
    rand(rng, Random.SamplerType{UInt64}()) % T


## Generic rand! fallback via ElementRNG

@kernel function rand_generic_kernel!(seed::UInt64, counter::UInt64, A::AbstractArray{T}) where T
    gid = @index(Global, Linear)
    len_A = length(A)
    if gid <= len_A
        subctr = Ref{UInt64}(gid%UInt64)
        GC.@preserve subctr begin
            rng = ElementRNG(seed, counter, len_A % UInt64,
                            Base.unsafe_convert(Ptr{UInt64}, subctr))
            @inbounds A[gid] = rand(rng, T)
        end
    end
end

function Random.rand!(rng::RNG, A::AnyGPUArray{T}) where T
    isempty(A) && return A
    rand_generic_kernel!(get_backend(A))(rng.seed, rng.counter, A; ndrange=length(A))
    advance_counter!(rng)
    A
end


## Specialized randn! kernel for common float types

# Float16/32/64 and their complex variants go through a batched kernel mirroring
# rand_batched_kernel!, rather than the generic ElementRNG path further down:
#
# 1. Random's `randn(rng, ::Float{16,32,64})` uses the Ziggurat algorithm with
#    global table lookups (`ki`, `wi`, `fi`), which aren't device-accessible
#    from a KernelAbstractions kernel.
#
# 2. The polar Box-Muller fallback reachable for other AbstractFloat types has
#    a rejection loop (`while true ... 0 < s < 1`), causing warp divergence
#    (~2x slower).
#
# 3. Direct (non-rejection) Box-Muller naturally produces value *pairs* from
#    sincospi. Batching these (4 Float32 / 2 Float64 per Philox call) keeps us
#    memory-bandwidth-bound; a 1-per-work-item kernel would discard half the
#    output.

# Convert Philox UInt32 outputs to N normally-distributed values of type T.
# ≤32-bit float targets pass UInt32s to boxmuller directly. 64-bit
# targets use UInt64s for finer sampling.
for T in (Float16, Float32)
    @eval @inline function philox_to_normals(::Type{$T}, a1, a2, a3, a4)
        n1, n2 = boxmuller($T, a1, a2)
        n3, n4 = boxmuller($T, a3, a4)
        (n1, n2, n3, n4)
    end
end
@inline function philox_to_normals(::Type{Float64}, a1, a2, a3, a4)
    boxmuller(Float64,
        UInt64(a1) | UInt64(a2) << 32,
        UInt64(a3) | UInt64(a4) << 32)
end
@inline philox_to_normals(::Type{Complex{Float32}}, a1, a2, a3, a4) =
    (boxmuller(Complex{Float32}, a1, a2),
     boxmuller(Complex{Float32}, a3, a4))
@inline philox_to_normals(::Type{Complex{Float64}}, a1, a2, a3, a4) =
    (boxmuller(Complex{Float64},
        UInt64(a1) | UInt64(a2) << 32,
        UInt64(a3) | UInt64(a4) << 32),)

@kernel function randn_batched_kernel!(seed::UInt64, counter::UInt64, A::AbstractArray{T}) where T
    gid = @index(Global, Linear)
    N = vals_per_call(T)
    idx = N * gid
    len = length(A)
    if idx <= len
        vals = philox_to_normals(T, philox4x32_10(gid % UInt64, counter, seed)...)
        for j in 1:N
            @inbounds A[idx - N + j] = vals[j]
        end
    elseif idx - N < len
        vals = philox_to_normals(T, philox4x32_10(gid % UInt64, counter, seed)...)
        for j in 1:min(N, len - idx + N)
            @inbounds A[idx - N + j] = vals[j]
        end
    end
end

const BatchedRandnTypes = Union{Float16, Float32, Float64,
                                Complex{Float32}, Complex{Float64}}

function Random.randn!(rng::RNG, A::AnyGPUArray{T}) where T <: BatchedRandnTypes
    isempty(A) && return A
    N = vals_per_call(T)
    randn_batched_kernel!(get_backend(A))(rng.seed, rng.counter, A;
                                          ndrange=cld(length(A), N))
    advance_counter!(rng)
    A
end


## Generic randn! fallback via ElementRNG
#
# For AbstractFloats outside BatchedRandnTypes (BFloat16, user-defined float
# types, etc.) we route through Random's `randn(rng, T)`. The reachable methods
# from there are:
#
# - `randn(rng, ::BitFloatType)` (Float16/32/64) — ziggurat, uses global `wi`
#   /`ki`/`fi` tables that aren't device-accessible. Overridden below to use
#   our Box-Muller directly. The direct dispatch for these types goes through
#   the batched kernel above, but `randn(rng, Complex{Float16})` recurses into
#   `randn(rng, Float16)` which hits this path.
# - `randn(rng, ::Type{Complex{T}})` — recurses into `randn(rng, T)`.
# - `randn(rng, ::Type{T}) where T<:AbstractFloat` — Marsaglia polar Box-Muller
#   rejection loop. GPU-safe (only calls `rand(rng, T)`) but warp-divergent.

# Bypass Base's ziggurat-based randn(rng, Float{16,32,64}) — its `wi`/`ki`/`fi`
# tables aren't device-accessible, and on Metal the Float64 tables can't even
# be loaded. Reached via Base's Complex recursion when the element type is
# e.g. Complex{Float16}.
@inline Random.randn(rng::ElementRNG, ::Type{Float16}) =
    first(boxmuller(Float16, rand(rng, UInt32), rand(rng, UInt32)))
@inline Random.randn(rng::ElementRNG, ::Type{Float32}) =
    first(boxmuller(Float32, rand(rng, UInt32), rand(rng, UInt32)))
@inline Random.randn(rng::ElementRNG, ::Type{Float64}) =
    first(boxmuller(Float64, rand(rng, UInt64), rand(rng, UInt64)))

@kernel function randn_generic_kernel!(seed::UInt64, counter::UInt64, A::AbstractArray{T}) where T
    gid = @index(Global, Linear)
    len_A = length(A)
    if gid <= len_A
        subctr = Ref{UInt64}(gid%UInt64)
        GC.@preserve subctr begin
            rng = ElementRNG(seed, counter, len_A % UInt64,
                            Base.unsafe_convert(Ptr{UInt64}, subctr))
            @inbounds A[gid] = randn(rng, T)
        end
    end
end

function Random.randn!(rng::RNG, A::AnyGPUArray{T}) where T <: Union{AbstractFloat,
                                                                     Complex{<:AbstractFloat}}
    isempty(A) && return A
    randn_generic_kernel!(get_backend(A))(rng.seed, rng.counter, A; ndrange=length(A))
    advance_counter!(rng)
    A
end


## Non-GPU array fallback: generate on AT, copyto! the destination.
#
# Without this, `rand!(rng::RNG{CuArray}, ::Vector)` would hit Random's stdlib
# scalar path and silently iterate the GPU rng one element at a time.

function Random.rand!(rng::RNG{AT}, A::AbstractArray{T}) where {AT, T}
    isempty(A) && return A
    B = similar(AT{T}, size(A))
    Random.rand!(rng, B)
    copyto!(A, B)
end
function Random.randn!(rng::RNG{AT}, A::AbstractArray{T}) where {AT, T<:Union{AbstractFloat,
                                                                             Complex{<:AbstractFloat}}}
    isempty(A) && return A
    B = similar(AT{T}, size(A))
    Random.randn!(rng, B)
    copyto!(A, B)
end


## CPU RNG → GPU array: generate on CPU, copyto! the destination.
#
# Without this, `rand!(::Random.TaskLocalRNG, ::CuArray)` hits Random's stdlib
# scalar path and iterates the GPU array one element at a time.

Random.rand!(rng::AbstractRNG, A::AnyGPUArray) =
    copyto!(A, rand(rng, eltype(A), size(A)...))
Random.randn!(rng::AbstractRNG, A::AnyGPUArray{T}) where {T<:Union{AbstractFloat,
                                                                   Complex{<:AbstractFloat}}} =
    copyto!(A, randn(rng, eltype(A), size(A)...))


## Out-of-place rand / randn — construct an AT array and fill it.

Random.rand(rng::RNG{AT}, ::Type{T}, dims::Dims) where {AT, T} =
    Random.rand!(rng, similar(AT{T}, dims))
Random.randn(rng::RNG{AT}, ::Type{T}, dims::Dims) where {AT, T<:Union{AbstractFloat,
                                                                       Complex{<:AbstractFloat}}} =
    Random.randn!(rng, similar(AT{T}, dims))

# untyped: default to Float32 (matches CUDA convention; better fit than Float64
# on consumer GPUs)
Random.rand(rng::RNG{AT}, dims::Dims) where {AT} = Random.rand(rng, Float32, dims)
Random.randn(rng::RNG{AT}, dims::Dims) where {AT} = Random.randn(rng, Float32, dims)

# variadic dim spellings
Random.rand(rng::RNG, dim1::Integer, dims::Integer...) =
    Random.rand(rng, Dims((dim1, dims...)))
Random.randn(rng::RNG, dim1::Integer, dims::Integer...) =
    Random.randn(rng, Dims((dim1, dims...)))
Random.rand(rng::RNG, ::Type{T}, dim1::Integer, dims::Integer...) where T =
    Random.rand(rng, T, Dims((dim1, dims...)))
Random.randn(rng::RNG, ::Type{T}, dim1::Integer, dims::Integer...) where T =
    Random.randn(rng, T, Dims((dim1, dims...)))

@testsuite "uniformscaling" (AT, eltypes)->begin
    eltypes = (ComplexF32, Float32)
    wrappers = (identity, UnitLowerTriangular, UnitUpperTriangular, LowerTriangular, UpperTriangular, Hermitian, Symmetric)

    @testset "UniformScaling $f $T1 $T2" for T1 in eltypes, T2 in eltypes, f in wrappers
        x = ones(T1, 5, 5)
        y = AT(x)

        xw = f(x)
        yw = f(y)

        J = one(T2) * I

        # TODO: remove @allowscalar as soon as there is a proper implementation for Symmetric / Hermitian
        @test @allowscalar collect(xw + J) ≈ collect(yw + J)

        # Missing methods in Base it seems... -(x - I) can be removed when Base supports (I - x)
        @test @allowscalar collect(-(xw - J)) ≈ collect(J - yw)
    end
end

# on-device array type

export AbstractDeviceArray


## device array

"""
    AbstractDeviceArray{T, N} <: DenseArray{T, N}

Supertype for `N`-dimensional GPU arrays (or array-like types) with elements of type `T`.
Instances of this type are expected to live on the device, see [`AbstractGPUArray`](@ref)
for host-side objects.
"""
abstract type AbstractDeviceArray{T, N} <: DenseArray{T, N} end

Base.IndexStyle(::AbstractDeviceArray) = IndexLinear()

@inline function Base.iterate(A::AbstractDeviceArray, i=1)
    if (i % UInt) - 1 < length(A)
        (@inbounds A[i], i + 1)
    else
        nothing
    end
end

function Base.sum(A::AbstractDeviceArray{T}) where T
    acc = zero(T)
    for elem in A
        acc += elem
    end
    acc
end

@testsuite "reductions/mapreducedim!_large" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        # Skip smaller floating types due to precision issues
        if ET in (Float16, ComplexF16)
            continue
        end

        range = ET <: Real ? (ET(1):ET(10)) : ET
        # Reduce larger array sizes to test multiple-element reading in certain implementations
        for (sz,red) in [(500000,)=>(1,), (1000,500)=>(1,1), (500,1000)=>(1,1),
                         (500,1000)=>(500,1), (1000,500)=>(1,500)]
            @test compare((A,R)->Base.mapreducedim!(identity, +, R, A), AT, rand(range, sz), zeros(ET, red))
        end
    end
end

@testsuite "reductions/mapreducedim!" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        range = ET <: Real ? (ET(1):ET(10)) : ET
        for (sz,red) in [(10,)=>(1,), (10,10)=>(1,1), (10,10,10)=>(1,1,1), (10,10,10)=>(10,10,10),
                         (10,10,10)=>(1,10,10), (10,10,10)=>(10,1,10), (10,10,10)=>(10,10,1),
                         (0,)=>(1,)]
            # mapreducedim!
            @test compare((A,R)->Base.mapreducedim!(identity, +, R, A), AT, rand(range, sz), zeros(ET, red))
            @test compare((A,R)->Base.mapreducedim!(identity, *, R, A), AT, rand(range, sz), ones(ET, red))
            @test compare((A,R)->Base.mapreducedim!(x->x+x, +, R, A), AT, rand(range, sz), zeros(ET, red))

            # reducedim!
            @test compare((A,R)->Base.reducedim!(+, R, A), AT, rand(range, sz), zeros(ET, red))
            @test compare((A,R)->Base.reducedim!(*, R, A), AT, rand(range, sz), ones(ET, red))
        end

        # implicit singleton dimensions
        @test compare((A,R)->Base.mapreducedim!(identity, +, R, A), AT, rand(range, (2,2)), zeros(ET, (2,)))
        @test compare((A,R)->Base.mapreducedim!(identity, +, R, A), AT, rand(range, (2,3)), zeros(ET, (2,)))

        # mapreducedim! into wrapper types
        for t in [transpose, adjoint]
            @test compare((A,R)->Base.mapreducedim!(identity, +, R, A), AT, rand(range, (2,2)), t(zeros(ET, (2,))))
            @test compare((A,R)->Base.mapreducedim!(abs2, +, R, A), AT, rand(range, (3,2,10)), t(zeros(ET, (2,3))))

            # TODO: reenable once https://github.com/JuliaGPU/Metal.jl/issues/907 is fixed
            # @test compare((A,R)->sum!(abs2, R, A), AT, rand(range, (3,2,10)), t(zeros(ET, (2,3))))

            A, R = AT(rand(range, (3,2,10))), t(AT(zeros(ET, (2,3))))
            @test Base.mapreducedim!(identity, *, R, A) === R
        end
    end
end

@testsuite "reductions/mapreduce" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        range = ET <: Real ? (ET(1):ET(10)) : ET
        for (sz,dims) in [(10,)=>[1], (10,10)=>[1,2], (10,10,10)=>[1,2,3], (10,10,10)=>[],
                          (10,)=>:, (10,10)=>:, (10,10,10)=>:,
                          (10,10,10)=>[1], (10,10,10)=>[2], (10,10,10)=>[3],
                          (0,)=>[1]]
            # mapreduce
            @test compare(A->mapreduce(identity, +, A; dims=dims, init=zero(ET)), AT, rand(range, sz))
            @test compare(A->mapreduce(identity, *, A; dims=dims, init=one(ET)), AT, rand(range, sz))
            @test compare(A->mapreduce(x->x+x, +, A; dims=dims, init=zero(ET)), AT, rand(range, sz))

            # reduce
            @test compare(A->reduce(+, A; dims=dims, init=zero(ET)), AT, rand(range, sz))
            @test compare(A->reduce(*, A; dims=dims, init=one(ET)), AT, rand(range, sz))
        end
    end
    # Test more corner cases. Tests from AcceleraterKernels.jl
    # Cover empty (size 0) and non-singleton (size 3) axes; the size-10 loop above
    # already covers the common non-edge shape.
    for dims in [1,2,3,4,[1,2],[1,3],[1,4],[2,3],[2,4],[3,4],[1,2,3],[1,2,4],[1,3,4],[2,3,4],[1,2,3,4]],
        isize in (0, 3), jsize in (0, 3), ksize in (0, 3)
        @test compare(A->mapreduce(x->x+x, +, A; init=zero(Int32), dims), AT, rand(Int32(1):Int32(10), isize, jsize, ksize))
        @test compare(A->reduce(+, A; init=zero(Int32), dims), AT, rand(Int32(1):Int32(10), isize, jsize, ksize))
    end
end

@testsuite "reductions/sum prod" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        range = ET <: Real ? (ET(1):ET(10)) : ET

        # whole-array reductions: exercise each unique shape only once
        for sz in ((10,), (10,10), (10,10,10), (0,))
            @test compare(A->sum(A), AT, rand(range, sz))
            @test compare(A->prod(A), AT, rand(range, sz))
            if typeof(abs(rand(range))) in eltypes
                # abs(::Complex{Int}) promotes to Float64
                @test compare(A->sum(abs, A), AT, rand(range, sz))
                @test compare(A->prod(abs, A), AT, rand(range, sz))
            end
        end

        # reductions along specific dims
        for (sz,dims) in [(10,)=>[1], (10,10)=>[1,2], (10,10,10)=>[1,2,3], (10,10,10)=>[],
                            (10,)=>:, (10,10)=>:, (10,10,10)=>:,
                            (10,10,10)=>[1], (10,10,10)=>[2], (10,10,10)=>[3],
                            (0,)=>[1]]
            @test compare(A->sum(A; dims=dims), AT, rand(range, sz))
            @test compare(A->prod(A; dims=dims), AT, rand(range, sz))
        end

        if ET in (Float32, Float64, Int64, ComplexF32, ComplexF64)
            # smaller-scale test to avoid very large values and roundoff issues
            for (sz,red) in [(2,)=>(1,), (2,2)=>(1,1), (2,2,2)=>(1,1,1), (2,2,2)=>(2,2,2),
                                (2,2,2)=>(1,2,2), (2,2,2)=>(2,1,2), (2,2,2)=>(2,2,1)]
                @test compare((A,R)->sum!(R, A), AT, rand(range, sz), rand(ET, red))
                @test compare((A,R)->prod!(R, A), AT, rand(range, sz), rand(ET, red))
            end
        end
    end
end

@testsuite "reductions/and or xor" (AT, eltypes)->begin
    @testset "$ET" for ET in filter(x -> x <: Integer, eltypes)
        range = ET <: Real ? (ET(1):ET(10)) : ET
        for (sz,dims) in [(10,)=>[1], (10,10)=>[1,2], (10,10,10)=>[1,2,3], (10,10,10)=>[],
                          (10,)=>:, (10,10)=>:, (10,10,10)=>:,
                          (10,10,10)=>[1], (10,10,10)=>[2], (10,10,10)=>[3],
                          (0,)=>[1]]
            @test compare(A->reduce(&, A; dims=dims, init=~zero(ET)), AT, rand(range, sz))
            @test compare(A->reduce(|, A; dims=dims, init=zero(ET)), AT, rand(range, sz))
            @test compare(A->reduce(⊻, A; dims=dims, init=zero(ET)), AT, rand(range, sz))
        end
    end
end

@testsuite "reductions/minimum maximum extrema" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        ET <: Complex && continue
        range = ET <: Real ? (ET(1):ET(10)) : ET

        # whole-array reductions: exercise each unique shape only once
        for sz in ((10,), (10,10), (10,10,10))
            @test compare(A->minimum(A), AT, rand(range, sz))
            @test compare(A->minimum(x->x*x, A), AT, rand(range, sz))
            @test compare(A->maximum(A), AT, rand(range, sz))
            @test compare(A->maximum(x->x*x, A), AT, rand(range, sz))
            @test compare(A->extrema(A), AT, rand(range, sz))
            @test compare(A->extrema(x->x*x, A), AT, rand(range, sz))
        end

        # reductions along specific dims
        for (sz,dims) in [(10,)=>[1], (10,10)=>[1,2], (10,10,10)=>[1,2,3], (10,10,10)=>[],
                          (10,)=>:, (10,10)=>:, (10,10,10)=>:,
                          (10,10,10)=>[1], (10,10,10)=>[2], (10,10,10)=>[3]]
            @test compare(A->minimum(A; dims=dims), AT, rand(range, sz))
            @test compare(A->maximum(A; dims=dims), AT, rand(range, sz))
            @test compare(A->extrema(A; dims=dims), AT, rand(range, sz))
        end

        for (sz,red) in [(10,)=>(1,), (10,10)=>(1,1), (10,10,10)=>(1,1,1), (10,10,10)=>(10,10,10),
                         (10,10,10)=>(1,10,10), (10,10,10)=>(10,1,10), (10,10,10)=>(10,10,1)]
            @test compare((A,R)->minimum!(R, A), AT, rand(range, sz), fill(typemax(ET), red))
            @test compare((A,R)->maximum!(R, A), AT, rand(range, sz), fill(typemin(ET), red))
            @test compare((A,R)->extrema!(R, A), AT, rand(range, sz), fill((typemax(ET),typemin(ET)), red))
        end
    end
end

@testsuite "reductions/any all count" (AT, eltypes)->begin
    for Ac in ([false, false], [false, true], [true, true],
                [false false; false false], [false true; false false],
                [true true; false false], [true true; true true])
        @test compare(A->any(A), AT, Ac)
        @test compare(A->all(A), AT, Ac)
        @test compare(A->count(A), AT, Ac)

        if ndims(Ac) > 1
            @test compare(A->any(A; dims=2), AT, Ac)
            @test compare(A->all(A; dims=2), AT, Ac)
            @test compare(A->count(A; dims=2), AT, Ac)
        end
    end
    for Ac in ([1, 1], [1, 2], [2, 2],
                [1 1; 1 1], [1 2; 1 1],
                [2 2; 1 1], [2 2; 2 2])
        @test compare(A->any(iseven, A), AT, Ac)
        @test compare(A->all(iseven, A), AT, Ac)
        @test compare(A->count(iseven, A), AT, Ac)

        if ndims(Ac) > 1
            @test compare(A->any(iseven, A; dims=2), AT, Ac)
            @test compare(A->all(iseven, A; dims=2), AT, Ac)
            @test compare(A->count(iseven, A; dims=2), AT, Ac)
        end

        A = AT(Ac)
        @test A == copy(A)
        @test A !== copy(A)
        @test A == deepcopy(A)
        @test A !== deepcopy(A)

        B = similar(A)
        @allowscalar B[1] = 3
        @test A != B
    end
end

@testsuite "reductions/== isequal" (AT, eltypes)->begin
    @testset "$ET" for ET in eltypes
        range = ET <: Real ? (ET(1):ET(10)) : ET

        # different sizes should trip up both (CUDA.jl#1524)
        @test compare((A, B) -> A == B, AT, rand(range, (2,3)), rand(range, 6))
        @test compare((A, B) -> isequal(A, B), AT, rand(range, (2,3)), rand(range, 6))

        # equal sizes depend on values
        for sz in [(10,), (10,10), (10,10,10), (0,)]
            @test compare((A, B) -> A == B, AT, rand(range, sz), rand(range, sz))
            @test compare((A, B) -> isequal(A, B), AT, rand(range, sz), rand(range, sz))
            Ac = rand(range, sz)
            @test compare((A, B) -> A == B, AT, Ac, Ac)
            @test compare((A, B) -> isequal(A, B), AT, Ac, Ac)
            if isfloattype(ET) && length(Ac) > 0
                # Test cases where == and isequal behave differently
                Bc = copy(Ac)
                # 0.0 == -0.0 but !isequal(0.0, -0.0)
                Ac[1] = zero(ET)
                Bc[1] = -zero(ET)
                @test compare((A, B) -> A == B, AT, Ac, Bc)
                @test compare((A, B) -> isequal(A, B), AT, Ac, Bc)
                # NaN != NaN but isequal(NaN, NaN)
                Ac[1] = Bc[1] = ET(NaN)
                @test compare((A, B) -> A == B, AT, Ac, Bc)
                @test compare((A, B) -> isequal(A, B), AT, Ac, Bc)
            end
        end
    end

    # missing values should only trip up ==
    @test compare((A, B) -> A == B, AT, [missing], [missing])
    @test compare((A, B) -> isequal(A, B), AT, [missing], [missing])
end

using LinearAlgebra
using LinearAlgebra: BlasFloat

abstract type AbstractGPUSparseArray{Tv, Ti, N} <: AbstractSparseArray{Tv, Ti, N} end
const AbstractGPUSparseVector{Tv, Ti} = AbstractGPUSparseArray{Tv, Ti, 1}
const AbstractGPUSparseMatrix{Tv, Ti} = AbstractGPUSparseArray{Tv, Ti, 2}

abstract type AbstractGPUSparseMatrixCSC{Tv, Ti} <: AbstractGPUSparseArray{Tv, Ti, 2} end
abstract type AbstractGPUSparseMatrixCSR{Tv, Ti} <: AbstractGPUSparseArray{Tv, Ti, 2} end
abstract type AbstractGPUSparseMatrixCOO{Tv, Ti} <: AbstractGPUSparseArray{Tv, Ti, 2} end
abstract type AbstractGPUSparseMatrixBSR{Tv, Ti} <: AbstractGPUSparseArray{Tv, Ti, 2} end

const AbstractGPUSparseVecOrMat = Union{AbstractGPUSparseVector,AbstractGPUSparseMatrix}

SparseArrays.nnz(g::T) where {T<:AbstractGPUSparseArray} = g.nnz
SparseArrays.nonzeros(g::T) where {T<:AbstractGPUSparseArray} = g.nzVal

SparseArrays.nonzeroinds(g::T) where {T<:AbstractGPUSparseVector} = g.iPtr
SparseArrays.rowvals(g::T) where {T<:AbstractGPUSparseVector} = SparseArrays.nonzeroinds(g)

SparseArrays.rowvals(g::AbstractGPUSparseMatrixCSC) = g.rowVal
SparseArrays.getcolptr(S::AbstractGPUSparseMatrixCSC) = S.colPtr

Base.convert(T::Type{<:AbstractGPUSparseArray}, m::AbstractArray) = m isa T ? m : T(m)

# collect to Array
Base.collect(x::AbstractGPUSparseVector) = collect(SparseVector(x))
Base.collect(x::AbstractGPUSparseMatrixCSC) = collect(SparseMatrixCSC(x))
Base.collect(x::AbstractGPUSparseMatrixCSR) = collect(SparseMatrixCSC(x))
Base.collect(x::AbstractGPUSparseMatrixBSR) = collect(SparseMatrixCSC(x))
Base.collect(x::AbstractGPUSparseMatrixCOO) = collect(SparseMatrixCSC(x))

Base.Array(x::AbstractGPUSparseVector)    = collect(SparseVector(x))
Base.Array(x::AbstractGPUSparseMatrixCSC) = collect(SparseMatrixCSC(x))
Base.Array(x::AbstractGPUSparseMatrixCSR) = collect(SparseMatrixCSC(x))
Base.Array(x::AbstractGPUSparseMatrixBSR) = collect(SparseMatrixCSC(x))
Base.Array(x::AbstractGPUSparseMatrixCOO) = collect(SparseMatrixCSC(x))

# iszero that avoids scalar indexing by using GPU-compatible reduction
# nnz(A) == 0 means no stored elements, so it's definitely zero
# all(iszero, nonzeros(A)) uses GPU reduction to check stored values
Base.iszero(A::AbstractGPUSparseArray) = SparseArrays.nnz(A) == 0 || all(iszero, SparseArrays.nonzeros(A))

SparseArrays.SparseVector(x::AbstractGPUSparseVector) = SparseVector(length(x), Array(SparseArrays.nonzeroinds(x)), Array(SparseArrays.nonzeros(x)))
SparseArrays.SparseMatrixCSC(x::AbstractGPUSparseMatrixCSC) = SparseMatrixCSC(size(x)..., Array(SparseArrays.getcolptr(x)), Array(SparseArrays.rowvals(x)), Array(SparseArrays.nonzeros(x)))

# similar
Base.similar(Vec::V) where {V<:AbstractGPUSparseVector} = V(copy(SparseArrays.nonzeroinds(Vec)), similar(SparseArrays.nonzeros(Vec)), length(Vec))
Base.similar(Mat::M) where {M<:AbstractGPUSparseMatrixCSC} = M(copy(SparseArrays.getcolptr(Mat)), copy(SparseArrays.rowvals(Mat)), similar(SparseArrays.nonzeros(Mat)), size(Mat))

Base.similar(Vec::V, T::Type) where {Tv, Ti, V<:AbstractGPUSparseVector{Tv, Ti}} = sparse_array_type(V){T, Ti}(copy(SparseArrays.nonzeroinds(Vec)), similar(SparseArrays.nonzeros(Vec), T), length(Vec))
Base.similar(Mat::M, T::Type) where {M<:AbstractGPUSparseMatrixCSC} = sparse_array_type(M)(copy(SparseArrays.getcolptr(Mat)), copy(SparseArrays.rowvals(Mat)), similar(SparseArrays.nonzeros(Mat), T), size(Mat))

dense_array_type(sa::SparseVector)     = SparseVector
dense_array_type(::Type{SparseVector}) = SparseVector
sparse_array_type(sa::SparseVector) = SparseVector
dense_vector_type(sa::AbstractSparseArray) = Vector
dense_vector_type(sa::AbstractArray)       = Vector
dense_vector_type(::Type{<:AbstractSparseArray}) = Vector
dense_vector_type(::Type{<:AbstractArray})       = Vector
dense_array_type(sa::SparseMatrixCSC)     = SparseMatrixCSC
dense_array_type(::Type{SparseMatrixCSC}) = SparseMatrixCSC
sparse_array_type(sa::SparseMatrixCSC)    = SparseMatrixCSC

function sparse_array_type(sa::AbstractGPUSparseArray) end
function dense_array_type(sa::AbstractGPUSparseArray) end
function coo_type(sa::AbstractGPUSparseArray) end
coo_type(::SA) where {SA<:AbstractGPUSparseMatrixCSC} = SA

function _spadjoint end
function _sptranspose end

function LinearAlgebra.opnorm(A::AbstractGPUSparseMatrixCSR, p::Real=2)
    if p == Inf
        return maximum(sum(abs, A; dims=2))
    elseif p == 1
        return maximum(sum(abs, A; dims=1))
    else
        throw(ArgumentError("p=$p is not supported"))
    end
end

LinearAlgebra.opnorm(A::AbstractGPUSparseMatrixCSC, p::Real=2) = opnorm(csr_type(A)(A), p)

function LinearAlgebra.norm(A::AbstractGPUSparseMatrix{T}, p::Real=2) where T
    if p == Inf
        return maximum(abs.(SparseArrays.nonzeros(A)))
    elseif p == -Inf
        return minimum(abs.(SparseArrays.nonzeros(A)))
    elseif p == 0
        return Float64(SparseArrays.nnz(A))
    else
        return sum(abs.(SparseArrays.nonzeros(A)).^p)^(1/p)
    end
end

function SparseArrays.findnz(S::MT) where {MT <: AbstractGPUSparseMatrix}
    S2 = coo_type(MT)(S)
    I = S2.rowInd
    J = S2.colInd
    V = S2.nzVal

    # To make it compatible with the SparseArrays.jl version
    idxs = sortperm(J)
    I = I[idxs]
    J = J[idxs]
    V = V[idxs]

    return (I, J, V)
end

### WRAPPED ARRAYS
LinearAlgebra.issymmetric(M::Union{AbstractGPUSparseMatrixCSC,AbstractGPUSparseMatrixCSR}) = size(M, 1) == size(M, 2) ? norm(M - transpose(M), Inf) == 0 : false
LinearAlgebra.ishermitian(M::Union{AbstractGPUSparseMatrixCSC,AbstractGPUSparseMatrixCSR}) = size(M, 1) == size(M, 2) ? norm(M - adjoint(M), Inf) == 0 : false

LinearAlgebra.istriu(M::UpperTriangular{T,S}) where {T<:BlasFloat, S<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}} = true
LinearAlgebra.istril(M::UpperTriangular{T,S}) where {T<:BlasFloat, S<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}} = false
LinearAlgebra.istriu(M::LowerTriangular{T,S}) where {T<:BlasFloat, S<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}} = false
LinearAlgebra.istril(M::LowerTriangular{T,S}) where {T<:BlasFloat, S<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}} = true

Hermitian{T}(Mat::AbstractGPUSparseMatrix{T}) where {T} = Hermitian{eltype(Mat),typeof(Mat)}(Mat,'U')

# work around upstream breakage from JuliaLang/julia#55547
@static if VERSION >= v"1.11.2"
    const GPUSparseUpperOrUnitUpperTriangular = LinearAlgebra.UpperOrUnitUpperTriangular{
        <:Any,<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}}
    const GPUSparseLowerOrUnitLowerTriangular = LinearAlgebra.LowerOrUnitLowerTriangular{
        <:Any,<:Union{<:AbstractGPUSparseMatrix, Adjoint{<:Any, <:AbstractGPUSparseMatrix}, Transpose{<:Any, <:AbstractGPUSparseMatrix}}}
    LinearAlgebra.istriu(::GPUSparseUpperOrUnitUpperTriangular) = true
    LinearAlgebra.istril(::GPUSparseUpperOrUnitUpperTriangular) = false
    LinearAlgebra.istriu(::GPUSparseLowerOrUnitLowerTriangular) = false
    LinearAlgebra.istril(::GPUSparseLowerOrUnitLowerTriangular) = true
end

for SparseMatrixType in [:AbstractGPUSparseMatrixCSC, :AbstractGPUSparseMatrixCSR]
    @eval begin
        LinearAlgebra.triu(A::ST, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( triu(coo_type(A)(A), k) )
        LinearAlgebra.triu(A::Transpose{T,<:ST}, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( triu(coo_type(A)(_sptranspose(parent(A))), k) )
        LinearAlgebra.triu(A::Adjoint{T,<:ST}, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( triu(coo_type(A)(_spadjoint(parent(A))), k) )

        LinearAlgebra.tril(A::ST, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( tril(coo_type(A)(A), k) )
        LinearAlgebra.tril(A::Transpose{T,<:ST}, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( tril(coo_type(A)(_sptranspose(parent(A))), k) )
        LinearAlgebra.tril(A::Adjoint{T,<:ST}, k::Integer) where {T, ST<:$SparseMatrixType{T}} =
            ST( tril(coo_type(A)(_spadjoint(parent(A))), k) )

        LinearAlgebra.triu(A::Union{ST, Transpose{T,<:ST}, Adjoint{T,<:ST}}) where {T, ST<:$SparseMatrixType{T}} =
            ST( triu(coo_type(A)(A), 0) )
        LinearAlgebra.tril(A::Union{ST,Transpose{T,<:ST}, Adjoint{T,<:ST}}) where {T, ST<:$SparseMatrixType{T}} =
            ST( tril(coo_type(A)(A), 0) )

        LinearAlgebra.kron(A::ST, B::ST) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(A), coo_type(B)(B)) )
        LinearAlgebra.kron(A::ST, B::Diagonal) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(A), B) )
        LinearAlgebra.kron(A::Diagonal, B::ST) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(A, coo_type(B)(B)) )

        LinearAlgebra.kron(A::Transpose{T,<:ST}, B::ST) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(_sptranspose(parent(A))), coo_type(B)(B)) )
        LinearAlgebra.kron(A::ST, B::Transpose{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(A), coo_type(parent(B))(_sptranspose(parent(B)))) )
        LinearAlgebra.kron(A::Transpose{T,<:ST}, B::Transpose{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(_sptranspose(parent(A))), coo_type(parent(B))(_sptranspose(parent(B)))) )
        LinearAlgebra.kron(A::Transpose{T,<:ST}, B::Diagonal) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(_sptranspose(parent(A))), B) )
        LinearAlgebra.kron(A::Diagonal, B::Transpose{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(A, coo_type(B)(_sptranspose(parent(B)))) )

        LinearAlgebra.kron(A::Adjoint{T,<:ST}, B::ST) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(_spadjoint(parent(A))), coo_type(B)(B)) )
        LinearAlgebra.kron(A::ST, B::Adjoint{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(A)(A), coo_type(parent(B))(_spadjoint(parent(B)))) )
        LinearAlgebra.kron(A::Adjoint{T,<:ST}, B::Adjoint{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(parent(A))(_spadjoint(parent(A))), coo_type(parent(B))(_spadjoint(parent(B)))) )
        LinearAlgebra.kron(A::Adjoint{T,<:ST}, B::Diagonal) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(coo_type(parent(A))(_spadjoint(parent(A))), B) )
        LinearAlgebra.kron(A::Diagonal, B::Adjoint{T,<:ST}) where {T, ST<:$SparseMatrixType{T}} =
            ST( kron(A, coo_type(parent(B))(_spadjoint(parent(B)))) )


        function Base.reshape(A::ST, dims::Dims) where {ST<:$SparseMatrixType}
            B = coo_type(A)(A)
            ST(reshape(B, dims))
        end

        function SparseArrays.droptol!(A::ST, tol::Real) where {ST<:$SparseMatrixType}
            B = coo_type(A)(A)
            droptol!(B, tol)
            copyto!(A, ST(B))
        end

        function LinearAlgebra.exp(A::ST; threshold = 1e-7, nonzero_tol = 1e-14) where {ST<:$SparseMatrixType}
            rows = LinearAlgebra.checksquare(A) # Throws exception if not square
            typeA = eltype(A)

            mat_norm = norm(A, Inf)
            scaling_factor = nextpow(2, mat_norm) # Native routine, faster
            A = A ./ scaling_factor
            delta = 1

            diag_vec = similar(SparseArrays.nonzeros(A), rows)
            fill!(diag_vec, one(eltype(A)))
            P = ST(spdiagm(0 => diag_vec))
            next_term = P
            n = 1

            while delta > threshold
                next_term = typeA(1 / n) * A * next_term
                droptol!(next_term, nonzero_tol)
                delta = norm(next_term, Inf)
                copyto!(P, P + next_term)
                n = n + 1
            end
            for n = 1:log2(scaling_factor)
                P = P * P;
                if nnz(P) / length(P) < 0.25
                    droptol!(P, nonzero_tol)
                end
            end
            P
        end
    end
end


### INDEXING
Base.getindex(A::AbstractGPUSparseVector, ::Colon)          = copy(A)
Base.getindex(A::AbstractGPUSparseMatrix, ::Colon, ::Colon) = copy(A)
Base.getindex(A::AbstractGPUSparseMatrix, i, ::Colon)       = getindex(A, i, 1:size(A, 2))
Base.getindex(A::AbstractGPUSparseMatrix, ::Colon, i)       = getindex(A, 1:size(A, 1), i)
Base.getindex(A::AbstractGPUSparseMatrix, I::Tuple{Integer,Integer}) = getindex(A, I[1], I[2])

function Base.getindex(A::AbstractGPUSparseVector{Tv, Ti}, i::Integer) where {Tv, Ti}
    @boundscheck checkbounds(A, i)
    ii = searchsortedfirst(SparseArrays.nonzeroinds(A), convert(Ti, i))
    (ii > SparseArrays.nnz(A) || SparseArrays.nonzeroinds(A)[ii] != i) && return zero(Tv)
    SparseArrays.nonzeros(A)[ii]
end

function Base.getindex(A::AbstractGPUSparseMatrixCSC{T}, i0::Integer, i1::Integer) where T
    @boundscheck checkbounds(A, i0, i1)
    r1 = Int(SparseArrays.getcolptr(A)[i1])
    r2 = Int(SparseArrays.getcolptr(A)[i1+1]-1)
    (r1 > r2) && return zero(T)
    r1 = searchsortedfirst(SparseArrays.rowvals(A), i0, r1, r2, Base.Order.Forward)
    (r1 > r2 || SparseArrays.rowvals(A)[r1] != i0) && return zero(T)
    SparseArrays.nonzeros(A)[r1]
end

## copying between sparse GPU arrays
Base.copy(Vec::AbstractGPUSparseVector) = copyto!(similar(Vec), Vec)

function Base.copyto!(dst::AbstractGPUSparseVector, src::AbstractGPUSparseVector)
    if length(dst) != length(src)
        throw(ArgumentError("Inconsistent Sparse Vector size"))
    end
    resize!(SparseArrays.nonzeroinds(dst), length(SparseArrays.nonzeroinds(src)))
    resize!(SparseArrays.nonzeros(dst), length(SparseArrays.nonzeros(src)))
    copyto!(SparseArrays.nonzeroinds(dst), SparseArrays.nonzeroinds(src))
    copyto!(SparseArrays.nonzeros(dst), SparseArrays.nonzeros(src))
    dst.nnz = src.nnz
    dst
end

function Base.copyto!(dst::AbstractGPUSparseMatrixCSC, src::AbstractGPUSparseMatrixCSC)
    if size(dst) != size(src)
        throw(ArgumentError("Inconsistent Sparse Matrix size"))
    end
    resize!(SparseArrays.getcolptr(dst), length(SparseArrays.getcolptr(src)))
    resize!(SparseArrays.rowvals(dst), length(SparseArrays.rowvals(src)))
    resize!(SparseArrays.nonzeros(dst), length(SparseArrays.nonzeros(src)))
    copyto!(SparseArrays.getcolptr(dst), SparseArrays.getcolptr(src))
    copyto!(SparseArrays.rowvals(dst), SparseArrays.rowvals(src))
    copyto!(SparseArrays.nonzeros(dst), SparseArrays.nonzeros(src))
    dst.nnz = src.nnz
    dst
end

### BROADCAST

# broadcast container type promotion for combinations of sparse arrays and other types
struct GPUSparseVecStyle <: Broadcast.AbstractArrayStyle{1} end
struct GPUSparseMatStyle <: Broadcast.AbstractArrayStyle{2} end
Broadcast.BroadcastStyle(::Type{<:AbstractGPUSparseVector}) = GPUSparseVecStyle()
Broadcast.BroadcastStyle(::Type{<:AbstractGPUSparseMatrix}) = GPUSparseMatStyle()
const SPVM = Union{GPUSparseVecStyle,GPUSparseMatStyle}

# GPUSparseVecStyle handles 0-1 dimensions, GPUSparseMatStyle 0-2 dimensions.
# GPUSparseVecStyle promotes to GPUSparseMatStyle for 2 dimensions.
# Fall back to DefaultArrayStyle for higher dimensionality.
GPUSparseVecStyle(::Val{0}) = GPUSparseVecStyle()
GPUSparseVecStyle(::Val{1}) = GPUSparseVecStyle()
GPUSparseVecStyle(::Val{2}) = GPUSparseMatStyle()
GPUSparseVecStyle(::Val{N}) where N = Broadcast.DefaultArrayStyle{N}()
GPUSparseMatStyle(::Val{0}) = GPUSparseMatStyle()
GPUSparseMatStyle(::Val{1}) = GPUSparseMatStyle()
GPUSparseMatStyle(::Val{2}) = GPUSparseMatStyle()
GPUSparseMatStyle(::Val{N}) where N = Broadcast.DefaultArrayStyle{N}()

Broadcast.BroadcastStyle(::GPUSparseVecStyle, ::AbstractGPUArrayStyle{1}) = GPUSparseVecStyle()
Broadcast.BroadcastStyle(::GPUSparseVecStyle, ::AbstractGPUArrayStyle{2}) = GPUSparseMatStyle()
Broadcast.BroadcastStyle(::GPUSparseMatStyle, ::AbstractGPUArrayStyle{2}) = GPUSparseMatStyle()

# don't wrap sparse arrays with Extruded
Broadcast.extrude(x::AbstractGPUSparseVecOrMat) = x

## detection of zero-preserving functions

# modified from SparseArrays.jl

# capturescalars takes a function (f) and a tuple of broadcast arguments, and returns a
# partially-evaluated function and a reduced argument tuple where all scalar operations have
# been applied already.
@inline function capturescalars(f, mixedargs)
    let (passedsrcargstup, makeargs) = _capturescalars(mixedargs...)
        parevalf = (passed...) -> f(makeargs(passed...)...)
        return (parevalf, passedsrcargstup)
    end
end

## sparse broadcast style

# Work around losing Type{T}s as DataTypes within the tuple that makeargs creates
@inline capturescalars(f, mixedargs::Tuple{Ref{Type{T}}, Vararg{Any}}) where {T} =
    capturescalars((args...)->f(T, args...), Base.tail(mixedargs))
@inline capturescalars(f, mixedargs::Tuple{Ref{Type{T}}, Ref{Type{S}}, Vararg{Any}}) where {T, S} =
    # This definition is identical to the one above and necessary only for
    # avoiding method ambiguity.
    capturescalars((args...)->f(T, args...), Base.tail(mixedargs))
@inline capturescalars(f, mixedargs::Tuple{AbstractGPUSparseVecOrMat, Ref{Type{T}}, Vararg{Any}}) where {T} =
    capturescalars((a1, args...)->f(a1, T, args...), (mixedargs[1], Base.tail(Base.tail(mixedargs))...))
@inline capturescalars(f, mixedargs::Tuple{Union{Ref,AbstractArray{<:Any,0}}, Ref{Type{T}}, Vararg{Any}}) where {T} =
    capturescalars((args...)->f(mixedargs[1], T, args...), Base.tail(Base.tail(mixedargs)))

scalararg(::Number) = true
scalararg(::Any) = false
scalarwrappedarg(::Union{AbstractArray{<:Any,0},Ref}) = true
scalarwrappedarg(::Any) = false

@inline function _capturescalars()
    return (), () -> ()
end
@inline function _capturescalars(arg, mixedargs...)
    let (rest, f) = _capturescalars(mixedargs...)
        if scalararg(arg)
            return rest, @inline function(tail...)
                (arg, f(tail...)...)
            end # add back scalararg after (in makeargs)
        elseif scalarwrappedarg(arg)
            return rest, @inline function(tail...)
                (arg[], f(tail...)...) # TODO: This can put a Type{T} in a tuple
            end # unwrap and add back scalararg after (in makeargs)
        else
            return (arg, rest...), @inline function(head, tail...)
                (head, f(tail...)...)
            end # pass-through to broadcast
        end
    end
end
@inline function _capturescalars(arg) # this definition is just an optimization (to bottom out the recursion slightly sooner)
    if scalararg(arg)
        return (), () -> (arg,) # add scalararg
    elseif scalarwrappedarg(arg)
        return (), () -> (arg[],) # unwrap
    else
        return (arg,), (head,) -> (head,) # pass-through
    end
end

@inline _iszero(x) = x == 0
@inline _iszero(x::Number) = Base.iszero(x)
@inline _iszero(x::AbstractArray) = Base.iszero(x)
@inline _zeros_eltypes(A) = (zero(eltype(A)),)
@inline _zeros_eltypes(A, Bs...) = (zero(eltype(A)), _zeros_eltypes(Bs...)...)

## COV_EXCL_START
## iteration helpers

"""
    CSRIterator{Ti}(row, args...)

A GPU-compatible iterator for accessing the elements of a single row `row` of several CSR
matrices `args` in one go. The row should be in-bounds for every sparse argument. Each
iteration returns a 2-element tuple: The current column, and each arguments' pointer index
(or 0 if that input didn't have an element at that column). The pointers can then be used to
access the elements themselves.

For convenience, this iterator can be passed non-sparse arguments as well, which will be
ignored (with the returned `col`/`ptr` values set to 0).
"""
struct CSRIterator{Ti,N,ATs}
    row::Ti
    col_ends::NTuple{N, Ti}
    args::ATs
end

function CSRIterator{Ti}(row, args::Vararg{Any, N}) where {Ti,N}
    # check that `row` is valid for all arguments
    @boundscheck begin
        ntuple(Val(N)) do i
            arg = @inbounds args[i]
            arg isa GPUSparseDeviceMatrixCSR && checkbounds(arg, row, 1)
        end
    end

    col_ends = ntuple(Val(N)) do i
        arg = @inbounds args[i]
        if arg isa GPUSparseDeviceMatrixCSR
            @inbounds(arg.rowPtr[row+1])
        else
            zero(Ti)
        end
    end

    CSRIterator{Ti, N, typeof(args)}(row, col_ends, args)
end

@inline function Base.iterate(iter::CSRIterator{Ti,N}, state=nothing) where {Ti,N}
    # helper function to get the column of a sparse array at a specific pointer
    @inline function get_col(i, ptr)
        arg = @inbounds iter.args[i]
        if arg isa GPUSparseDeviceMatrixCSR
            col_end = @inbounds iter.col_ends[i]
            if ptr < col_end
                return @inbounds arg.colVal[ptr] % Ti
            end
        end
        typemax(Ti)
    end

    # initialize the state
    # - ptr: the current index into the colVal/nzVal arrays
    # - col: the current column index (cached so that we don't have to re-read each time)
    state = something(state,
        ntuple(Val(N)) do i
            arg = @inbounds iter.args[i]
            if arg isa GPUSparseDeviceMatrixCSR
                ptr = @inbounds iter.args[i].rowPtr[iter.row] % Ti
                col = @inbounds get_col(i, ptr)
            else
                ptr = typemax(Ti)
                col = typemax(Ti)
            end
            (; ptr, col)
        end
    )

    # determine the column we're currently processing
    cols = ntuple(i -> @inbounds(state[i].col), Val(N))
    cur_col = min(cols...)
    cur_col == typemax(Ti) && return

    # fetch the pointers (we don't look up the values, as the caller might want to index
    # the sparse array directly, e.g., to mutate it). we don't return `ptrs` from the state
    # directly, but first convert the `typemax(Ti)` to a more convenient zero value.
    # NOTE: these values may end up unused by the caller (e.g. in the count_nnzs kernels),
    #       but LLVM appears smart enough to filter them away.
    ptrs = ntuple(Val(N)) do i
        ptr, col = @inbounds state[i]
        col == cur_col ? ptr : zero(Ti)
    end

    # advance the state
    new_state = ntuple(Val(N)) do i
        ptr, col = @inbounds state[i]
        if col == cur_col
            ptr += one(Ti)
            col = get_col(i, ptr)
        end
        (; ptr, col)
    end

    return (cur_col, ptrs), new_state
end

struct CSCIterator{Ti,N,ATs}
    col::Ti
    row_ends::NTuple{N, Ti}
    args::ATs
end

function CSCIterator{Ti}(col, args::Vararg{Any, N}) where {Ti,N}
    # check that `col` is valid for all arguments
    @boundscheck begin
        ntuple(Val(N)) do i
            arg = @inbounds args[i]
            arg isa GPUSparseDeviceMatrixCSR && checkbounds(arg, 1, col)
        end
    end

    row_ends = ntuple(Val(N)) do i
        arg = @inbounds args[i]
        x = if arg isa GPUSparseDeviceMatrixCSC
            @inbounds(arg.colPtr[col+1])
        else
            zero(Ti)
        end
        x
    end

    CSCIterator{Ti, N, typeof(args)}(col, row_ends, args)
end

@inline function Base.iterate(iter::CSCIterator{Ti,N}, state=nothing) where {Ti,N}
    # helper function to get the column of a sparse array at a specific pointer
    @inline function get_col(i, ptr)
        arg = @inbounds iter.args[i]
        if arg isa GPUSparseDeviceMatrixCSC
            col_end = @inbounds iter.row_ends[i]
            if ptr < col_end
                return @inbounds arg.rowVal[ptr] % Ti
            end
        end
        typemax(Ti)
    end

    # initialize the state
    # - ptr: the current index into the rowVal/nzVal arrays
    # - row: the current row index (cached so that we don't have to re-read each time)
    state = something(state,
        ntuple(Val(N)) do i
            arg = @inbounds iter.args[i]
            if arg isa GPUSparseDeviceMatrixCSC
                ptr = @inbounds iter.args[i].colPtr[iter.col] % Ti
                row = @inbounds get_col(i, ptr)
            else
                ptr = typemax(Ti)
                row = typemax(Ti)
            end
            (; ptr, row)
        end
    )

    # determine the row we're currently processing
    rows = ntuple(i -> @inbounds(state[i].row), Val(N))
    cur_row = min(rows...)
    cur_row == typemax(Ti) && return

    # fetch the pointers (we don't look up the values, as the caller might want to index
    # the sparse array directly, e.g., to mutate it). we don't return `ptrs` from the state
    # directly, but first convert the `typemax(Ti)` to a more convenient zero value.
    # NOTE: these values may end up unused by the caller (e.g. in the count_nnzs kernels),
    #       but LLVM appears smart enough to filter them away.
    ptrs = ntuple(Val(N)) do i
        ptr, row = @inbounds state[i]
        row == cur_row ? ptr : zero(Ti)
    end

    # advance the state
    new_state = ntuple(Val(N)) do i
        ptr, row = @inbounds state[i]
        if row == cur_row
            ptr += one(Ti)
            row = get_col(i, ptr)
        end
        (; ptr, row)
    end

    return (cur_row, ptrs), new_state
end

# helpers to index a sparse or dense array
function _getindex(arg::Union{<:GPUSparseDeviceMatrixCSR,GPUSparseDeviceMatrixCSC}, I, ptr)
    if ptr == 0
        zero(eltype(arg))
    else
        @inbounds arg.nzVal[ptr]
    end
end
@inline function _getindex(arg::DenseArray{Tv}, I, ptr)::Tv where {Tv}
    return @inbounds arg[I]::Tv
end
@inline _getindex(arg, I, ptr) = Broadcast._broadcast_getindex(arg, I)

## sparse broadcast implementation
iter_type(::Type{<:AbstractGPUSparseMatrixCSC}, ::Type{Ti}) where {Ti} = CSCIterator{Ti}
iter_type(::Type{<:AbstractGPUSparseMatrixCSR}, ::Type{Ti}) where {Ti} = CSRIterator{Ti}
iter_type(::Type{<:GPUSparseDeviceMatrixCSC}, ::Type{Ti}) where {Ti} = CSCIterator{Ti}
iter_type(::Type{<:GPUSparseDeviceMatrixCSR}, ::Type{Ti}) where {Ti} = CSRIterator{Ti}

_has_row(A, offsets, row, fpreszeros::Bool) = fpreszeros ? 0 : row
_has_row(A::AbstractDeviceArray, offsets, row, ::Bool) = row
function _has_row(A::GPUSparseDeviceVector, offsets, row, ::Bool)
    for row_ix in 1:length(A.iPtr)
        arg_row = @inbounds A.iPtr[row_ix]
        arg_row == row && return row_ix
        arg_row > row && break
    end
    return 0
end

@kernel function compute_offsets_kernel(::Type{<:AbstractGPUSparseVector}, first_row::Ti, last_row::Ti,
                                        fpreszeros::Bool, offsets::AbstractVector{Pair{Ti, NTuple{N, Ti}}},
                                        args...) where {Ti, N}
    my_ix = @index(Global, Linear)
    row = my_ix + first_row - one(eltype(my_ix))
    if row ≤ last_row
        # TODO load arg.iPtr slices into shared memory
        arg_row_is_nnz = ntuple(Val(N)) do i
            arg = @inbounds args[i]
            _has_row(arg, offsets, row, fpreszeros)
        end
        row_is_nnz = 0
        for i in 1:N
            row_is_nnz |= @inbounds arg_row_is_nnz[i]
        end
        key = (row_is_nnz == 0) ? typemax(Ti) : row
        @inbounds offsets[my_ix] = key => arg_row_is_nnz
    end
end

# kernel to count the number of non-zeros in a row, to determine the row offsets
@kernel function compute_offsets_kernel(T::Type{<:Union{AbstractGPUSparseMatrixCSR, AbstractGPUSparseMatrixCSC}},
                                        offsets::AbstractVector{Ti}, args...) where Ti
    # every thread processes an entire row
    leading_dim = @index(Global, Linear)
    if leading_dim ≤ length(offsets)-1 
        iter = @inbounds iter_type(T, Ti)(leading_dim, args...)

        # count the nonzero leading_dims of all inputs
        accum = zero(Ti)
        for (leading_dim, vals) in iter
            accum += one(Ti)
        end

        # the way we write the nnz counts is a bit strange, but done so that the result
        # after accumulation can be directly used as the rowPtr/colPtr array of a CSR/CSC matrix.
        @inbounds begin
            if leading_dim == 1
                offsets[1] = 1
            end
            offsets[leading_dim+1] = accum
        end
    end
end

@kernel function sparse_to_sparse_broadcast_kernel(f::F, output::GPUSparseDeviceVector{Tv,Ti},
                                                   offsets::AbstractVector{Pair{Ti, NTuple{N, Ti}}},
                                                   args...) where {Tv, Ti, N, F}
    row_ix = @index(Global, Linear)
    if row_ix ≤ output.nnz
        row_and_ptrs = @inbounds offsets[row_ix]
        row          = @inbounds row_and_ptrs[1]
        arg_ptrs     = @inbounds row_and_ptrs[2]
        vals = ntuple(Val(N)) do i
            @inline
            arg = @inbounds args[i]
            # ptr is 0 if the sparse vector doesn't have an element at this row
            # ptr is 0 if the arg is a scalar AND f preserves zeros
            ptr = @inbounds arg_ptrs[i]
            _getindex(arg, row, ptr)
        end
        output_val = f(vals...)
        @inbounds output.iPtr[row_ix]  = row
        @inbounds output.nzVal[row_ix] = output_val
    end
end

@kernel function sparse_to_sparse_broadcast_kernel(f, output::T, offsets::Union{<:AbstractArray,Nothing},
                                                   args...) where {Ti, T<:Union{GPUSparseDeviceMatrixCSR{<:Any,Ti},
                                                                                GPUSparseDeviceMatrixCSC{<:Any,Ti}}}
    # every thread processes an entire row
    leading_dim = @index(Global, Linear)
    leading_dim_size = output isa GPUSparseDeviceMatrixCSR ? size(output, 1) : size(output, 2)
    if leading_dim ≤ leading_dim_size
        iter = @inbounds iter_type(T, Ti)(leading_dim, args...)

        output_ptrs  = output isa GPUSparseDeviceMatrixCSR ? output.rowPtr : output.colPtr
        output_ivals = output isa GPUSparseDeviceMatrixCSR ? output.colVal : output.rowVal
        # fetch the row offset, and write it to the output
        @inbounds begin
            output_ptr = output_ptrs[leading_dim] = offsets[leading_dim]
            if leading_dim == leading_dim_size
                output_ptrs[leading_dim+one(eltype(leading_dim))] = offsets[leading_dim+one(eltype(leading_dim))]
            end
        end

        # set the values for this row
        for (sub_leading_dim, ptrs) in iter
            index_first  = output isa GPUSparseDeviceMatrixCSR ? leading_dim : sub_leading_dim
            index_second = output isa GPUSparseDeviceMatrixCSR ? sub_leading_dim : leading_dim
            I = CartesianIndex(index_first, index_second)
            vals = ntuple(Val(length(args))) do i
                arg = @inbounds args[i]
                ptr = @inbounds ptrs[i]
                _getindex(arg, I, ptr)
            end
            @inbounds output_ivals[output_ptr] = sub_leading_dim
            @inbounds output.nzVal[output_ptr] = f(vals...)
            output_ptr += one(Ti)
        end
    end
end
@kernel function sparse_to_dense_broadcast_kernel(T::Type{<:Union{AbstractGPUSparseMatrixCSR{Tv, Ti},
                                                                  AbstractGPUSparseMatrixCSC{Tv, Ti}}},
                                                  f, output::AbstractArray, args...) where {Tv, Ti}
    # every thread processes an entire row
    leading_dim = @index(Global, Linear)
    leading_dim_size = T <: AbstractGPUSparseMatrixCSR ? size(output, 1) : size(output, 2)
    if leading_dim ≤ leading_dim_size
        iter = @inbounds iter_type(T, Ti)(leading_dim, args...)

        # set the values for this row
        for (sub_leading_dim, ptrs) in iter
            index_first  = T <: AbstractGPUSparseMatrixCSR ? leading_dim : sub_leading_dim
            index_second = T <: AbstractGPUSparseMatrixCSR ? sub_leading_dim : leading_dim
            I = CartesianIndex(index_first, index_second)
            vals = ntuple(Val(length(args))) do i
                arg = @inbounds args[i]
                ptr = @inbounds ptrs[i]
                _getindex(arg, I, ptr)
            end

            @inbounds output[I] = f(vals...)
        end
    end
end

@kernel function sparse_to_dense_broadcast_kernel(::Type{<:AbstractGPUSparseVector}, f::F,
                                                  output::AbstractArray{Tv},
                                                  offsets::AbstractVector{Pair{Ti, NTuple{N, Ti}}},
                                                  args...) where {Tv, F, N, Ti}
    # every thread processes an entire row
    row_ix = @index(Global, Linear)
    if row_ix ≤ length(output)
        row_and_ptrs = @inbounds offsets[row_ix]
        row          = @inbounds row_and_ptrs[1]
        arg_ptrs     = @inbounds row_and_ptrs[2]
        vals = ntuple(Val(length(args))) do i
            @inline
            arg = @inbounds args[i]
            # ptr is 0 if the sparse vector doesn't have an element at this row
            # ptr is row if the arg is dense OR a scalar with non-zero-preserving f
            # ptr is 0 if the arg is a scalar AND f preserves zeros
            ptr = @inbounds arg_ptrs[i]
            _getindex(arg, row, ptr)
        end
        @inbounds output[row] = f(vals...)
    end
end
## COV_EXCL_STOP

function Broadcast.copy(bc::Broadcasted{<:Union{GPUSparseVecStyle,GPUSparseMatStyle}})
    # find the sparse inputs
    bc = Broadcast.flatten(bc)
    sparse_args = findall(bc.args) do arg
        arg isa AbstractGPUSparseArray
    end
    sparse_types = unique(map(i->nameof(typeof(bc.args[i])), sparse_args))
    if length(sparse_types) > 1
        error("broadcast with multiple types of sparse arrays ($(join(sparse_types, ", "))) is not supported")
    end
    sparse_typ = typeof(bc.args[first(sparse_args)])
    sparse_typ <: Union{AbstractGPUSparseMatrixCSR,AbstractGPUSparseMatrixCSC,AbstractGPUSparseVector} ||
        error("broadcast with sparse arrays is currently only implemented for vectors and CSR and CSC matrices")
    Ti = if sparse_typ <: AbstractGPUSparseMatrixCSR
        reduce(promote_type, map(i->eltype(bc.args[i].rowPtr), sparse_args))
    elseif sparse_typ <: AbstractGPUSparseMatrixCSC
        reduce(promote_type, map(i->eltype(bc.args[i].colPtr), sparse_args))
    elseif sparse_typ <: AbstractGPUSparseVector
        reduce(promote_type, map(i->eltype(bc.args[i].iPtr), sparse_args))
    end

    # determine the output type
    Tv = Broadcast.combine_eltypes(bc.f, eltype.(bc.args))
    if !Base.isconcretetype(Tv)
        error("""GPU sparse broadcast resulted in non-concrete element type $Tv.
                 This probably means that the function you are broadcasting contains an error or type instability.""")
    end

    # partially-evaluate the function, removing scalars.
    parevalf, passedsrcargstup = capturescalars(bc.f, bc.args)
    # check if the partially-evaluated function preserves zeros. if so, we'll only need to
    # apply it to the sparse input arguments, preserving the sparse structure.
    if all(arg->isa(arg, AbstractSparseArray), passedsrcargstup)
        fofzeros = parevalf(_zeros_eltypes(passedsrcargstup...)...)
        fpreszeros = _iszero(fofzeros)
    else
        fpreszeros = false
    end

    # the kernels below parallelize across rows or cols, not elements, so it's unlikely
    # we'll launch many threads. to maximize utilization, parallelize across blocks first.
    rows, cols = get(size(bc), 1, 1), get(size(bc), 2, 1) 
    # `size(bc, ::Int)` is missing
    # for AbstractGPUSparseVec, figure out the actual row range we need to address, e.g. if m = 2^20
    # but the only rows present in any sparse vector input are between 2 and 128, no need to
    # launch massive threads.
    # TODO: use the difference here to set the thread count
    overall_first_row = one(Ti)
    overall_last_row = Ti(rows)
    offsets = nothing
    # allocate the output container
    sparse_arg = bc.args[first(sparse_args)]
    if !fpreszeros && sparse_typ <: Union{AbstractGPUSparseMatrixCSR, AbstractGPUSparseMatrixCSC}
        # either we have dense inputs, or the function isn't preserving zeros,
        # so use a dense output to broadcast into.
        val_array = nonzeros(sparse_arg)
        output    = similar(val_array, Tv, size(bc))
        # since we'll be iterating the sparse inputs, we need to pre-fill the dense output
        # with appropriate values (while setting the sparse inputs to zero). we do this by
        # re-using the dense broadcast implementation.
        nonsparse_args = map(bc.args) do arg
            # NOTE: this assumes the broadcast is flattened, but not yet preprocessed
            if arg isa AbstractGPUSparseArray
                zero(eltype(arg))
            else
                arg
            end
        end
        broadcast!(bc.f, output, nonsparse_args...)
    elseif length(sparse_args) == 1 && sparse_typ <: Union{AbstractGPUSparseMatrixCSR, AbstractGPUSparseMatrixCSC}
        # we only have a single sparse input, so we can reuse its structure for the output.
        # this avoids a kernel launch and costly synchronization.
        if sparse_typ <: AbstractGPUSparseMatrixCSR
            offsets = rowPtr = sparse_arg.rowPtr
            colVal  = similar(sparse_arg.colVal)
            nzVal   = similar(sparse_arg.nzVal, Tv)
            output  = sparse_array_type(sparse_typ)(rowPtr, colVal, nzVal, size(bc))
        elseif sparse_typ <: AbstractGPUSparseMatrixCSC
            offsets = colPtr = sparse_arg.colPtr
            rowVal  = similar(sparse_arg.rowVal)
            nzVal   = similar(sparse_arg.nzVal, Tv)
            output  = sparse_array_type(sparse_typ)(colPtr, rowVal, nzVal, size(bc))
        end
    else
        # determine the number of non-zero elements per row so that we can create an
        # appropriately-structured output container
        offsets = if sparse_typ <: AbstractGPUSparseMatrixCSR
            ptr_array = sparse_arg.rowPtr
            similar(ptr_array, Ti, rows+1)
        elseif sparse_typ <: AbstractGPUSparseMatrixCSC
            ptr_array = sparse_arg.colPtr
            similar(ptr_array, Ti, cols+1)
        elseif sparse_typ <: AbstractGPUSparseVector
            ptr_array = sparse_arg.iPtr
            @allowscalar begin
                arg_first_rows = ntuple(Val(length(bc.args))) do i
                    bc.args[i] isa AbstractGPUSparseVector && return bc.args[i].iPtr[1]
                    return one(Ti)
                end
                arg_last_rows = ntuple(Val(length(bc.args))) do i
                    bc.args[i] isa AbstractGPUSparseVector && return bc.args[i].iPtr[end]
                    return Ti(rows)
                end
            end
            overall_first_row = min(arg_first_rows...)
            overall_last_row  = max(arg_last_rows...)
            similar(ptr_array, Pair{Ti, NTuple{length(bc.args), Ti}}, overall_last_row - overall_first_row + 1)
        end
        let
            args = if sparse_typ <: AbstractGPUSparseVector
                (sparse_typ, overall_first_row, overall_last_row, fpreszeros, offsets, bc.args...)
            else
                (sparse_typ, offsets, bc.args...)
            end
            kernel = compute_offsets_kernel(get_backend(bc.args[first(sparse_args)]))
            kernel(args...; ndrange=length(offsets))
        end
        # accumulate these values so that we can use them directly as row pointer offsets,
        # as well as to get the total nnz count to allocate the sparse output array.
        # cusparseXcsrgeam2Nnz computes this in one go, but it doesn't seem worth the effort
        if !(sparse_typ <: AbstractGPUSparseVector)
            @allowscalar accumulate!(Base.add_sum, offsets, offsets)
            total_nnz = @allowscalar last(offsets[end]) - 1
        else
            @allowscalar sort!(offsets; by=first)
            total_nnz = mapreduce(x->first(x) != typemax(first(x)), +, offsets)
        end
        output = if sparse_typ <: Union{AbstractGPUSparseMatrixCSR,AbstractGPUSparseMatrixCSC}
            ixVal = similar(offsets, Ti, total_nnz)
            nzVal = similar(offsets, Tv, total_nnz)
            output_sparse_typ = sparse_array_type(sparse_typ) 
            output_sparse_typ(offsets, ixVal, nzVal, size(bc))
        elseif sparse_typ <: AbstractGPUSparseVector && !fpreszeros
            val_array = bc.args[first(sparse_args)].nzVal
            similar(val_array, Tv, size(bc))
        elseif sparse_typ <: AbstractGPUSparseVector && fpreszeros
            iPtr   = similar(offsets, Ti, total_nnz)
            nzVal  = similar(offsets, Tv, total_nnz)
            sparse_array_type(sparse_arg){Tv, Ti}(iPtr, nzVal, rows)
        end
        if sparse_typ <: AbstractGPUSparseVector && !fpreszeros
            nonsparse_args = map(bc.args) do arg
                # NOTE: this assumes the broadcst is flattened, but not yet preprocessed
                if arg isa AbstractGPUSparseArray
                    zero(eltype(arg))
                else
                    arg
                end
            end
            broadcast!(bc.f, output, nonsparse_args...)
        end
    end
    # perform the actual broadcast
    if output isa AbstractGPUSparseArray
        args   = (bc.f, output, offsets, bc.args...)
        kernel = sparse_to_sparse_broadcast_kernel(get_backend(bc.args[first(sparse_args)]))
        ndrange = if sparse_typ <: AbstractGPUSparseVector
                    output.nnz
                  elseif sparse_typ <: AbstractGPUSparseMatrixCSC
                    size(output, 2)
                  else
                     size(output, 1)
                  end
    else
        args   = sparse_typ <: AbstractGPUSparseVector ? (sparse_typ, bc.f, output, offsets, bc.args...) :
                                                         (sparse_typ, bc.f, output, bc.args...)
        kernel = sparse_to_dense_broadcast_kernel(get_backend(bc.args[first(sparse_args)]))
        ndrange = sparse_typ <: AbstractGPUSparseMatrixCSC ? size(output, 2) : size(output, 1)
    end
    kernel(args...; ndrange)
    return output
end
## COV_EXCL_START
@kernel function csr_reduce_kernel(f::F, op::OP, neutral, zeros_preserved::Bool, output::DenseArray, args...) where {F, OP}
    # every thread processes an entire row
    row = @index(Global, Linear)
    if row ≤ size(output, 1)
        iter = @inbounds CSRIterator{Int}(row, args...)

        val = op(neutral, neutral)

        # reduce the values for this row
        for (col, ptrs) in iter
            I = CartesianIndex(row, col)
            vals = ntuple(Val(length(args))) do i
                arg = @inbounds args[i]
                ptr = @inbounds ptrs[i]
                _getindex(arg, I, ptr)
            end
            val = op(val, f(vals...))
        end
        if !zeros_preserved
            f_zero_val   = f(zero(neutral))
            next_row_ind = row+1
            nzs_this_row = ntuple(Val(length(args))) do i
                max_n_zeros = size(args[i], 2)
                arg_row_ptr = args[i].rowPtr
                nz_this_row = max_n_zeros - (@inbounds(arg_row_ptr[next_row_ind]) - @inbounds(arg_row_ptr[row]))
                nz_this_row * f_zero_val
            end
            val = op(val, nzs_this_row...)
        end

        @inbounds output[row] = val
    end
end

@kernel function csc_reduce_kernel(f::F, op::OP, neutral, zeros_preserved::Bool, output::DenseArray, args...) where {F, OP}
    # every thread processes an entire column
    col = @index(Global, Linear) 
    if col ≤ size(output, 2)
        iter = @inbounds CSCIterator{Int}(col, args...)

        val = op(neutral, neutral)

        # reduce the values for this col
        for (row, ptrs) in iter
            I = CartesianIndex(row, col)
            vals = ntuple(Val(length(args))) do i
                arg = @inbounds args[i]
                ptr = @inbounds ptrs[i]
                _getindex(arg, I, ptr)
            end
            val = op(val, f(vals...))
        end
        if !zeros_preserved
            f_zero_val   = f(zero(neutral))
            next_col_ind = col+1
            nzs_this_col = ntuple(Val(length(args))) do i
                max_n_zeros = size(args[i], 1)
                arg_col_ptr = args[i].colPtr
                nz_this_col = max_n_zeros - (@inbounds(arg_col_ptr[next_col_ind]) - @inbounds(arg_col_ptr[col]))
                nz_this_col * f_zero_val
            end
            val = op(val, nzs_this_col...)
        end
        @inbounds output[col] = val
    end
end
## COV_EXCL_STOP

function csc_type end
function csr_type end

# TODO: implement mapreducedim!
function Base.mapreduce(f, op, A::AbstractGPUSparseMatrix; dims=:, init=nothing)
    # figure out the destination container type by looking at the initializer element,
    # or by relying on inference to reason through the map and reduce functions
    if init === nothing
        ET = Broadcast.combine_eltypes(f, (A,))
        ET = Base.promote_op(op, ET, ET)
        (ET === Union{} || ET === Any) &&
            error("mapreduce cannot figure the output element type, please pass an explicit init value")

        init = zero(ET)
    else
        ET = typeof(init)
    end

    f_preserves_zeros = ( f(zero(ET)) == zero(ET) )
    # we only handle reducing along one of the two dimensions,
    # or a complete reduction (requiring an additional pass)
    in(dims, [Colon(), 1, 2]) || error("only dims=:, dims=1 or dims=2 is supported")

    if A isa AbstractGPUSparseMatrixCSR && dims == 1
        A = csc_type(A)(A)
    elseif A isa AbstractGPUSparseMatrixCSC && dims == 2
        A = csr_type(A)(A)
    end
    m, n      = size(A)
    val_array = nonzeros(A)
    backend   = get_backend(A)
    output_dim = 0
    ndrange    = 0
    if A isa AbstractGPUSparseMatrixCSR
        output_dim = m
        ndrange = m
        kernel = csr_reduce_kernel(backend)
    elseif A isa AbstractGPUSparseMatrixCSC 
        output_dim = (1, n)
        ndrange = n
        kernel = csc_reduce_kernel(backend)
    end
    output = similar(val_array, ET, output_dim)
    kernel(f, op, init, f_preserves_zeros, output, A; ndrange = ndrange)
    if dims == Colon()
        return mapreduce(identity, op, output; init)
    else
        return output
    end
end

@testsuite "broadcasting" (AT, eltypes)->begin
    broadcasting(AT, eltypes)
    vec3(AT, eltypes)
    unknown_wrapper(AT, eltypes)
end

test_idx(idx, A::AbstractArray{T}) where T = A[idx] * T(2)

function testv3_1(a, b)
    x = a .* b
    y =  x .+ b
    @inbounds return y[1]
end

function testv3_2(a, b)
    x = a .* b
    y =  x .+ b
    return y
end

# more complex function for broadcast
function test_kernel(a::T, b) where T
    c = a
    for i=1:5
        c += T(b)
        c = a * T(2)
    end
    return c
end

function broadcasting(AT, eltypes)
    for ET in eltypes
        N = 10
        @testset "broadcast $ET" begin
            @testset "RefValue" begin
                cidx = rand(1:Int(N), 2*N)
                gidx = AT(cidx)
                cy = rand(ET, 2*N)
                gy = AT(cy)
                cres = fill(zero(ET), size(cidx))
                gres = AT(cres)
                gres .= test_idx.(gidx, Base.RefValue(gy))
                cres .= test_idx.(cidx, Base.RefValue(cy))
                @test Array(gres) == cres
            end

            @testset "Tuple" begin
                @test compare(AT, rand(ET, 3, N), rand(ET, 3, N), rand(ET, N), rand(ET, N), rand(ET, N)) do out, arr, a, b, c
                    broadcast!(out, arr, (a, b, c)) do xx, yy
                        xx + first(yy)
                    end
                end
            end

            @testset "Number" begin
                A = AT(rand(ET, N))
                x = rand(ET)
                A .= x
                @test all(isequal(x), Array(A))
            end

            @testset "Adjoint and Transpose" begin
                A = AT(rand(ET, N))
                A' .= ET(2)
                @test all(isequal(ET(2)'), Array(A))
                transpose(A) .= ET(1)
                @test all(isequal(ET(1)), Array(A))
            end

            ############
            # issue #27
            @test compare((a, b)-> a .+ b, AT, rand(ET, 4, 5, 3), rand(ET, 1, 5, 3))
            @test compare((a, b)-> a .+ b, AT, rand(ET, 4, 5, 3), rand(ET, 1, 5, 1))

            ############
            # issue #22
            dim = (32, 32)
            @test compare(AT, rand(ET, dim), rand(ET, dim), rand(ET, dim)) do tmp, a1, a2
                tmp .=  a1 .+ a2 .* ET(2)
            end

            ############
            # issue #21
            if ET in (Float32, Float64)
                @test compare((a1, a2)-> muladd.(ET(2), a1, a2), AT, rand(ET, dim), rand(ET, dim))
                #########
                # issue #41
                # The first issue is likely https://github.com/JuliaLang/julia/issues/22255
                # since GPUArrays adds some arguments to the function, it becomes longer longer, hitting the 12
                # so this wont fix for now
                @test compare(AT, rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim)) do a1, a2, a3, a4, a5, a6
                    c1, c2, c3, c4, c5 = ET(1.2), ET(1.3), ET(1.4), ET(1.5), ET(1.6)
                    @. a1 = a2 + c1 * (c2 * a3 + c3 * a4 + c4 * a5 + c5 * a6)
                end

                @test compare(AT, rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim)) do u, uprev, duprev, ku
                    fract = ET(1//2)
                    dt = ET(1.4)
                    dt2 = dt^2
                    @. u = uprev + dt*duprev + dt2*(fract*ku)
                end
                @test compare((x) -> (-).(x), AT, rand(ET, 2, 3))

                @test compare(AT, rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim), rand(ET, dim)) do utilde, gA, k1, k2, k3, k4
                    btilde1 = ET(1)
                    btilde2 = ET(1)
                    btilde3 = ET(1)
                    btilde4 = ET(1)
                    dt = ET(1)
                    @. utilde = dt*(btilde1*k1 + btilde2*k2 + btilde3*k3 + btilde4*k4)
                end

                @testset "0D" begin
                    x = AT{ET}(undef)
                    x .= ET(1)
                    @test collect(x)[] == ET(1)
                    x /= ET(2)
                    @test collect(x)[] == ET(0.5)
                end
            end

            @test compare((x) -> fill!(x, 1), AT, rand(ET, 3,3))
            @test compare((x, y) -> map(+, x, y), AT, rand(ET, 2, 3), rand(ET, 2, 3))

            @test compare((x) -> 2x, AT, rand(ET, 2, 3))
            @test compare((x, y) -> x .+ y, AT, rand(ET, 2, 3), rand(ET, 1, 3))
            @test compare((z, x, y) -> z .= x .+ y, AT, rand(ET, 2, 3), rand(ET, 2, 3), rand(ET, 2))

            @test compare(A -> A .= identity.(ET(10)), AT, rand(ET, 40, 40))
            @test compare(A -> test_kernel.(A, ET(10)), AT, rand(ET, 40, 40))
            @test compare(A -> A .* ET(10), AT, rand(ET, 40, 40))
            @test compare((A, B) -> A .* B, AT, rand(ET, 40, 40), rand(ET, 40, 40))
            @test compare((A, B) -> A .* B .+ ET(10), AT, rand(ET, 40, 40), rand(ET, 40, 40))
        end

        @testset "map! $ET" begin
            @test compare(AT, rand(ET, 2,2), rand(ET, 2,2)) do x,y
                map!(+, x, y)
            end
            @test compare(AT, rand(ET, 2), rand(ET, 2,2)) do x,y
                map!(+, x, y)
            end
            @test compare(AT, rand(ET, 2,2), rand(ET, 2)) do x,y
                map!(+, x, y)
            end
            @test compare(AT, rand(ET, 2), 1:2) do x, y
                map!(+, x, y)
            end
        end

        @testset "map $ET" begin
            @test compare(AT, rand(ET, 2,2), rand(ET, 2,2)) do x,y
                map(+, x, y)
            end
            @test compare(AT, rand(ET, 2), rand(ET, 2,2)) do x,y
                map(+, x, y)
            end
            @test compare(AT, rand(ET, 2,2), rand(ET, 2)) do x,y
                map(+, x, y)
            end
            ############
            # issue #598
            @test compare(AT, rand(ET, ()), rand(ET, ())) do x, y
                map(+, x, y)
            end
        end
    end

    @testset "stackoverflow in copy(::Broadcast)" begin
        copy(Base.broadcasted(identity, AT(Int[])))
    end
end

function vec3(AT, eltypes)
    @testset "vec 3" begin
        N = 20

        xc = map(x-> ntuple(i-> rand(Float32), Val(3)), 1:N)
        yc = map(x-> ntuple(i-> rand(Float32), Val(3)), 1:N)

        x = AT(xc)
        y = AT(yc)

        res1c = fill(0f0, N)
        res2c = similar(xc)

        res1 = AT(res1c)
        res2 = AT(res2c)

        res1 .= testv3_1.(x, y)
        res1c .= testv3_1.(xc, yc)
        @test Array(res1) ≈ res1c

        res2 .= testv3_2.(x, y)
        res2c .= testv3_2.(xc, yc)
        @test all(map((a,b)-> all((1,2,3) .≈ (1,2,3)), Array(res2), res2c))
    end
end

# A help struct to test style-based broadcast dispatch with unknown array wrapper.
# `WrapArray(A)` behaves like `A` during broadcast. But its not a `BroadcastGPUArray`.
struct WrapArray{T,N,P<:AbstractArray{T,N}} <: AbstractArray{T,N}
    data::P
end
Base.@propagate_inbounds Base.getindex(A::WrapArray, i::Integer...) = A.data[i...]
Base.@propagate_inbounds Base.setindex!(A::WrapArray, v::Any, i::Integer...) = setindex!(A.data, v, i...)
Base.size(A::WrapArray) = size(A.data)
# For kernal support
Adapt.adapt_structure(to, s::WrapArray) = WrapArray(Adapt.adapt(to, s.data))
# For broadcast support
Broadcast.BroadcastStyle(::Type{WrapArray{T,N,P}}) where {T,N,P} = Broadcast.BroadcastStyle(P)
KernelAbstractions.get_backend(a::WA) where WA <: WrapArray = get_backend(a.data)


function unknown_wrapper(AT, eltypes)
    for ET in eltypes
        @views @testset "unknown wrapper $ET" begin
            A = AT(rand(ET, 10, 10))
            WA = WrapArray(A)
            # test for dispatch with src's BroadcastStyle.
            @test Array(WA .+ ET(1)) == Array(A .+ ET(1))
            @test Array(WA .+ WA) == Array(WA .+ A) == Array(A .+ A)
            @test Array(WA .+ A[:,1]) == Array(A .+ A[:,1])
            @test Array(WA .+ A[1,:]) == Array(A .+ A[1,:])
            # test for dispatch with dest's BroadcastStyle.
            WA .= ET(1)
            @test all(isequal(ET(1)), Array(A))
        end
    end
end

import Base: +, -

const genericwrappers = (
    :LowerTriangular,
    :UpperTriangular,
    :Hermitian,
    :Symmetric
)

const unittriangularwrappers = (
    (:UnitUpperTriangular, :UpperTriangular), 
    (:UnitLowerTriangular, :LowerTriangular)
)

@kernel function kernel_generic(B, J)
    lin_idx = @index(Global, Linear)
    @inbounds diag_idx = diagind(B)[lin_idx]
    @inbounds B[diag_idx] += J
end

@kernel function kernel_unittriangular(B, J, diagonal_val)
    lin_idx = @index(Global, Linear)
    @inbounds diag_idx = diagind(B)[lin_idx]
    @inbounds B[diag_idx] = diagonal_val + J
end

for (t1, t2) in unittriangularwrappers
    @eval begin
        function (+)(A::$t1{T, <:AbstractGPUMatrix}, J::UniformScaling) where T
            B = similar(parent(A), typeof(oneunit(T) + J))
            copyto!(B, parent(A))
            min_size = minimum(size(B))
            kernel_unittriangular(get_backend(B))(B, J, one(eltype(B)); ndrange=min_size)
            return $t2(B)
        end

        function (-)(J::UniformScaling, A::$t1{T, <:AbstractGPUMatrix}) where T
            B = similar(parent(A), typeof(J - oneunit(T)))
            B .= .- parent(A)
            min_size = minimum(size(B))
            kernel_unittriangular(get_backend(B))(B, J, -one(eltype(B)); ndrange=min_size)
            return $t2(B)
        end
    end
end

for t in genericwrappers
    @eval begin
        function (+)(A::$t{T, <:AbstractGPUMatrix}, J::UniformScaling) where T
            B = similar(parent(A), typeof(oneunit(T) + J))
            copyto!(B, parent(A))
            min_size = minimum(size(B))
            kernel_generic(get_backend(B))(B, J; ndrange=min_size)
            return $t(B)
        end

        function (-)(J::UniformScaling, A::$t{T, <:AbstractGPUMatrix}) where T
            B = similar(parent(A), typeof(J - oneunit(T)))
            B .= .- parent(A)
            min_size = minimum(size(B))
            kernel_generic(get_backend(B))(B, J; ndrange=min_size)
            return $t(B)
        end
    end
end

# Breaking Hermiticity when adding a complex value to the diagonal
function (+)(A::Hermitian{T,<:AbstractGPUMatrix}, J::UniformScaling{<:Complex}) where T
    B = similar(parent(A), typeof(oneunit(T) + J))
    copyto!(B, parent(A))
    min_size = minimum(size(B))
    kernel_generic(get_backend(B))(B, J; ndrange=min_size)
    return B
end

function (-)(J::UniformScaling{<:Complex}, A::Hermitian{T,<:AbstractGPUMatrix}) where T
    B = similar(parent(A), typeof(J - oneunit(T)))
    B .= .-parent(A)
    min_size = minimum(size(B))
    kernel_generic(get_backend(B))(B, J; ndrange=min_size)
    return B
end

# Finally the generic matrix version
function (+)(A::AbstractGPUMatrix{T}, J::UniformScaling) where T
    B = similar(A, typeof(oneunit(T) + J))
    copyto!(B, A)
    min_size = minimum(size(B))
    kernel_generic(get_backend(B))(B, J; ndrange=min_size)
    return B
end

function (-)(J::UniformScaling, A::AbstractGPUMatrix{T}) where T
    B = similar(A, typeof(J - oneunit(T)))
    B .= .-A
    min_size = minimum(size(B))
    kernel_generic(get_backend(B))(B, J; ndrange=min_size)
    return B
end

# broadcasting operations

using Base.Broadcast

using Base.Broadcast: BroadcastStyle, Broadcasted, AbstractArrayStyle, instantiate

# but make sure we don't dispatch to the optimized copy method that directly indexes
function Broadcast.copy(bc::Broadcasted{<:AbstractGPUArrayStyle{0}})
    ElType = Broadcast.combine_eltypes(bc.f, bc.args)
    if ElType == Union{}
        # using a Union{} eltype would fail early, during GPU array construction,
        # so use Nothing instead to give the error a chance to be thrown dynamically.
        ElType = Nothing
    end
    dest = copyto!(similar(bc, ElType), bc)
    return @allowscalar dest[CartesianIndex()]  # 0D broadcast needs to unwrap results
end

# we need to override the outer copy method to make sure we never fall back to scalar
# iteration (see, e.g., CUDA.jl#145)
@inline function Broadcast.copy(bc::Broadcasted{<:AbstractGPUArrayStyle})
    ElType = Broadcast.combine_eltypes(bc.f, bc.args)
    if ElType == Union{} || !Base.allocatedinline(ElType)
        # a Union{} or non-isbits eltype would fail early, during GPU array construction,
        # so use a special marker to give the error a chance to be thrown during compilation
        # or even dynamically, and pick that marker up afterwards to throw an error.
        ElType = BrokenBroadcast{ElType}
    end
    copyto!(similar(bc, ElType), bc)
end

struct BrokenBroadcast{T} end
Base.convert(::Type{BrokenBroadcast{T}}, x) where T = BrokenBroadcast{T}()
Base.convert(::Type{BrokenBroadcast{T}}, x::BrokenBroadcast{T}) where T = x
Base.eltype(::Type{BrokenBroadcast{T}}) where T = T

@inline function Base.materialize!(::Style, dest, bc::Broadcasted) where {Style<:AbstractGPUArrayStyle}
    return _copyto!(dest, instantiate(Broadcasted{Style}(bc.f, bc.args, axes(dest))))
end

@inline Base.copyto!(dest::AnyGPUArray, bc::Broadcasted{Nothing}) =
    _copyto!(dest, bc) # Keep it for ArrayConflict

@inline Base.copyto!(dest::AbstractArray, bc::Broadcasted{<:AbstractGPUArrayStyle}) =
    _copyto!(dest, bc)

@inline function _copyto!(dest::AbstractArray, bc::Broadcasted)
    axes(dest) == axes(bc) || Broadcast.throwdm(axes(dest), axes(bc))
    isempty(dest) && return dest
    bc = Broadcast.preprocess(dest, bc)

    @kernel function broadcast_kernel_linear(dest, bc)
        I = @index(Global, Linear)
        @inbounds dest[I] = bc[I]
    end

    @kernel function broadcast_kernel_cartesian(dest, bc)
        I = @index(Global, Cartesian)
        @inbounds dest[I] = bc[I]
    end

    broadcast_kernel = if ndims(dest) == 1 ||
                          (isa(IndexStyle(dest), IndexLinear) &&
                           isa(IndexStyle(bc), IndexLinear))
        broadcast_kernel_linear(get_backend(dest))
    else
        broadcast_kernel_cartesian(get_backend(dest))
    end

    # ndims check for 0D support
    broadcast_kernel(dest, bc; ndrange = ndims(dest) > 0 ? size(dest) : (1,))
    if eltype(dest) <: BrokenBroadcast
        throw(ArgumentError("Broadcast operation resulting in $(eltype(eltype(dest))) is not GPU compatible"))
    end

    return dest
end


## map

allequal(x) = true
allequal(x, y, z...) = x == y && allequal(y, z...)

function Base.map(f, x1::AnyGPUArray, xrest::AnyGPUArray...)
    xs = (x1, xrest...)
    # if argument sizes match, their shape needs to be preserved
    if allequal(size.(xs)...)
        return Broadcast.broadcast_preserving_zero_d(f, xs...)
    end

    # if not, treat them as iterators
    indices = LinearIndices.(xs)
    common_length = minimum(length.(indices))

    # construct a broadcast to figure out the destination container
    ElType = Broadcast.combine_eltypes(f, xs)
    if ElType == Union{} || !Base.allocatedinline(ElType)
        # see `broadcast`
        ElType = BrokenBroadcast{ElType}
    end
    dest = similar(first(xs), ElType, common_length)

    return map!(f, dest, xs...)
end

function Base.map!(f, dest::AnyGPUArray, xs::AbstractArray...)
    # custom broadcast, ignoring the container size mismatches
    # (avoids the reshape + view that our mapreduce impl has to do)
    indices = LinearIndices.((dest, xs...))
    common_length = minimum(length.(indices))
    common_length==0 && return

    bc = Broadcast.instantiate(Broadcast.broadcasted(f, xs...))
    if bc isa Broadcast.Broadcasted
        bc = Broadcast.preprocess(dest, bc)
    end

    @kernel function map_kernel(dest, bc)
        i = @index(Global, Linear)
        I = CartesianIndices(axes(bc))[i]
        @inbounds dest[i] = bc[I]
    end

    kernel = map_kernel(get_backend(dest))
    config = KernelAbstractions.launch_config(kernel, common_length, nothing)
    kernel(dest, bc; ndrange = config[1], workgroupsize = config[2])

    if eltype(dest) <: BrokenBroadcast
        throw(ArgumentError("Map operation resulting in $(eltype(eltype(dest))) is not GPU compatible"))
    end

    return dest
end

# common Base functionality
import Base: _RepeatInnerOuter

@kernel function issorted_kernel!(
        data,
        violations,
        ord,
    )
    i = @index(Global)
    if i <= length(violations)
        @inbounds begin
            a = data[i]
            b = data[i + 1]
            violations[i] = Base.Order.lt(ord, b, a)
        end
    end
end

function Base.issorted(A::AbstractGPUArray; lt::Function = isless, by::Function = identity, rev::Bool = false, order = Base.Order.Forward)
    if order === Base.Order.Reverse
        rev = !rev
        order = Base.Order.Forward
    elseif order !== Base.Order.Forward
        throw(ArgumentError("custom orderings are not supported on GPU"))
    end

    n = length(A)
    n ≤ 1 && return true

    ord = Base.Order.ord(lt, by, rev, order)

    violations = similar(A, Bool, n - 1)
    backend = get_backend(A)

    issorted_kernel!(backend)(
        A,
        violations,
        ord,
        ndrange = n - 1,
    )

    return !any(Array(violations))
end

# Handle `out = repeat(x; inner)` by parallelizing over `out` array This can benchmark
# faster if repeating elements along the first axis (i.e. `inner=(n, ones...)`), as data
# access can be contiguous on write.
@kernel function repeat_inner_dst_kernel!(
    xs::AbstractArray{<:Any, N},
    inner::NTuple{N, Int},
    out::AbstractArray{<:Any, N}
) where {N}
    # Get the "stride" index in each dimension, where the size
    # of the stride is given by `inner`. The stride-index (sdx) then
    # corresponds to the index of the repeated value in `xs`.
    odx = @index(Global, Cartesian)
    dest_inds = odx.I
    sdx = ntuple(N) do i
        @inbounds (dest_inds[i] - 1) ÷ inner[i] + 1
    end
    @inbounds out[odx] = xs[CartesianIndex(sdx)]
end

# Handle `out = repeat(x; inner)` by parallelizing over the `xs` array This tends to
# benchmark faster by having fewer read operations and avoiding the costly division
# operation. Additionally, when repeating over the trailing dimension. `inner=(ones..., n)`,
# data access can be contiguous during both the read and write operations.
@kernel function repeat_inner_src_kernel!(
    xs::AbstractArray{<:Any, N},
    inner::NTuple{N, Int},
    out::AbstractArray{<:Any, N}
) where {N}
    # Get single element from src
    idx = @index(Global, Cartesian)
    @inbounds val = xs[idx]

    # Loop over "repeat" indices of inner
    for rdx in CartesianIndices(inner)
        # Get destination CartesianIndex
        odx = ntuple(N) do i
            @inbounds (idx[i]-1) * inner[i] + rdx[i]
        end
        @inbounds out[CartesianIndex(odx)] = val
    end
end

function repeat_inner(xs::AnyGPUArray, inner)
    out = similar(xs, eltype(xs), inner .* size(xs))
    any(==(0), size(out)) && return out # consistent with `Base.repeat`

    # Pick which kernel to launch based on `inner`, using the heuristic that if the largest
    # entry in `inner` is `inner[1]`, then we should parallelize over `out`. Otherwise, we
    # should parallelize over `xs`. This choice is purely for performance. Better heuristics
    # may exist, but hopefully, this is good enough.
    #
    # Using `repeat_inner_src_kernel!`, requires fewer read ops (`prod(size(xs))` vs.
    # `prod(size(out))`) and generally benchmarks faster than `repeat_inner_dst_kernel!`.
    # However, for `inner = (n, 1, 1)`, `repeat_inner_dst_kernel!` benchmarked faster as it
    # avoids strided memory access over `out`.
    # See https://github.com/JuliaGPU/GPUArrays.jl/pull/400#issuecomment-1172641982 for the
    # relevant benchmarks.
    if argmax(inner) == firstindex(inner)
        # Parallelize over the destination array
        kernel = repeat_inner_dst_kernel!(get_backend(out))
        kernel(xs, inner, out; ndrange=size(out))
    else
        # Parallelize over the source array
        kernel = repeat_inner_src_kernel!(get_backend(xs))
        kernel(xs, inner, out; ndrange=size(xs))
    end
    return out
end

@kernel function repeat_outer_kernel!(
    xs::AbstractArray{<:Any, N},
    xssize::NTuple{N},
    outer::NTuple{N},
    out::AbstractArray{<:Any, N}
) where {N}
    # Get index to input element
    idx = @index(Global, Cartesian)
    @inbounds val = xs[idx]

    # Loop over repeat indices, copying val to out
    for rdx in CartesianIndices(outer)
        # Get destination CartesianIndex
        odx = ntuple(N) do i
            @inbounds idx[i] + xssize[i] * (rdx[i] -1)
        end
        @inbounds out[CartesianIndex(odx)] = val
    end
end

function repeat_outer(xs::AnyGPUArray, outer)
    out = similar(xs, eltype(xs), outer .* size(xs))
    any(==(0), size(out)) && return out # consistent with `Base.repeat`
    kernel = repeat_outer_kernel!(get_backend(xs))
    kernel(xs, size(xs), outer, out; ndrange=size(xs))
    return out
end

# Overload methods used by `Base.repeat`.
# No need to implement `repeat_inner_outer` since this is implemented in `Base` as
# `repeat_outer(repeat_inner(arr, inner), outer)`.
function _RepeatInnerOuter.repeat_inner(xs::AnyGPUArray{<:Any, N}, dims::NTuple{N}) where {N}
    return repeat_inner(xs, dims)
end

function _RepeatInnerOuter.repeat_outer(xs::AnyGPUArray{<:Any, N}, dims::NTuple{N}) where {N}
    return repeat_outer(xs, dims)
end

function _RepeatInnerOuter.repeat_outer(xs::AnyGPUArray{<:Any, 1}, dims::Tuple{Any})
    return repeat_outer(xs, dims)
end

function _RepeatInnerOuter.repeat_outer(xs::AnyGPUArray{<:Any, 2}, dims::NTuple{2, Any})
    return repeat_outer(xs, dims)
end


## PermutedDimsArrays

using Base: PermutedDimsArrays

# PermutedDimsArrays' custom copyto! doesn't know how to deal with GPU arrays
function PermutedDimsArrays._copy!(dest::PermutedDimsArray{T,N,<:Any,<:Any,<:AbstractGPUArray}, src) where {T,N}
    dest .= src
    dest
end


## concatenation

# hacky overloads to make simple vcat and hcat with numbers work as expected.
# we can't really make this work in general without Base providing
# a dispatch mechanism for output container type.
@inline Base.vcat(a::Number, b::AbstractGPUArray) =
    vcat(fill!(similar(b, typeof(a), (1,size(b)[2:end]...)), a), b)
@inline Base.hcat(a::Number, b::AbstractGPUArray) =
    hcat(fill!(similar(b, typeof(a), (size(b)[1:end-1]...,1)), a), b)


## reshape

function Base.reshape(a::AbstractGPUArray{T,M}, dims::NTuple{N,Int}) where {T,N,M}
  if prod(dims) != length(a)
      throw(DimensionMismatch("new dimensions $(dims) must be consistent with array size $(size(a))"))
  end

  if N == M && dims == size(a)
      return a
  end

  derive(T, a, dims, 0)
end


## reinterpret

function Base.reinterpret(::Type{T}, a::AbstractGPUArray{S,N}) where {T,S,N}
  err = _reinterpret_exception(T, a)
  err === nothing || throw(err)

  if sizeof(T) == sizeof(S) # for N == 0
    osize = size(a)
  else
    isize = size(a)
    size1 = div(isize[1]*sizeof(S), sizeof(T))
    osize = tuple(size1, Base.tail(isize)...)
  end

  return derive(T, a, osize, 0)
end

function _reinterpret_exception(::Type{T}, a::AbstractArray{S,N}) where {T,S,N}
  if !isbitstype(T) || !isbitstype(S)
    return ReinterpretBitsTypeError{T,typeof(a)}()
  end
  if N == 0 && sizeof(T) != sizeof(S)
    return ReinterpretZeroDimError{T,typeof(a)}()
  end
  if N != 0 && sizeof(S) != sizeof(T)
      ax1 = axes(a)[1]
      dim = length(ax1)
      if Base.rem(dim*sizeof(S),sizeof(T)) != 0
        return ReinterpretDivisibilityError{T,typeof(a)}(dim)
      end
      if first(ax1) != 1
        return ReinterpretFirstIndexError{T,typeof(a),typeof(ax1)}(ax1)
      end
  end
  return nothing
end

struct ReinterpretBitsTypeError{T,A} <: Exception end
function Base.showerror(io::IO, ::ReinterpretBitsTypeError{T, <:AbstractArray{S}}) where {T, S}
  print(io, "cannot reinterpret an `$(S)` array to `$(T)`, because not all types are bitstypes")
end

struct ReinterpretZeroDimError{T,A} <: Exception end
function Base.showerror(io::IO, ::ReinterpretZeroDimError{T, <:AbstractArray{S,N}}) where {T, S, N}
  print(io, "cannot reinterpret a zero-dimensional `$(S)` array to `$(T)` which is of a different size")
end

struct ReinterpretDivisibilityError{T,A} <: Exception
  dim::Int
end
function Base.showerror(io::IO, err::ReinterpretDivisibilityError{T, <:AbstractArray{S,N}}) where {T, S, N}
  dim = err.dim
  print(io, """
      cannot reinterpret an `$(S)` array to `$(T)` whose first dimension has size `$(dim)`.
      The resulting array would have non-integral first dimension.
      """)
end

struct ReinterpretFirstIndexError{T,A,Ax1} <: Exception
  ax1::Ax1
end
function Base.showerror(io::IO, err::ReinterpretFirstIndexError{T, <:AbstractArray{S,N}}) where {T, S, N}
  ax1 = err.ax1
  print(io, "cannot reinterpret a `$(S)` array to `$(T)` when the first axis is $ax1. Try reshaping first.")
end


## reinterpret(reshape)

function Base.reinterpret(::typeof(reshape), ::Type{T}, a::AbstractGPUArray) where {T}
  osize = _base_check_reshape_reinterpret(T, a)
  return derive(T, a, osize, 0)
end

# taken from reinterpretarray.jl
# TODO: move these Base definitions out of the ReinterpretArray struct for reuse
function _base_check_reshape_reinterpret(::Type{T}, a::AbstractGPUArray{S}) where {T,S}
  isbitstype(T) || throwbits(S, T, T)
  isbitstype(S) || throwbits(S, T, S)
  if sizeof(S) == sizeof(T)
      N = ndims(a)
      size(a)
  elseif sizeof(S) > sizeof(T)
      d, r = divrem(sizeof(S), sizeof(T))
      r == 0 || throwintmult(S, T)
      N = ndims(a) + 1
      (d, size(a)...)
  else
      d, r = divrem(sizeof(T), sizeof(S))
      r == 0 || throwintmult(S, T)
      N = ndims(a) - 1
      N > -1 || throwsize0(S, T, "larger")
      axes(a, 1) == Base.OneTo(sizeof(T) ÷ sizeof(S)) || throwsize1(a, T)
      size(a)[2:end]
  end
end

@noinline function throwbits(S::Type, T::Type, U::Type)
  throw(ArgumentError("cannot reinterpret `$(S)` as `$(T)`, type `$(U)` is not a bits type"))
end

@noinline function throwintmult(S::Type, T::Type)
  throw(ArgumentError("`reinterpret(reshape, T, a)` requires that one of `sizeof(T)` (got $(sizeof(T))) and `sizeof(eltype(a))` (got $(sizeof(S))) be an integer multiple of the other"))
end

@noinline function throwsize0(S::Type, T::Type, msg)
  throw(ArgumentError("cannot reinterpret a zero-dimensional `$(S)` array to `$(T)` which is of a $msg size"))
end

@noinline function throwsize1(a::AbstractArray, T::Type)
    throw(ArgumentError("`reinterpret(reshape, $T, a)` where `eltype(a)` is $(eltype(a)) requires that `axes(a, 1)` (got $(axes(a, 1))) be equal to 1:$(sizeof(T) ÷ sizeof(eltype(a))) (from the ratio of element sizes)"))
end


## views

struct Contiguous end
struct NonContiguous end

# NOTE: this covers more cases than the I<:... in Base.FastContiguousSubArray
GPUIndexStyle() = Contiguous()
GPUIndexStyle(I...) = NonContiguous()
GPUIndexStyle(::Union{Base.ScalarIndex, CartesianIndex}...) = Contiguous()
GPUIndexStyle(::Colon, ::Union{Base.ScalarIndex, CartesianIndex}...) = Contiguous()
GPUIndexStyle(::Base.Slice, ::Union{Base.ScalarIndex, CartesianIndex}...) = Contiguous()
GPUIndexStyle(::AbstractUnitRange, ::Union{Base.ScalarIndex, CartesianIndex}...) = Contiguous()
GPUIndexStyle(::Colon, I...) = GPUIndexStyle(I...)
GPUIndexStyle(::Base.Slice, I...) = GPUIndexStyle(I...)

viewlength() = ()
@inline viewlength(::Real, I...) = viewlength(I...) # skip scalar

@inline viewlength(i1::AbstractUnitRange, I...) = (Base.length(i1), viewlength(I...)...)
@inline viewlength(i1::AbstractUnitRange, ::Base.ScalarIndex...) = (Base.length(i1),)

# adaptor to upload an array to the GPU
struct ToGPU
    array::AbstractGPUArray
end
ToGPU(A::WrappedArray) = ToGPU(parent(A))
function Adapt.adapt_storage(to::ToGPU, xs::Array)
    arr = similar(to.array, eltype(xs), size(xs))
    copyto!(arr, xs)
    arr
end

@inline function Base.view(A::AbstractGPUArray, I::Vararg{Any,N}) where {N}
    J = to_indices(A, I)
    J_gpu = map(j->adapt(ToGPU(A), j), J)
    @boundscheck checkbounds(A, J...)
    unsafe_view(A, J_gpu, GPUIndexStyle(I...))
end

@inline function unsafe_view(A, I, ::Contiguous)
    unsafe_contiguous_view(Base._maybe_reshape_parent(A, Base.index_ndims(I...)), I, viewlength(I...))
end
@inline function unsafe_contiguous_view(a::AbstractGPUArray{T}, I::NTuple{N,Base.ViewIndex}, dims::NTuple{M,Integer}) where {T,N,M}
    offset = Base.compute_offset1(a, 1, I)

    derive(T, a, dims, offset)
end

@inline function unsafe_view(A, I, ::NonContiguous)
    Base.unsafe_view(Base._maybe_reshape_parent(A, Base.index_ndims(I...)), I...)
end

# host-level indexing

using Base: @propagate_inbounds


# indexing operators

Base.IndexStyle(::Type{<:AbstractGPUArray}) = Base.IndexLinear()

vectorized_indices(Is::Union{Integer,CartesianIndex}...) = Val{false}()
vectorized_indices(Is...) = Val{true}()

# TODO: re-use Base functionality for the conversion of indices to a linear index,
#       by only implementing `getindex(A, ::Int)` etc. this is difficult due to
#       ambiguities with the vectorized method that can take any index type.

@propagate_inbounds Base.getindex(A::AbstractGPUArray, Is...) =
    _getindex(vectorized_indices(Is...), A, to_indices(A, Is)...)
@propagate_inbounds _getindex(::Val{false}, A::AbstractGPUArray, Is...) =
    scalar_getindex(A, to_indices(A, Is)...)
@propagate_inbounds _getindex(::Val{true}, A::AbstractGPUArray, Is...) =
    vectorized_getindex(A, to_indices(A, Is)...)

@propagate_inbounds Base.setindex!(A::AbstractGPUArray, v, Is...) =
    _setindex!(vectorized_indices(Is...), A, v, to_indices(A, Is)...)
@propagate_inbounds _setindex!(::Val{false}, A::AbstractGPUArray, v, Is...) =
    scalar_setindex!(A, v, to_indices(A, Is)...)
@propagate_inbounds _setindex!(::Val{true}, A::AbstractGPUArray, v, Is...) =
    vectorized_setindex!(A, v, to_indices(A, Is)...)

## scalar indexing

@propagate_inbounds function scalar_getindex(A::AbstractGPUArray{T}, Is...) where T
    @boundscheck checkbounds(A, Is...)
    I = Base._to_linear_index(A, Is...)
    getindex(A, I)
end

@propagate_inbounds function scalar_setindex!(A::AbstractGPUArray{T}, v, Is...) where T
    @boundscheck checkbounds(A, Is...)
    I = Base._to_linear_index(A, Is...)
    setindex!(A, v, I)
end

# we still dispatch to `Base.getindex(a, ::Int)` etc so that there's a single method to
# override when a back-end (e.g. with unified memory) wants to allow scalar indexing.

@propagate_inbounds function Base.getindex(A::AbstractGPUArray{T}, I::Int) where T
    @boundscheck checkbounds(A, I)
    assertscalar("getindex")
    x = Array{T}(undef, 1)
    copyto!(x, 1, A, I, 1)
    return x[1]
end

@propagate_inbounds function Base.setindex!(A::AbstractGPUArray{T}, v, I::Int) where T
    @boundscheck checkbounds(A, I)
    assertscalar("setindex!")
    x = T[v]
    copyto!(A, I, x, 1, 1)
    return A
end

## vectorized indexing

@propagate_inbounds function vectorized_getindex!(dest::AbstractGPUArray,
                                                  src::AbstractArray, Is...)
    any(isempty, Is) && return dest # indexing with empty array
    idims = map(length, Is)

    # NOTE: we are pretty liberal here supporting non-GPU indices...
    Is = map(adapt(ToGPU(dest)), Is)
    @boundscheck checkbounds(src, Is...)

    getindex_kernel(get_backend(dest))(dest, src, idims, Is...; ndrange=size(dest))
    return dest
end

@propagate_inbounds function vectorized_getindex(src::AbstractGPUArray, Is...)
    shape = Base.index_shape(Is...)
    dest = similar(src, shape)
    return vectorized_getindex!(dest, src, Is...)
end

@kernel function getindex_kernel(dest, src, idims, Is...)
    i = @index(Global, Linear)
    getindex_generated(dest, src, idims, i, Is...)
end
@generated function getindex_generated(dest, src, idims, i, Is::Vararg{Any,N}) where {N}
    quote
        is = @inbounds CartesianIndices(idims)[i]
        @nexprs $N i -> I_i = @inbounds(Is[i][is[i]])
        val = @ncall $N getindex src i -> I_i
        @inbounds dest[i] = val
    end
end

@propagate_inbounds function vectorized_setindex!(dest::AbstractArray, src, Is...)
    isempty(Is) && return dest
    idims = length.(Is)
    len = prod(idims)
    len==0 && return dest
    if length(src) != len
        if length(src) == 1
            throw(ArgumentError("indexed assignment with a single value to possibly many locations is not supported; perhaps use broadcasting `.=` instead?"))
        else
            throw(DimensionMismatch("dimensions must match: a has "*string(length(src))*" elements, b has  "*string(len)))
        end
    end

    # NOTE: we are pretty liberal here supporting non-GPU indices...
    Is = map(adapt(ToGPU(dest)), Is)
    @boundscheck checkbounds(dest, Is...)

    setindex_kernel(get_backend(dest))(dest, adapt(ToGPU(dest), src), idims, len, Is...;
             ndrange = length(dest))
    return dest
end

@kernel function setindex_kernel(dest, src, idims, len, Is...)
    i = @index(Global, Linear)
    setindex_generated(dest, src, idims, len, i, Is...)
end
@generated function setindex_generated(dest, src, idims, len, i, Is::Vararg{Any,N}) where {N}
    quote
        i > len && return
        is = @inbounds CartesianIndices(idims)[i]
        @nexprs $N i -> I_i = @inbounds(Is[i][is[i]])
        @ncall $N setindex! dest src[i] i -> I_i
        return
    end
end


# bounds checking

# indices residing on the GPU should be bounds-checked on the GPU to avoid iteration.

# not all wrapped GPU arrays make sense as indices, so we use a subset of `AnyGPUArray`
const IndexGPUArray{T} = Union{AbstractGPUArray{T},
                               SubArray{T, <:Any, <:AbstractGPUArray},
                               LinearAlgebra.Adjoint{T}}

@inline function Base.checkindex(::Type{Bool}, inds::AbstractUnitRange, I::IndexGPUArray)
    all(broadcast(I) do i
        Base.checkindex(Bool, inds, i)
    end)
end

@inline function Base.checkindex(::Type{Bool}, inds::Tuple,
                                 I::IndexGPUArray{<:CartesianIndex})
    all(broadcast(I) do i
        Base.checkbounds_indices(Bool, inds, (i,))
    end)
end

## Vectorized index overloading for `WrappedGPUArray`
# We'd better not to overload `getindex`/`setindex!` directly as otherwise
# the ambiguities from the default scalar fallback become a mess.
# The default `getindex` for `AbstractArray` follows a `similar`-`copyto!` style.
# Thus we only dispatch the `copyto!` part (`Base._unsafe_getindex!`) to our implement.
function Base._unsafe_getindex!(dest::AbstractGPUArray, src::AbstractArray, Is::Vararg{Union{Real, AbstractArray}, N}) where {N}
    return vectorized_getindex!(dest, src, Base.ensure_indexable(Is)...)
end
# Similar for `setindex!`, its default fallback is equivalent to `copyto!`.
# We only dispatch the `copyto!` part (`Base._unsafe_setindex!`) to our implement.
# Also cover the outer `ReshapedArray` that `_maybe_reshape` produces when the parent
# is a `WrappedGPUArray`. Keeping this in the same `Union` as `WrappedGPUArray` (rather
# than as a second method) avoids the dispatch ambiguity from #587: the two signatures
# would otherwise overlap (`WrappedGPUArray` already includes some `ReshapedArray`s)
# without either being a strict subtype of the other.
function Base._unsafe_setindex!(::IndexStyle, A::Union{
            WrappedGPUArray,
            Base.ReshapedArray{<:Any, <:Any, <:WrappedGPUArray},
        }, x, Is::Vararg{Union{Real,AbstractArray}, N}) where N
    return vectorized_setindex!(A, x, Base.ensure_indexable(Is)...)
end

# find*

# simple array type that returns the index used to access an element, while
# retaining the dimensionality of the original array. this can be used to
# broadcast or reduce an array together with its indices, whereas normally
# combining e.g. a 2x2 array with its 4-element eachindex array would result
# in a 4x4 broadcast or reduction.
struct EachIndex{T,N,IS} <: AbstractArray{T,N}
    dims::NTuple{N,Int}
    indices::IS
end
EachIndex(A::AbstractArray) =
    EachIndex{typeof(firstindex(A)), ndims(A), typeof(eachindex(A))}(
              size(A), eachindex(A))
Base.size(ei::EachIndex) = ei.dims
Base.getindex(ei::EachIndex, i::Int) = ei.indices[i]
Base.IndexStyle(::Type{<:EachIndex}) = Base.IndexLinear()

function findfirstlast_reduction(op_and_dummy, t1, t2)
    op, dummy_index = op_and_dummy
    (x, i), (y, j) = t1, t2
    if op(i, j)
        t1, t2 = t2, t1
        (x, i), (y, j) = t1, t2
    end
    x && return t1
    y && return t2
    return (false, dummy_index)
end

for (find_f, op, dummy_f) in ((:(Base.findfirst), :>, :first), (:(Base.findlast), :<, :last))
    @eval begin
        function $find_f(f::Function, A::AnyGPUArray)
            isempty(A) && return nothing
            indices = EachIndex(A)
            dummy_index = $dummy_f(indices)

            # given two pairs of (istrue, index), return the one with the smallest index
            res = mapreduce((x, y)->(f(x), y), (a, b)->findfirstlast_reduction(($op, dummy_index), a, b), A, indices;
                            init = (false, dummy_index))
            if res[1]
                # out of consistency with Base.findarray, return a CartesianIndex
                # when the input is a multidimensional array
                ndims(A) == 1 && return res[2]
                return CartesianIndices(A)[res[2]]
            else
                return nothing
            end
        end
    end
end
Base.findfirst(A::AnyGPUArray{Bool}) = findfirst(identity, A)
Base.findlast(A::AnyGPUArray{Bool})  = findlast(identity, A)

function findminmax(binop, f, A::AnyGPUArray; init, dims)
    indices = EachIndex(A)
    dummy_index = firstindex(A)

    function reduction(t1, t2)
        (x, i), (y, j) = t1, t2

        binop(x, y) && return t2
        isequal(x, y) && return (x, min(i, j))
        return t1
    end
    
    fA = f.(A)

    if dims == Colon()
        res = mapreduce(tuple, reduction, fA, indices; init = (init, dummy_index))

        # out of consistency with Base.findarray, return a CartesianIndex
        # when the input is a multidimensional array
        return (res[1], ndims(A) == 1 ? res[2] : CartesianIndices(A)[res[2]])
    else
        res = mapreduce(tuple, reduction, fA, indices;
                        init = (init, dummy_index), dims=dims)
        vals = map(x->x[1], res)
        inds = map(x->ndims(A) == 1 ? x[2] : CartesianIndices(A)[x[2]], res)
        return (vals, inds)
    end
end

Base.findmax(a::AnyGPUArray; dims=:) = findminmax(Base.isless, identity, a; init=typemin(eltype(a)), dims)
Base.findmin(a::AnyGPUArray; dims=:) = findminmax(Base.isgreater, identity, a; init=typemax(eltype(a)), dims)
Base.findmax(f::Function, a::AnyGPUArray; dims=:) = findminmax(Base.isless, f, a; init=typemin(f(zero(eltype(a)))), dims)
Base.findmin(f::Function, a::AnyGPUArray; dims=:) = findminmax(Base.isgreater, f, a; init=typemax(f(zero(eltype(a)))), dims)

using ParallelTestRunner: runtests, parse_args
import GPUArrays

include("testsuite.jl")

const init_worker_code = quote
    using Test, JLArrays, SparseArrays

    include("testsuite.jl")

    TestSuite.sparse_types(::Type{<:JLArray}) = (JLSparseVector, JLSparseMatrixCSC, JLSparseMatrixCSR)
    TestSuite.sparse_types(::Type{<:Array})   = (SparseVector, SparseMatrixCSC)

    # Disable Float16-related tests until JuliaGPU/KernelAbstractions#600 is resolved
    if isdefined(JLArrays.KernelAbstractions, :POCL)
        TestSuite.supported_eltypes(::Type{<:JLArray}) =
            setdiff(TestSuite.supported_eltypes(), [Float16, ComplexF16])
    end
end

const init_code = quote
    using Test, JLArrays, SparseArrays

    import ..TestSuite
end

args = parse_args(ARGS)

testsuite = Dict{String, Expr}()
for AT in (:JLArray, :Array), name in keys(TestSuite.tests)
    testsuite["$(AT)/$name"] = :(TestSuite.tests[$name]($AT))
end

runtests(GPUArrays, ARGS; init_code, init_worker_code, testsuite)

# A non-`Number` isbits eltype with a custom sampler, mirroring how ColorTypes
# hooks colorants into the Random API. Exercises the generic element-wise rand!
# path; regression cover for JuliaGPU/CUDA.jl#3179.
struct RGBTriplet
    r::Float32
    g::Float32
    b::Float32
end
Random.rand(rng::AbstractRNG, ::Random.SamplerType{RGBTriplet}) =
    RGBTriplet(rand(rng, Float32), rand(rng, Float32), rand(rng, Float32))

@testsuite "random" (AT, eltypes)->begin
    rng = if AT <: AbstractGPUArray
        GPUArrays.RNG{AT}()
    else
        Random.default_rng()
    end

    @testset "rand" begin  # uniform
        @testset "$T $d" for T in eltypes, d in (2, (2,2), (2,2,2))
            A = AT{T}(undef, d)
            B = copy(A)
            rand!(rng, A)
            rand!(rng, B)
            @test Array(A) != Array(B)
        end

        # empty arrays
        B = AT{Float32}(undef, 0)
        rand!(rng, B)
        @test isempty(Array(B))

        # Bool coverage
        A = AT{Bool}(undef, 1024)
        fill!(A, false)
        rand!(rng, A)
        @test true in Array(A)
        fill!(A, true)
        rand!(rng, A)
        @test false in Array(A)
    end

    @testset "randn" begin  # normally-distributed
        @testset "$T $d" for T in filter(isrealfloattype, eltypes),
                              d in (2, (2,2), (2,2,2))
            A = AT{T}(undef, d)
            B = copy(A)
            randn!(rng, A)
            randn!(rng, B)
            @test Array(A) != Array(B)
        end

        # complex randn
        for T in filter(t -> t <: Complex && isrealfloattype(real(t)), eltypes)
            A = AT{T}(undef, 8)
            randn!(rng, A)
            @test !any(isnan, Array(A))
        end

        # empty arrays
        A = AT{Float32}(undef, 0)
        randn!(rng, A)
        @test isempty(Array(A))

        # Box-Muller should not produce infinities
        if Float32 in eltypes
            @test isfinite(maximum(randn!(rng, AT{Float32}(undef, 2^20))))
        end
    end

    @testset "seeding" begin
        if AT <: AbstractGPUArray
            # seeding should produce reproducible results
            for T in (Float32, Float64)
                if T in eltypes
                    Random.seed!(rng, 1)
                    A = rand!(rng, AT{T}(undef, 100))
                    Random.seed!(rng, 1)
                    B = rand!(rng, AT{T}(undef, 100))
                    @test Array(A) == Array(B)

                    Random.seed!(rng, 1)
                    A = randn!(rng, AT{T}(undef, 100))
                    Random.seed!(rng, 1)
                    B = randn!(rng, AT{T}(undef, 100))
                    @test Array(A) == Array(B)
                end
            end
        end
    end

    # a CPU RNG into a GPU array should route through a CPU generate + copyto!,
    # not the stdlib scalar setindex! fallback
    if AT <: AbstractGPUArray && Float32 in eltypes
        @testset "CPU RNG → GPU array" begin
            cpu_rng = MersenneTwister(1)
            A = AT{Float32}(undef, 16)
            @test (rand!(cpu_rng, A); true)
            @test (randn!(cpu_rng, A); true)
        end
    end

    # non-`Number` eltypes with a custom sampler must generate element-wise
    # rather than hit an ambiguous fallback (JuliaGPU/CUDA.jl#3179)
    if AT <: AbstractGPUArray
        @testset "non-Number eltype" begin
            A = AT{RGBTriplet}(undef, 1024)
            rand!(rng, A)
            h = Array(A)
            @test all(t -> 0f0 <= t.r <= 1f0 && 0f0 <= t.g <= 1f0 && 0f0 <= t.b <= 1f0, h)
            @test any(t -> t.r != h[1].r, h)
        end

        # randn! on a non-float eltype must error cleanly, not recurse forever
        @testset "randn! rejects non-float" begin
            @test_throws MethodError randn!(rng, AT{Int32}(undef, 4))
        end
    end
end

# revert JuliaLang/julia#32867; avoid string interpolation
#
# NOTE: without contextual dispatch, we can only redefine methods where a GPU-specific
#       type occurs in the signature (or we'll get a "fatal precompilation failure" error)

_bcs1(a::Integer, b::Integer) = a == 1 ? b : (b == 1 ? a : (a == b ? a : throw(DimensionMismatch("arrays could not be broadcast to a common size"))))
_bcs1(a::Integer, b) = a == 1 ? b : (first(b) == 1 && last(b) == a ? b : throw(DimensionMismatch("arrays could not be broadcast to a common size")))
_bcs1(a, b::Integer) = _bcs1(b, a)
_bcs1(a, b) = Broadcast._bcsm(b, a) ? Broadcast.axistype(b, a) : (Broadcast._bcsm(a, b) ? Broadcast.axistype(a, b) : throw(DimensionMismatch("arrays could not be broadcast to a common size")))

_bcs(::Tuple{}, ::Tuple{}) = ()
_bcs(::Tuple{}, newshape::Tuple) = (newshape[1], _bcs((), Base.tail(newshape))...)
_bcs(shape::Tuple, ::Tuple{}) = (shape[1], _bcs(Base.tail(shape), ())...)
function _bcs(shape::Tuple, newshape::Tuple)
    return (_bcs1(shape[1], newshape[1]), _bcs(Base.tail(shape), Base.tail(newshape))...)
end

broadcast_shape(shape::Tuple) = shape
broadcast_shape(shape::Tuple, shape1::Tuple, shapes::Tuple...) = broadcast_shape(_bcs(shape, shape1), shapes...)

@inline combine_axes(A, B...) = broadcast_shape(axes(A), combine_axes(B...))
combine_axes(A) = axes(A)

Broadcast._axes(::Broadcasted{<:AbstractGPUArrayStyle}, axes::Tuple) = axes
@inline Broadcast._axes(bc::Broadcasted{<:AbstractGPUArrayStyle}, ::Nothing) = combine_axes(bc.args...)

@testsuite "indexing scalar" (AT, eltypes)->begin
    AT <: AbstractGPUArray && @testset "errors and warnings" begin
        x = AT([0])

        @test_throws ErrorException x[]

        @allowscalar begin
            x[] = 1
            @test x[] == 1
        end

        @test_throws ErrorException x[]

        allowscalar() do
            x[] = 2
            @test x[] == 2
        end

        @test_throws ErrorException x[]

        @allowscalar y = 42
        @test y == 42
    end

    @allowscalar @testset "getindex with $T" for T in eltypes
        x = rand(T, 32)
        src = AT(x)
        for (i, xi) in enumerate(x)
            @test src[i] == xi
        end
        @test Array(src[1:3]) == x[1:3]
        @test Array(src[3:end]) == x[3:end]
    end

    @allowscalar @testset "setindex! with $T" for T in eltypes
        x = fill(zero(T), 7)
        src = AT(x)
        for i = 1:7
            src[i] = i
        end
        @test Array(src) == T[1:7;]
        src[1:3] = T[77, 22, 11]
        @test Array(src[1:3]) == T[77, 22, 11]
        src[1] = T(0)
    end

    @allowscalar @testset "issue #42 with $T" for T in eltypes
        Ac = rand(Float32, 2, 2)
        A = AT(Ac)
        @test A[1] == Ac[1]
        @test A[end] == Ac[end]
        @test A[1, 1] == Ac[1, 1]
    end

    @allowscalar @testset "get/setindex!" begin
        # literal calls to get/setindex! have different return types
        @test compare(x->getindex(x,1), AT, zeros(Int, 2))
        @test compare(x->setindex!(x,1,1), AT, zeros(Int, 2))

        # issue #319
        @test compare(x->setindex!(x,1,1,1), AT, zeros(Float32, 2, 2))
    end
end

@testsuite "indexing multidimensional" (AT, eltypes)->begin
    @testset "sliced setindex" for T in eltypes
        x = AT(zeros(T, (10, 10, 10, 10)))
        y = AT(rand(T, (5, 5, 10, 10)))
        x[2:6, 2:6, :, :] = y
        @test Array(x[2:6, 2:6, :, :]) == Array(y)
    end

    @testset "sliced setindex, CPU source" for T in eltypes
        x = AT(zeros(T, (2,3,4)))
        y = AT(rand(T, (2,3)))
        x[:, :, 2] = y
        @test Array(x[:, :, 2]) == Array(y)
    end

    @allowscalar @testset "empty array" begin
        @testset "1D" begin
            Ac = zeros(Float32, 10)
            A = AT(Ac)
            @test typeof(A[[]]) == typeof(AT(Ac[[]]))
            @test size(A[[]]) == size(Ac[[]])
        end

        @testset "2D with other index $other" for other in (Colon(), 1:5, 5)
            Ac = zeros(Float32, 10, 10)
            A = AT(Ac)

            @test typeof(A[[], other]) == typeof(AT(Ac[[], other]))
            @test size(A[[], other]) == size(Ac[[], other])

            @test typeof(A[other, []]) == typeof(AT(Ac[other, []]))
            @test size(A[other, []]) == size(Ac[other, []])
        end

        @test compare(AT, rand(Float32, 2,2)) do a
            a[:, 2:end-2] = AT{Float32}(undef,2,0)
        end
    end

    @testset "GPU source" begin
        a = rand(Float32, 3)
        i = rand(1:3, 2)
        @test compare(getindex, AT, a, i)
        @test compare(getindex, AT, a, i')
        @test compare(getindex, AT, a, view(i, 2:2))
    end

    @testset "CPU source" begin
        # JuliaGPU/CUDA.jl#345
        a = rand(Float32, 3, 4)
        i = rand(1:3,2,2)
        @test compare(a->a[i,:], AT, a)
        @test compare(a->a[i',:], AT, a)
        @test compare(a->a[view(i,1,:),:], AT, a)
    end

    @testset "JuliaGPU/CUDA.jl#461: sliced setindex" begin
        @test compare((X,Y)->(X[1,:] = Y), AT, zeros(Float32, 2,2), ones(Float32, 2))
    end

    @testset "Broadcasting exceptions" for T in eltypes
        x = AT(zeros(T, (10, 10, 10, 10)))
        @test_throws ArgumentError x[1, :, :, :] = 0
        y = AT(rand(T, (5, 5, 5, 5)))
        @test_throws DimensionMismatch x[1:9,1:9,:,:] = y
    end

    @testset "mismatching axes/indices" begin
        a = rand(Float32, 1,1)
        @test compare(a->a[1:1], AT, a)
        @test compare(a->a[1:1,1:1], AT, a)
        @test compare(a->a[1:1,1:1,1:1], AT, a)
    end

    @testset "getindex for WrapperGPUArray" begin
        a = rand(Float32, 5, 5)
        @test compare(a->a'[:, 1], AT, a)
        @test compare(a->Base.PermutedDimsArray(a, (2, 1))[2:-1:1, 1:2], AT, a)
        @test compare(a->LowerTriangular(a)[:], AT, a)
        @test compare(a->Symmetric(a, :U)[a .> 0], AT, a)
    end

    @testset "setindex! for WrapperGPUArray" for T in eltypes
        x = AT(zeros(T, (10, 10)))'
        y = AT(rand(T, (5, 5)))
        x[2:6, 2:6] = y
        @test Array(parent(x)[2:6, 2:6]) == Array(y)'
        x[2:6, 2:6] = 1:25
        @test Array(parent(x)[2:6, 2:6]) == reshape(1:25, 5, 5)'
    end
end

@testsuite "indexing find" (AT, eltypes)->begin
    @testset "findfirst" begin
        # 1D
        @test compare(findfirst, AT, rand(Bool, 100))
        @test compare(x->findfirst(>(0.5f0), x), AT, rand(Float32, 100))
        @test compare(findfirst, AT, fill(false, 10))
        let x = fill(false, 10)
            @test findfirst(x) == findfirst(AT(x))
        end

        # ND
        let x = rand(Bool, 10, 10)
            @test findfirst(x) == findfirst(AT(x))
        end
        let x = rand(Float32, 10, 10)
            @test findfirst(>(0.5f0), x) == findfirst(>(0.5f0), AT(x))
        end

        # empty
        @test compare(findfirst, AT, Bool[])
        @test compare(x->findfirst(>(0.5f0), x), AT, Float32[])
    end
    @testset "findlast" begin
        # 1D
        @test compare(findlast, AT, rand(Bool, 100))
        @test compare(x->findlast(>(0.5f0), x), AT, rand(Float32, 100))
        let x = fill(false, 10)
            @test findlast(x) == findlast(AT(x))
        end

        # ND
        let x = rand(Bool, 10, 10)
            @test findlast(x) == findlast(AT(x))
        end
        let x = rand(Float32, 10, 10)
            @test findlast(>(0.5f0), x) == findlast(>(0.5f0), AT(x))
        end

        # empty
        @test compare(findlast, AT, Bool[])
        @test compare(x->findlast(>(0.5f0), x), AT, Float32[])
    end

    @testset "findmax & findmin" begin
        let x = rand(Float32, 100)
            @test findmax(x) == findmax(AT(x))
            @test findmax(x; dims=1) == Array.(findmax(AT(x); dims=1))

            x[32] = x[33] = x[55] = x[66] = NaN32
            @test isequal(findmax(x), findmax(AT(x)))
            @test isequal(findmax(x; dims=1), Array.(findmax(AT(x); dims=1)))
        end
        let x = randn(Float32, 100)
            @test findmax(abs, x) == findmax(abs, AT(x))
            @test findmax(abs, x; dims=1) == Array.(findmax(abs, AT(x); dims=1))

            x[32] = x[33] = x[55] = x[66] = NaN32
            @test isequal(findmax(abs, x), findmax(abs, AT(x)))
            @test isequal(findmax(abs, x; dims=1), Array.(findmax(abs, AT(x); dims=1)))
        end
        let x = rand(Float32, 10, 10)
            @test findmax(x) == findmax(AT(x))
            @test findmax(x; dims=1) == Array.(findmax(AT(x); dims=1))
            @test findmax(x; dims=2) == Array.(findmax(AT(x); dims=2))

            x[rand(CartesianIndices((10, 10)), 10)] .= NaN
            @test isequal(findmax(x), findmax(AT(x)))
            @test isequal(findmax(x; dims=1), Array.(findmax(AT(x); dims=1)))
        end
        let x = rand(Float32, 10, 10, 10)
            @test findmax(x) == findmax(AT(x))
            @test findmax(x; dims=1) == Array.(findmax(AT(x); dims=1))
            @test findmax(x; dims=2) == Array.(findmax(AT(x); dims=2))
            @test findmax(x; dims=3) == Array.(findmax(AT(x); dims=3))

            x[rand(CartesianIndices((10, 10, 10)), 20)] .= NaN
            @test isequal(findmax(x), findmax(AT(x)))
            @test isequal(findmax(x; dims=1), Array.(findmax(AT(x); dims=1)))
            @test isequal(findmax(x; dims=2), Array.(findmax(AT(x); dims=2)))
            @test isequal(findmax(x; dims=3), Array.(findmax(AT(x); dims=3)))
        end

        let x = rand(Float32, 100)
            @test findmin(x) == findmin(AT(x))
            @test findmin(x; dims=1) == Array.(findmin(AT(x); dims=1))

            x[32] = x[33] = x[55] = x[66] = NaN32
            @test isequal(findmin(x), findmin(AT(x)))
            @test isequal(findmin(x; dims=1), Array.(findmin(AT(x); dims=1)))
        end
        let x = randn(Float32, 100)
            @test findmin(abs, x) == findmin(abs, AT(x))
            @test findmin(abs, x; dims=1) == Array.(findmin(abs, AT(x); dims=1))

            x[32] = x[33] = x[55] = x[66] = NaN32
            @test isequal(findmin(abs, x), findmin(abs, AT(x)))
            @test isequal(findmin(abs, x; dims=1), Array.(findmin(abs, AT(x); dims=1)))
        end
        let x = rand(Float32, 10, 10)
            @test findmin(x) == findmin(AT(x))
            @test findmin(x; dims=1) == Array.(findmin(AT(x); dims=1))
            @test findmin(x; dims=2) == Array.(findmin(AT(x); dims=2))

            x[rand(CartesianIndices((10, 10)), 10)] .= NaN
            @test isequal(findmin(x), findmin(AT(x)))
            @test isequal(findmin(x; dims=1), Array.(findmin(AT(x); dims=1)))
            @test isequal(findmin(x; dims=2), Array.(findmin(AT(x); dims=2)))
            @test isequal(findmin(x; dims=3), Array.(findmin(AT(x); dims=3)))
        end
        let x = rand(Float32, 10, 10, 10)
            @test findmin(x) == findmin(AT(x))
            @test findmin(x; dims=1) == Array.(findmin(AT(x); dims=1))
            @test findmin(x; dims=2) == Array.(findmin(AT(x); dims=2))
            @test findmin(x; dims=3) == Array.(findmin(AT(x); dims=3))

            x[rand(CartesianIndices((10, 10, 10)), 20)] .= NaN
            @test isequal(findmin(x), findmin(AT(x)))
            @test isequal(findmin(x; dims=1), Array.(findmin(AT(x); dims=1)))
            @test isequal(findmin(x; dims=2), Array.(findmin(AT(x); dims=2)))
            @test isequal(findmin(x; dims=3), Array.(findmin(AT(x); dims=3)))
        end
        # test with Complex elements as long as f outputs a real
        let x = rand(ComplexF32, 100)
            @test findmax(real, x) == findmax(real, AT(x))
            @test findmax(real, x; dims=1) == Array.(findmax(real, AT(x); dims=1))
            @test findmin(real, x) == findmin(real, AT(x))
            @test findmin(real, x; dims=1) == Array.(findmin(real, AT(x); dims=1))
        end
    end

    @testset "argmax & argmin" begin
        @test compare(argmax, AT, rand(Int, 10))
        @test compare(argmax, AT, -rand(Int, 10))

        @test compare(argmin, AT, rand(Int, 10))
        @test compare(argmin, AT, -rand(Int, 10))
    end
end

@testsuite "indexing reshaped wrappers" (AT, eltypes) -> begin
    # Regression for #587: `Q[:] = …` on an `IndexCartesian` SubArray of a GPU array
    # threw a `MethodError` due to ambiguous `_unsafe_setindex!` on the
    # `ReshapedArray{…,<:WrappedGPUArray}` that `_maybe_reshape` produces. A
    # strided view triggers the same dispatch path as the original `BitVector`
    # MWE without depending on non-isbits indices that some backends reject.
    @testset "issue #587 with $T" for T in eltypes
        @test compare(AT, ones(T, 8, 8, 8)) do P
            Q = view(P, 1:2:7, :, :)
            Q[:] = fill(T(2), length(Q))
            P
        end
    end

    @testset "reshape(view) with $T" for T in eltypes
        @test compare(AT, ones(T, 4, 4, 4)) do A
            R = reshape(view(A, 1:2, 1:2, 1:2), :)
            R[:] = fill(T(2), length(R))
            A
        end
    end

    @testset "reshape(PermutedDimsArray) with $T" for T in eltypes
        @test compare(AT, ones(T, 4, 4)) do A
            R = reshape(PermutedDimsArray(A, (2, 1)), :)
            R[1:2] = fill(zero(T), 2)
            A
        end
    end

    @testset "reshape(reinterpret) with $T" for T in eltypes
        T <: Complex || continue
        IT = Complex{Int16}
        @test compare(AT, ones(T, 4, 4)) do A
            R = reshape(reinterpret(IT, A), :)
            R[1:2] = fill(zero(IT), 2)
            A
        end
    end
end

@testsuite "ext/jld2" (AT, eltypes) -> begin
    mktempdir() do dir
        for ET in eltypes
            @testset "$ET" begin
                # Test with different array sizes and dimensions
                for dims in ((2,), (2, 2), (2, 2, 2))
                    # Create a random array
                    x = AT(rand(ET, dims...))

                    # Save to a temporary file
                    file = joinpath(dir, "test.jld2")

                    # Save and load
                    JLD2.save_object(file, x)
                    y = JLD2.load_object(file)

                    # Verify the loaded array matches the original
                    @test y isa AT{ET, length(dims)}
                    @test size(y) == size(x)
                    @test x == y
                end
            end
        end
    end
end

@testsuite "vectors" (AT, eltypes)->begin
    ## push! not defined for most GPU arrays,
    ## uncomment once it is.
    # a = Float32[]
    # x = AT(a)
    # @test length(x) == 0
    # @test push!(x, 12)
    # @allowscalar begin
    #     @test x[1] == 12
    # end

    a = Float32[0]
    x = AT(a)
    resize!(x, 3)
    @test length(x) == 3

    a = Float32[0, 1, 2]
    x = AT(a)
    resize!(x, 2)
    @test length(x) == 2
    @allowscalar begin
        @test x[1] == 0
        @test x[2] == 1
    end

    a = Float32[0, 1, 2]
    x = AT(a)
    append!(x, [3, 4])
    @test length(x) == 5
    @allowscalar begin
        @test x[4] == 3
        @test x[5] == 4
    end

    a = Float32[0, 1, 2]
    x = AT(a)
    append!(x, (3, 4))
    @test length(x) == 5
    @allowscalar begin
        @test x[4] == 3
        @test x[5] == 4
    end
end

# map-reduce

const AbstractArrayOrBroadcasted = Union{AbstractArray,Broadcast.Broadcasted}

# GPUArrays' mapreduce methods build on `Base.mapreducedim!`, but with an additional
# argument `init` value to avoid eager initialization of `R` (if set to something).
mapreducedim!(f, op, R::AnyGPUArray, A::AbstractArrayOrBroadcasted;
              init=nothing) = error("Not implemented") # COV_EXCL_LINE
# resolve ambiguities
Base.mapreducedim!(f, op, R::AnyGPUArray, A::AbstractArray) = mapreducedim!(f, op, R, A)
Base.mapreducedim!(f, op, R::AnyGPUArray, A::Broadcast.Broadcasted) = mapreducedim!(f, op, R, A)

neutral_element(op, T) =
    error("""GPUArrays.jl needs to know the neutral element for your operator `$op`.
             Please pass it as an explicit argument to `GPUArrays.mapreducedim!`,
             or register it globally by defining `GPUArrays.neutral_element(::typeof($op), T)`.""")
neutral_element(::typeof(Base.:(|)), T) = zero(T)
neutral_element(::typeof(Base.:(⊻)), T) = zero(T)
neutral_element(::typeof(Base.:(&)), T) = ~zero(T)
neutral_element(::typeof(Base.:(+)), T) = zero(T)
neutral_element(::typeof(Base.add_sum), T) = zero(T)
neutral_element(::typeof(Base.:(*)), T) = one(T)
neutral_element(::typeof(Base.mul_prod), T) = one(T)
neutral_element(::typeof(Base.min), T) = typemax(T)
neutral_element(::typeof(Base.max), T) = typemin(T)
neutral_element(::typeof(Base._extrema_rf), ::Type{<:NTuple{2,T}}) where {T} = typemax(T), typemin(T)
@static if isdefined(Base, :and_all) # VERSION >~ v"1.13-"
    neutral_element(::typeof(Base.:(and_all)), T) = ~zero(T)
end
@static if isdefined(Base, :or_any) # VERSION >~ v"1.13-"
    neutral_element(::typeof(Base.:(or_any)), T) = zero(T)
end

# resolve ambiguities
Base.mapreduce(f, op, A::AnyGPUArray, As::AbstractArrayOrBroadcasted...;
               dims=:, init=nothing) = _mapreduce(f, op, A, As...; dims=dims, init=init)
Base.mapreduce(f, op, A::Broadcast.Broadcasted{<:AbstractGPUArrayStyle}, As::AbstractArrayOrBroadcasted...;
               dims=:, init=nothing) = _mapreduce(f, op, A, As...; dims=dims, init=init)

function _mapreduce(f::F, op::OP, As::Vararg{Any,N}; dims::D, init) where {F,OP,N,D}
    # figure out the destination container type by looking at the initializer element,
    # or by relying on inference to reason through the map and reduce functions
    if init === nothing
        ET = Broadcast.combine_eltypes(f, As)
        ET = Base.promote_op(op, ET, ET)
        (ET === Union{} || ET === Any) &&
            error("mapreduce cannot figure the output element type, please pass an explicit init value")

        init = neutral_element(op, ET)
    else
        ET = typeof(init)
    end

    # apply the mapping function to the input arrays
    if N == 1
        # ... with only a single input, we can defer this to the reduce step
        A = only(As)
    else
        # mapreduce should apply `f` like `map` does, consuming elements like iterators
        A = if allequal(size.(As)...)
            Broadcast.instantiate(Broadcast.broadcasted(f, As...))
        else
            # TODO: can we avoid the reshape + view?
            indices = LinearIndices.(As)
            common_length = minimum(length.(indices))
            Bs = map(As) do A
                view(reshape(A, length(A)), 1:common_length)
            end
            Broadcast.instantiate(Broadcast.broadcasted(f, Bs...))
        end
        f = identity
    end

    # allocate an output container
    sz = size(A)
    red = ntuple(i->(dims==Colon() || i in dims) ? 1 : sz[i], length(sz))
    R = similar(A, ET, red)

    # perform the reduction
    if prod(sz) == 0
        fill!(R, init)
    else
        mapreducedim!(f, op, R, A; init)
    end

    # return the result
    if dims === Colon()
        @allowscalar R[]
    else
        R
    end
end

Base.any(A::AnyGPUArray{Bool}) = mapreduce(identity, |, A)
Base.all(A::AnyGPUArray{Bool}) = mapreduce(identity, &, A)

Base.any(f::Function, A::AnyGPUArray) = mapreduce(f, |, A)
Base.all(f::Function, A::AnyGPUArray) = mapreduce(f, &, A)

Base.count(pred::Function, A::AnyGPUArray; dims=:, init=0) =
    mapreduce(pred, Base.add_sum, A; init=init, dims=dims)

# avoid calling into `initarray!`
for (fname, op) in [(:sum, :(Base.add_sum)), (:prod, :(Base.mul_prod)),
                    (:maximum, :(Base.max)), (:minimum, :(Base.min)),
                    (:all, :&),              (:any, :|)]
    fname! = Symbol(fname, '!')
    @eval begin
        Base.$(fname!)(f::Function, r::AnyGPUArray, A::AnyGPUArray{T}) where T =
            GPUArrays.mapreducedim!(f, $(op), r, A; init=neutral_element($(op), T))
    end
end

LinearAlgebra.ishermitian(A::AbstractGPUMatrix) = mapreduce(==, &, A, adjoint(A))


# comparisons

# ignores missing
function Base.isequal(A::AnyGPUArray, B::AnyGPUArray)
    if A === B return true end
    if axes(A) != axes(B)
        return false
    end
    mapreduce(isequal, &, A, B; init=true)
end

# returns `missing` when missing values are involved
function Base.:(==)(A::AnyGPUArray, B::AnyGPUArray)
    if axes(A) != axes(B)
        return false
    end

    function mapper(a, b)
        eq = (a == b)
        if ismissing(eq)
            (; is_missing=true, is_equal=#=don't care=#false)
        else
            (; is_missing=false, is_equal=eq)
        end
    end
    function reducer(a, b)
        if a.is_missing || b.is_missing
            (; is_missing=true, is_equal=#=don't care=#false)
        else
            (; is_missing=false, is_equal=a.is_equal & b.is_equal)
        end
    end
    res = mapreduce(mapper, reducer, A, B; init=(; is_missing=false, is_equal=true))
    res.is_missing ? missing : res.is_equal
end

# convenience and indirect construction

# conversions from CPU arrays rely on constructors
Base.convert(::Type{T}, a::AbstractArray) where {T<:AbstractGPUArray} = a isa T ? a : T(a)
# TODO: can we implement constructors to and from ::AbstractArray here? by calling the undef
#       constructor and doing a `copyto!`. this is tricky, due to ambiguities, and no easy
#       way to go from <:AbstractGPUArray{T,N} to e.g. CuArray{S,N}


## convenience constructors

function Base.fill!(A::AnyGPUArray{T}, x) where T
    isempty(A) && return A

    @kernel function fill_kernel!(a, val)
        idx = @index(Global, Linear)
        @inbounds a[idx] = val
    end

    # ndims check for 0D support
    kernel = fill_kernel!(get_backend(A))
    kernel(A, x; ndrange = length(A))
    A
end


## identity matrices

@kernel function identity_kernel(res::AbstractArray{T}, stride, val) where T
    i = @index(Global, Linear)
    ilin = (stride * (i - 1)) + i
    if ilin <= length(res)
        @inbounds res[ilin] = val
    end
end

function (T::Type{<: AnyGPUArray{U}})(s::UniformScaling, dims::Dims{2}) where {U}
    res = similar(T, dims)
    fill!(res, zero(U))
    isempty(res) && return res
    kernel = identity_kernel(get_backend(res))
    kernel(res, size(res, 1), s.λ; ndrange=minimum(dims))
    return res
end

(T::Type{<: AnyGPUArray})(s::UniformScaling{U}, dims::Dims{2}) where U = T{U}(s, dims)

(T::Type{<: AnyGPUArray})(s::UniformScaling, m::Integer, n::Integer) = T(s, Dims((m, n)))

function Base.copyto!(A::AbstractGPUMatrix{T}, s::UniformScaling) where T
    fill!(A, zero(T))
    isempty(A) && return A
    kernel = identity_kernel(get_backend(A))
    kernel(A, size(A, 1), s.λ; ndrange=minimum(size(A)))
    return A
end

function _one(unit::T, x::AbstractGPUMatrix) where {T}
    m,n = size(x)
    m==n || throw(DimensionMismatch("multiplicative identity defined only for square matrices"))
    I = similar(x, T)
    isempty(I) && return I

    fill!(I, zero(T))
    kernel = identity_kernel(get_backend(I))
    kernel(I, m, unit; ndrange=m)
    I
end

Base.one(x::AbstractGPUMatrix{T}) where {T} = _one(one(T), x)
Base.oneunit(x::AbstractGPUMatrix{T}) where {T} = _one(oneunit(T), x)


## type checking

export contains_eltype, explain_allocatedinline

# back-ends often do not support all kinds of element types, so provide some helpers
# to detect unsupported caes

function hasfieldcount(@nospecialize(dt))
    try
        fieldcount(dt)
    catch
        return false
    end
    return true
end

# for finding specific element types, e.g., when Float64 is unsupported
function contains_eltype(T, typ)
    if T === typ
      return true
    elseif T isa Union
        for U in Base.uniontypes(T)
            contains_eltype(U, typ) && return true
        end
    elseif hasfieldcount(T)
        for U in fieldtypes(T)
            contains_eltype(U, typ) && return true
        end
    end
    return false
end

# Types that are allocated inline include:
# 1. plain bitstypes (`Int`, `(Float16, Float32)`, plain immutable structs, etc).
#    these are simply stored contiguously in the buffer.
# 2. structs of unions (`struct Foo; x::Union{Int, Float32}; end`)
#    these are stored with a selector at the end (handled by Julia).
# 3. bitstype unions (`Union{Int, Float32}`, etc)
#    these are stored contiguously and require a selector array (handled by us)
#
# This function explains why a type is not allocated inline.
function explain_allocatedinline(@nospecialize(T), depth=0; maxdepth=10)
    depth > maxdepth && return ""

    if T isa Union
      msg = "  "^depth * "$T is a union that's not allocated inline\n"
      for U in Base.uniontypes(T)
        if !Base.allocatedinline(U)
          msg *= explain_eltype(U, depth+1)
        end
      end
    elseif Base.ismutabletype(T)
      msg = "  "^depth * "$T is a mutable type\n"
    elseif hasfieldcount(T)
      msg = "  "^depth * "$T is a struct that's not allocated inline\n"
      for U in fieldtypes(T)
          if !Base.allocatedinline(U)
              msg *= explain_nonisbits(U, depth+1)
          end
      end
    else
      msg = "  "^depth * "$T is not allocated inline\n"
    end
    return msg
end


## derived arrays

# to avoid needless array wrappers (which make it harder to write generic wrappers) we
# materialize several kinds of operations:
# - contiguous views
# - reinterpret
# - reshape
#
# For this functionality to be reusable, we expect the back-end to provide a `derive`
# operation that makes it possible to create a new array object, with a different type or
# size, but backed by the same data. The `additional_offset` is the number of elements
# to offset the new array from the original array.

derive(::Type, a::AbstractGPUArray, osize::Dims, additional_offset::Int) =
    error("Not implemented")

# RNG: the old RNG took a GPU state array and Vector{UInt32} seeds.
# The new stateless Philox4x32 RNG doesn't need either.

function RNG(state::AbstractGPUArray)
    AT = Base.typename(typeof(state)).wrapper
    Base.depwarn("RNG(state::AbstractGPUArray) is deprecated, use RNG{$AT}() instead", :RNG)
    RNG{AT}()
end

function Random.seed!(rng::RNG, seed::Vector{UInt32})
    Base.depwarn("seed!(rng::RNG, seed::Vector{UInt32}) is deprecated, use seed!(rng, seed::Integer) instead", :seed!)
    Random.seed!(rng, isempty(seed) ? rand(Random.RandomDevice(), UInt64) : first(seed))
end

# Stub kept so downstream packages that still extend `GPUArrays.default_rng`
# (Metal.jl, etc.) continue to load. The interface itself is gone — `RNG{AT}()`
# is now constructed directly — so any extension of this is dead code.
function default_rng end

@testsuite "math/intrinsics" (AT, eltypes)->begin
    for ET in filter(!iscomplextype, eltypes)
        T = AT{ET}
        @testset "$ET" begin
            range = ET <: Integer ? (ET(-2):ET(2)) : ET
            low = ET(-1)
            high = ET(1)
            @testset "clamp!" begin
                for N in (2, 10)
                    @test compare(x -> clamp!(x, low, high), AT, rand(range, N, N))
                end
            end
        end
    end
end

@testsuite "math/power" (AT, eltypes)->begin
    for ET in eltypes
        for p in 0:5
            @test compare(x->x^p, AT, rand(ET, 2,2))
        end
    end
end

@testsuite "constructors" (AT, eltypes)->begin
    @testset "direct" begin
        for T in eltypes
            B = AT{T}(undef, 10)
            @test B isa AT{T,1}
            @test size(B) == (10,)
            @test eltype(B) == T

            B = AT{T}(undef, 10, 10)
            @test B isa AT{T,2}
            @test size(B) == (10, 10)
            @test eltype(B) == T

            B = AT{T}(undef, (10, 10))
            @test B isa AT{T,2}
            @test size(B) == (10, 10)
            @test eltype(B) == T
        end

        # compare against Array
        for typs in [(), (Int,), (Int,1), (Int,2), (Float32,), (Float32,1), (Float32,2)],
            args in [(), (1,), (1,2),  (Int32(1),Int64(2)), ((1,),), ((1,2),),
                        ((Int32(1),Int64(2)),),
                    (undef,), (undef, 1,), (undef, 1,2), (undef, Int32(1),Int64(2)),
                        (undef, (1,),), (undef, (1,2),), (undef, (Int32(1),Int64(2)),),
                    (Int,), (Int, 1,), (Int, 1,2), (Int, Int32(1),Int64(2)), (Int, (1,),),
                        (Int, (1,2),), (Int, (Int32(1),Int64(2)),),
                    ([1,2],), ([1 2],)]
            cpu = try
                Array{typs...}(args...)
            catch ex
                isa(ex, MethodError) || rethrow()
                nothing
            end

            gpu = try
                AT{typs...}(args...)
            catch ex
                isa(ex, MethodError) || rethrow()
                cpu == nothing || rethrow()
                nothing
            end

            if cpu == nothing
                @test gpu == nothing
            else
                @test typeof(cpu) == typeof(convert(Array, gpu))
            end
        end
    end

    @testset "similar" begin
        for T in eltypes
            B = AT{T}(undef, 10)

            B = similar(B, Int32, 11, 15)
            @test B isa AT{Int32,2}
            @test size(B) == (11, 15)
            @test eltype(B) == Int32

            B = similar(B, T)
            @test B isa AT{T,2}
            @test size(B) == (11, 15)
            @test eltype(B) == T

            B = similar(B, (5,))
            @test B isa AT{T,1}
            @test size(B) == (5,)
            @test eltype(B) == T

            B = similar(B, 7)
            @test B isa AT{T,1}
            @test size(B) == (7,)
            @test eltype(B) == T

            B = similar(AT{Int32}, (11, 15))
            @test B isa AT{Int32,2}
            @test size(B) == (11, 15)
            @test eltype(B) == Int32

            B = similar(AT{T}, (5,))
            @test B isa AT{T,1}
            @test size(B) == (5,)
            @test eltype(B) == T

            B = similar(AT{T}, 7)
            @test B isa AT{T,1}
            @test size(B) == (7,)
            @test eltype(B) == T

            B = similar(Broadcast.Broadcasted(*, (B, B)), T)
            @test B isa AT{T,1}
            @test size(B) == (7,)
            @test eltype(B) == T

            B = similar(Broadcast.Broadcasted(*, (B, B)), Int32, (11, 15))
            @test B isa AT{Int32,2}
            @test size(B) == (11, 15)
            @test eltype(B) == Int32
        end
    end

    @testset "convenience" begin
        for T in eltypes
            A = AT(rand(T, 0))
            b = rand(T)
            fill!(A, b)
            @test A isa AT{T,1}
            @test Array(A) == fill(b, 0)

            A = AT(rand(T, 3))
            b = rand(T)
            fill!(A, b)
            @test A isa AT{T,1}
            @test Array(A) == fill(b, 3)

            A = zero(AT(rand(T, 2)))
            @test A isa AT{T,1}
            @test Array(A) == zero(rand(T, 2))

            A = zero(AT(rand(T, 2, 2)))
            @test A isa AT{T,2}
            @test Array(A) == zero(rand(T, 2, 2))

            A = zero(AT(rand(T, 2, 2, 2)))
            @test A isa AT{T,3}
            @test Array(A) == zero(rand(T, 2, 2, 2))

            A = one(AT(rand(T, 2, 2)))
            @test A isa AT{T,2}
            @test Array(A) == one(rand(T, 2, 2))

            A = one(AT(rand(T, 0, 0)))
            @test A isa AT{T,2}
            @test Array(A) == one(rand(T, 0, 0))

            A = oneunit(AT(rand(T, 2, 2)))
            @test A isa AT{T,2}
            @test Array(A) == oneunit(rand(T, 2, 2))
        end
    end

    @testset "conversions" begin
        for T in eltypes
            Bc = round.(rand(10, 10) .* 10.0)
            B = AT{T}(Bc)
            @test size(B) == (10, 10)
            @test eltype(B) == T
            @test Array(B) ≈ Bc

            Bc = rand(T, 10)
            B = AT(Bc)
            @test size(B) == (10,)
            @test eltype(B) == T
            @test Array(B) ≈ Bc

            Bc = rand(T, 10, 10)
            B = AT{T, 2}(Bc)
            @test size(B) == (10, 10)
            @test eltype(B) == T
            @test Array(B) ≈ Bc

            intervals = Dict(
                Float16 => -2^11:2^11,
                Float32 => -2^24:2^24,
                Float64 => -2^53:2^53,
            )

            Bc = rand(Int8, 3, 3, 3)
            B = convert(AT{T, 3}, Bc)
            @test size(B) == (3, 3, 3)
            @test eltype(B) == T
            @test Array(B) ≈ Bc
        end
    end

    @testset "uniformscaling" begin
        for T in eltypes
            x = Matrix{T}(I, 4, 2)

            x1 = AT{T, 2}(I, 4, 2)
            x2 = AT{T}(I, (4, 2))
            x3 = AT{T, 2}(I, (4, 2))

            @test Array(x1) ≈ x
            @test Array(x2) ≈ x
            @test Array(x3) ≈ x

            x = Matrix(T(3) * I, 2, 4)
            x1 = AT(T(3) * I, 2, 4)
            @test eltype(x1) == T
            @test Array(x1) ≈ x
        end

        @testset "empty" begin
            x = Matrix{Float32}(I, (0, 3))
            x1 = AT{Float32, 2}(I, (0, 3))

            @test Array(x1) ≈ x

            copyto!(x1, I)
            @test Array(x1) ≈ x
        end

        @testset "JuliaGPU/GPUArrays.jl#439" begin
            x = AT{Float32}(I, 500, 300)
            y = Array{Float32}(I, 500, 300)
            @test Array(x) == y
        end
    end
end

# core definition of the AbstractGPUArray type


# storage handling

export DataRef, unsafe_free!

# DataRef provides a helper class to manage the storage of an array.
#
# There's multiple reasons we don't just put the data directly in a GPUArray struct:
# - to share data between multiple arrays, e.g., to create views;
# - to be able to early-free data and release GC pressure.
#
# To support this, wrap the data in a DataRef instead, and use it with the following methods:
# - `ref[]`: get the data;
# - `copy(ref)`: create a new reference, increasing the reference count;
# - `unsafe_free!(ref)`: decrease the reference count, and free the data if it reaches 0.
#
# The contained RefCounted struct should not be used directly.

# shared, reference-counted state.
mutable struct RefCounted{D}
  obj::D
  finalizer
  count::Threads.Atomic{Int}
end

function retain(rc::RefCounted)
    if rc.count[] == 0
        throw(ArgumentError("Attempt to retain freed data."))
    end
    Threads.atomic_add!(rc.count, 1)
    return
end

function release(rc::RefCounted, args...)
    if rc.count[] == 0
        throw(ArgumentError("Attempt to release freed data."))
    end
    refcount = Threads.atomic_add!(rc.count, -1)
    if refcount == 1 && rc.finalizer !== nothing
        rc.finalizer(rc.obj, args...)
    end
    return
end

function Base.getindex(rc::RefCounted)
    if rc.count[] == 0
        throw(ArgumentError("Attempt to use freed data."))
    end
    rc.obj
end

# per-object state, with a flag to indicate whether the object has been freed.
# this is to support multiple calls to `unsafe_free!` on the same object,
# while only lowering the reference count of the underlying data once.
mutable struct DataRef{D}
    rc::RefCounted{D}
    freed::Bool
    cached::Bool
end

function DataRef(finalizer, ref::D) where {D}
    rc = RefCounted{D}(ref, finalizer, Threads.Atomic{Int}(1))
    DataRef{D}(rc, false, false)
end
DataRef(ref; kwargs...) = DataRef(nothing, ref; kwargs...)

Base.sizeof(ref::DataRef) = sizeof(ref.rc[])

function Base.getindex(ref::DataRef)
    if ref.freed
        throw(ArgumentError("Attempt to use a freed reference."))
    end
    ref.rc[]
end

function Base.copy(ref::DataRef{D}) where {D}
    if ref.freed
        throw(ArgumentError("Attempt to copy a freed reference."))
    end
    retain(ref.rc)
    # copies of cached references are not managed by the cache, so
    # we need to mark them as such to make sure their refcount can drop.
    return DataRef{D}(ref.rc, false, false)
end

function unsafe_free!(ref::DataRef)
    if ref.cached
        # lifetimes of cached references are tied to the cache.
        return
    end
    if ref.freed
        # multiple frees *of the same object* are allowed.
        # we should only ever call `release` once per object, though,
        # as multiple releases of the underlying data is not allowed.
        return
    end
    ref.freed = true
    release(ref.rc)
    return
end

# array methods

storage(x::AbstractGPUArray) = error("Not implemented") # COV_EXCL_LINE

"""
    unsafe_free!(a::GPUArray)

Release the memory of an array for reuse by future allocations. This operation is
performed automatically by the GC when an array goes out of scope, but can be called
earlier to reduce pressure on the memory allocator.
"""
unsafe_free!(x::AbstractGPUArray) = unsafe_free!(storage(x))


# input/output

## serialization

using Serialization: AbstractSerializer, serialize_type

function Serialization.serialize(s::AbstractSerializer, @nospecialize(t::AbstractGPUArray))
    serialize_type(s, typeof(t))
    serialize(s, Array(t))
end

function Serialization.deserialize(s::AbstractSerializer, ::Type{T}) where T <: AbstractGPUArray
    A = deserialize(s)
    T(A)
end

## showing

struct ToArray end
Adapt.adapt_storage(::ToArray, xs::AbstractGPUArray) = convert(Array, xs)

# display: show is called on the materialised CPU copy, so no need to
# specialize the forwarders per element type / wrapper.
Base.print_array(io::IO, @nospecialize(X::AnyGPUArray)) =
    Base.print_array(io, adapt(ToArray(), X))

# show
Base._show_nonempty(io::IO, @nospecialize(X::AnyGPUArray), prefix::String) =
    Base._show_nonempty(io, adapt(ToArray(), X), prefix)
Base._show_empty(io::IO, @nospecialize(X::AnyGPUArray)) =
    Base._show_empty(io, adapt(ToArray(), X))
Base.show_vector(io::IO, @nospecialize(v::AnyGPUArray), args...) =
    Base.show_vector(io, adapt(ToArray(), v), args...)

## collect to CPU (discarding wrapper type)

collect_to_cpu(xs::AbstractArray) = collect(adapt(ToArray(), xs))
Base.collect(X::AnyGPUArray) = collect_to_cpu(X)


# memory copying

# expects the GPU array type to have linear `copyto!` methods (i.e. accepting an integer
# offset and length) from and to CPU arrays and between GPU arrays.

for (D, S) in ((AnyGPUArray, Array),
               (Array, AnyGPUArray),
               (AnyGPUArray, AnyGPUArray))
    @eval begin
        function Base.copyto!(dest::$D{<:Any, N}, rdest::UnitRange,
                              src::$S{<:Any, N}, ssrc::UnitRange) where {N}
            drange = CartesianIndices((rdest,))
            srange = CartesianIndices((ssrc,))
            copyto!(dest, drange, src, srange)
        end

        Base.copyto!(dest::$D, src::$S) = copyto!(dest, 1, src, 1, length(src))
    end
end

# kernel-based variant for copying between wrapped GPU arrays
@kernel function linear_copy_kernel!(dest, dstart, src, sstart, n)
    i = @index(Global, Linear)
    if i <= n
        @inbounds dest[dstart+i-1] = src[sstart+i-1]
    end
end

function Base.copyto!(dest::AnyGPUArray, dstart::Integer,
                      src::AnyGPUArray, sstart::Integer, n::Integer)
    n == 0 && return dest
    n < 0 && throw(ArgumentError(string("tried to copy n=", n, " elements, but n should be nonnegative")))
    destinds, srcinds = LinearIndices(dest), LinearIndices(src)
    (checkbounds(Bool, destinds, dstart) && checkbounds(Bool, destinds, dstart+n-1)) || throw(BoundsError(dest, dstart:dstart+n-1))
    (checkbounds(Bool, srcinds, sstart)  && checkbounds(Bool, srcinds, sstart+n-1))  || throw(BoundsError(src,  sstart:sstart+n-1))
    kernel = linear_copy_kernel!(get_backend(dest))
    kernel(dest, dstart, src, sstart, n; ndrange=n)
    return dest
end

# variants that materialize the GPU wrapper before copying from or to the CPU

function Base.copyto!(dest::Array, dstart::Integer,
                      src::WrappedGPUArray, sstart::Integer, n::Integer)
    n == 0 && return dest
    temp = similar(parent(src), n)
    copyto!(temp, 1, src, sstart, n)
    copyto!(dest, dstart, temp, 1, n)
    return dest
end

function Base.copyto!(dest::WrappedGPUArray, dstart::Integer,
                      src::Array, sstart::Integer, n::Integer)
    n == 0 && return dest
    temp = similar(parent(dest), n)
    copyto!(temp, 1, src, sstart, n)
    copyto!(dest, dstart, temp, 1, n)
    return dest
end

# variants that converts values on the CPU when there's a type mismatch
#
# we prefer to convert on the CPU where there's typically more memory / less memory pressure
# to quickly perform these very lightweight conversions

function Base.copyto!(dest::Array{T}, dstart::Integer,
                      src::AnyGPUArray{U}, sstart::Integer,
                      n::Integer) where {T,U}
    n == 0 && return dest
    temp = Vector{U}(undef, n)
    copyto!(temp, 1, src, sstart, n)
    copyto!(dest, dstart, temp, 1, n)
    return dest
end

function Base.copyto!(dest::AnyGPUArray{T}, dstart::Integer,
                      src::Array{U}, sstart::Integer, n::Integer) where {T,U}
    n == 0 && return dest
    temp = Vector{T}(undef, n)
    copyto!(temp, 1, src, sstart, n)
    copyto!(dest, dstart, temp, 1, n)
    return dest
end

## generalized blocks of heterogeneous memory

@kernel function cartesian_copy_kernel!(dest, dest_offsets, src, src_offsets)
    I = @index(Global, Cartesian)
    @inbounds dest[I + dest_offsets] = src[I + src_offsets]
end

function Base.copyto!(dest::AnyGPUArray{<:Any, N}, destcrange::CartesianIndices{N},
                      src::AnyGPUArray{<:Any, N}, srccrange::CartesianIndices{N}) where {N}
    shape = size(destcrange)
    if shape != size(srccrange)
        throw(ArgumentError("Ranges don't match their size. Found: $shape, $(size(srccrange))"))
    end
    len = length(destcrange)
    len == 0 && return dest

    # linear copy if we can
    if N == 1
        d_offset = first(destcrange)[1]
        s_offset = first(srccrange)[1]
        return copyto!(dest, d_offset, src, s_offset, len)
    end

    dest_offsets = first(destcrange) - oneunit(CartesianIndex{N})
    src_offsets = first(srccrange) - oneunit(CartesianIndex{N})
    kernel = cartesian_copy_kernel!(get_backend(dest))
    kernel(dest, dest_offsets, src, src_offsets; ndrange=shape)
    dest
end

for (dstTyp, srcTyp) in (AbstractGPUArray=>Array, Array=>AbstractGPUArray)
    @eval function Base.copyto!(dst::$dstTyp{T,N}, dstrange::CartesianIndices{N},
                                src::$srcTyp{T,N}, srcrange::CartesianIndices{N}) where {T,N}
        isempty(dstrange) && return dst
        if size(dstrange) != size(srcrange)
            throw(ArgumentError("source and destination must have same size (got $(size(srcrange)) and $(size(dstrange)))"))
        end
        len = length(dstrange)
        len == 0 && return dest

        # linear copy if we can
        if N == 1
            d_offset = first(dstrange)[1]
            s_offset = first(srcrange)[1]
            return copyto!(dst, d_offset, src, s_offset, len)
        end

        # figure out how many dimensions of the Cartesian ranges map onto contiguous memory
        # in both source and destination. we will copy these one by one as linear ranges.
        contiguous_dims = 1
        for dim in 2:N
            # a slice is broken up if the previous dimension didn't cover the entire range
            if axes(src, dim-1) == axes(srcrange, dim-1) &&
            axes(dst, dim-1) == axes(dstrange, dim-1)
                contiguous_dims = dim
            else
                break
            end
        end

        m = prod(size(dstrange)[1:contiguous_dims])       # inner, contiguous length
        n = prod(size(dstrange)[contiguous_dims+1:end])   # outer non-contiguous length
        @assert m*n == length(srcrange) == length(dstrange)

        # copy linear slices
        for i in 1:m:m*n
            srcoff = LinearIndices(src)[srcrange[i]]
            dstoff = LinearIndices(dst)[dstrange[i]]
            # TODO: Use asynchronous memory copies
            copyto!(dst, dstoff, src, srcoff, m)
        end

        dst
    end
end

## other

Base.copy(x::AbstractGPUArray) = error("Not implemented") # COV_EXCL_LINE

Base.deepcopy_internal(@nospecialize(x::AbstractGPUArray), ::IdDict) = copy(x)


# filtering

# TODO: filter!

# revert of JuliaLang/julia#31929
Base.filter(f, As::AbstractGPUArray) = As[map(f, As)::AbstractGPUArray{Bool}]

# appending

function Base.append!(a::AbstractGPUVector, items::AbstractVector)
    n = length(items)
    resize!(a, length(a) + n)
    copyto!(a, length(a) - n + 1, items, firstindex(items), n)
    return a
end

# this is needed because copyto! of most GPU arrays
# doesn't currently support Tuple sources
function Base.append!(a::AbstractGPUVector, @nospecialize(items::Tuple))
    append!(a, collect(items))
    return a
end

using Statistics

@testsuite "statistics" (AT, eltypes)->begin
    for ET in eltypes
        if !(ET in [Float16, Float32, Float64])
            continue
        end
        # Larger range for Float16 to avoid numerical instability
        range = ET == Float16 ? (ET(1):ET(100)) : ET

        @testset "std" begin
            @test compare(std, AT, rand(range, 10))
            @test compare(std, AT, rand(range, 10, 1, 2))
            @test compare(A -> std(A; corrected = true), AT, rand(range, 10, 1, 2))
            @test compare(A -> std(A; dims = 1), AT, rand(range, 10, 1, 2))
        end

        @testset "var" begin
            @test compare(var, AT, rand(range, 10))
            @test compare(var, AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; corrected = true), AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; dims = 1), AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; dims = [1]), AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; dims = (1,)), AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; dims = [2, 3]), AT, rand(range, 10, 1, 2))
            @test compare(A -> var(A; dims = (2, 3)), AT, rand(range, 10, 1, 2))
        end

        @testset "mean" begin
            @test compare(mean, AT, rand(range, 2, 2))
            @test compare(A -> mean(A; dims = 2), AT, rand(range, 2, 2))
            @test compare(A -> mean(A; dims = [1, 3]), AT, rand(range, 2, 2, 2))
            @test compare(A -> mean(sin, A), AT, rand(range, 2, 2))
            @test compare(A -> mean(sin, A; dims = 2), AT, rand(range, 2, 2))
            @test compare(A -> mean(sin, A; dims = [1, 3]), AT, rand(range, 2, 2, 2))
        end
    end

    for ET in eltypes
        # Doesn't work with ComplexF32 in oneAPI for some reason.
        if !(ET in [Float32, Float64, Float16, ComplexF64])
            continue
        end
        # Larger range for Float16 to avoid numerical instability
        range = ET == Float16 ? (ET(1):ET(100)) : ET

        @testset "cov" begin
            s = 100
            @test compare(cov, AT, rand(range, s))
            @test compare(cov, AT, rand(range, s, 2))
            @test compare(A -> cov(A; dims = 2), AT, rand(range, s, 2))
        end

        @testset "cor" begin
            s = 100
            @test compare(cor, AT, rand(range, s)) nans = true
            @test compare(cor, AT, rand(range, s, 2)) nans = true
            @test compare(A -> cor(A; dims = 2), AT, rand(range, s, 2)) nans = true
        end
    end
end

# GPUArrays.jl

GPUArrays is a package that provides reusable GPU array functionality for Julia's various
GPU backends. Think of it as the `AbstractArray` interface from Base, but for GPU array
types. It allows you to write generic julia code for all GPU platforms and implements common
algorithms for the GPU. Like Julia Base, this includes BLAS wrapper, FFTs, maps, broadcasts
and mapreduces. So when you inherit from GPUArrays and overload the interface correctly, you
will get a lot of functionality for free. This will allow to have multiple GPUArray
implementation for different purposes, while maximizing the ability to share code.

**This package is not intended for end users!** Instead, you should use one of the packages
that builds on GPUArrays.jl such as [CUDA](https://github.com/JuliaGPU/CUDA.jl), [AMDGPU](https://github.com/JuliaGPU/AMDGPU.jl), [OneAPI](https://github.com/JuliaGPU/oneAPI.jl), or [Metal](https://github.com/JuliaGPU/Metal.jl).

This documentation is meant for users who might wish to implement a version of GPUArrays for another GPU backend and will cover the features you will need
to implement, the functionality you gain by doing so, and the test suite that is available
to verify your implementation. GPUArrays.jl also provides a reference implementation of
these interfaces on the CPU: The `JLArray` array type uses Julia's parallel programming
functionality to simulate GPU execution, and will be used throughout this documentation to
illustrate functionality.

# Test suite

GPUArrays provides an extensive test suite that covers all of the functionality that should
be available after implementing the required interfaces. This test suite is part of this
package, but for dependency reasons it is not available when importing the package. Instead,
you should include the code from your `runtests.jl` as follows:

```julia
import GPUArrays
gpuarrays = pathof(GPUArrays)
gpuarrays_root = dirname(dirname(gpuarrays))
include(joinpath(gpuarrays_root, "test", "testsuite.jl"))
```

With this set-up, you can run the test suite like this:

```julia
TestSuite.test(MyGPUArrayType)
```
If you don't want to run the whole suite, you can also run parts of it:


```julia
T = JLArray
GPUArrays.allowscalar(false) # fail tests when slow indexing path into Array type is used.

TestSuite.test_gpuinterface(T) # interface functions like gpu_call, threadidx, etc
TestSuite.test_base(T) # basic functionality like launching a kernel on the GPU and Base operations
TestSuite.test_blas(T) # tests the blas interface
TestSuite.test_broadcasting(T) # tests the broadcasting implementation
TestSuite.test_construction(T) # tests all kinds of different ways of constructing the array
TestSuite.test_linalg(T) # linalg function tests
TestSuite.test_mapreduce(T) # mapreduce sum, etc
TestSuite.test_indexing(T) # indexing tests
TestSuite.test_random(T) # randomly constructed arrays
TestSuite.test_io(T)
```

# Interface

To extend the above functionality to a new array type, you should use the types and
implement the interfaces listed on this page. GPUArrays is designed around having two
different array types to represent a GPU array: one that exists only on the host, and
one that actually can be instantiated on the device (i.e. in kernels).
Device functionality is then handled by [KernelAbstractions.jl](https://github.com/JuliaGPU/KernelAbstractions.jl).

## Host abstractions

You should provide an array type that builds on the `AbstractGPUArray` supertype, such as:

```julia
mutable struct CustomArray{T, N} <: AbstractGPUArray{T, N}
    data::DataRef{Vector{UInt8}}
    offset::Int
    dims::Dims{N}
    ...
end

```

This will allow your defined type (in this case `JLArray`) to use the GPUArrays interface where available.
To be able to actually use the functionality that is defined for `AbstractGPUArray`s, you need to define the backend, like so:

```julia
import KernelAbstractions: Backend
struct CustomBackend <: KernelAbstractions.GPU
KernelAbstractions.get_backend(a::CA) where CA <: CustomArray = CustomBackend()
```

There are numerous examples of potential interfaces for GPUArrays, such as with [JLArrays](https://github.com/JuliaGPU/GPUArrays.jl/blob/master/lib/JLArrays/src/JLArrays.jl), [CuArrays](https://github.com/JuliaGPU/CUDA.jl/blob/master/src/gpuarrays.jl), and [ROCArrays](https://github.com/JuliaGPU/AMDGPU.jl/blob/master/src/gpuarrays.jl).

## Caching Allocator

```@docs
GPUArrays.@cached
GPUArrays.@uncached
```
